import { ComponentTypeResolver, DYNAMIC_COMPONENTS, JsonService, ConfigService, CONFIG_OPTIONS, CONFIG_PATH, MODULE_DATA_KEY, DataProviderService, isDataStorage, ModuleManager, RemoteDataProviderService, DialogService, DATA_PROVIDER, EventAggregatorService, RemoteMessagingService, DataStorageService, DATA_STORAGE, DEFAULT_DATA_STORAGE_KEY, MessageType, DIALOG_REF, FieldTypes, DIALOG_OVERLAY_CONTAINER, DIALOG_MESSAGE_COMPONENT, DIALOG_INPUT_COMPONENT, DIALOG_CONTENT_COMPONENT, DIALOG_CONTAINER, ErrorHandleService, ErrorHandler, MetaDataService, ModuleEventType, NavigationProvider, UrlCreatorService, AuthorizationService, AuthenticationService, UrlCreator, ValidationService, ShortcutService, FormTitleResolver, CommandProcessor, DEFAULT_LANG, NavigationService, USE_DEFAULT_LANG } from 'narik-infrastructure';
import { Injectable, Inject, Injector, ɵɵdefineInjectable, ɵɵinject, INJECTOR, InjectionToken, Optional, TemplateRef, Type, ApplicationRef, ComponentFactoryResolver, NgModuleRef, RendererFactory2, APP_INITIALIZER, NgModule, EventEmitter, ViewChild } from '@angular/core';
import { getNestedValue, isArray, toFilterFunction, isString, formatString, toDtoArray, isFunction, groupBy, replaceString, isObject, promiseSerial, ComponentLoaderHostDirective } from 'narik-common';
import { map, tap, merge, mergeMap as mergeMap$1, first as first$1, pluck, share } from 'rxjs/operators';
import { HttpClient, HTTP_INTERCEPTORS } from '@angular/common/http';
import { Observable } from 'rxjs/internal/Observable';
import { mergeMap } from 'rxjs/internal/operators/mergeMap';
import { of, forkJoin, empty, Observable as Observable$1, concat } from 'rxjs';
import { tap as tap$1 } from 'rxjs/internal/operators/tap';
import { ReplaySubject } from 'rxjs/internal/ReplaySubject';
import { ToastrService, ToastrModule } from 'ngx-toastr';
import { first } from 'rxjs/internal/operators/first';
import { of as of$1 } from 'rxjs/internal/observable/of';
import { TranslateService } from '@ngx-translate/core';
import { map as map$1 } from 'rxjs/internal/operators/map';
import { throwError } from 'rxjs/internal/observable/throwError';
import { catchError } from 'rxjs/internal/operators/catchError';
import { __decorate, __metadata } from 'tslib';
import { UUID } from 'angular2-uuid';
import { DOCUMENT } from '@angular/common';
import { filter } from 'rxjs/internal/operators/filter';
import { OverlayContainer } from '@angular/cdk/overlay';
import { take } from 'rxjs/internal/operators/take';
import { Subject } from 'rxjs/internal/Subject';
import { BehaviorSubject } from 'rxjs/internal/BehaviorSubject';
import { Validators } from '@angular/forms';
import { CustomValidators } from 'ngx-custom-validators';
import { EventManager } from '@angular/platform-browser';
import { PRIMARY_OUTLET, ActivatedRoute, Router } from '@angular/router';
import { forkJoin as forkJoin$1 } from 'rxjs/internal/observable/forkJoin';
import { state, style, transition, animate } from '@angular/animations';
import 'reflect-metadata';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikComponentTypeResolver extends ComponentTypeResolver {
    /**
     * @param {?} components
     */
    constructor(components) {
        super();
        this.components = [];
        this.components = [].concat.apply([], components);
    }
    /**
     * @param {?} key
     * @return {?}
     */
    resolveComponentType(key) {
        return this.components.filter((/**
         * @param {?} x
         * @return {?}
         */
        x => x.name === key || x["COMPONENT_NAME"] === key))[0];
    }
}
NarikComponentTypeResolver.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikComponentTypeResolver.ctorParameters = () => [
    { type: Array, decorators: [{ type: Inject, args: [DYNAMIC_COMPONENTS,] }] }
];
if (false) {
    /** @type {?} */
    NarikComponentTypeResolver.prototype.components;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikHttpService {
    /**
     * @param {?} httpClient
     * @param {?} injector
     */
    constructor(httpClient, injector) {
        this.httpClient = httpClient;
        this.injector = injector;
    }
    /**
     * @param {?} url
     * @return {?}
     */
    get(url) {
        return this.httpClient
            .get(url)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        result => this.extractData(result))));
    }
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    post(url, data) {
        return this.httpClient
            .post(url, data)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        result => this.extractData(result))));
    }
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    delete(url, data) {
        return this.httpClient.delete(url, data);
    }
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    put(url, data) {
        return this.httpClient.put(url, data);
    }
    /**
     * @private
     * @param {?} result
     * @return {?}
     */
    extractData(result) {
        if (result && result["@odata.context"]) {
            if (result["@odata.count"] || result["@odata.count"] === 0) {
                return {
                    count: result["@odata.count"],
                    result: result.value
                };
            }
            else if (result["@odata.null"]) {
                return null;
            }
            else {
                return ((/** @type {?} */ (result["@odata.context"]))).endsWith("$entity")
                    ? result
                    : result.hasOwnProperty("value")
                        ? result.value
                        : result;
            }
        }
        return result || result === 0 || result === false
            ? result.data || result
            : null;
    }
}
NarikHttpService.decorators = [
    { type: Injectable, args: [{
                providedIn: "root"
            },] }
];
/** @nocollapse */
NarikHttpService.ctorParameters = () => [
    { type: HttpClient },
    { type: Injector }
];
/** @nocollapse */ NarikHttpService.ɵprov = ɵɵdefineInjectable({ factory: function NarikHttpService_Factory() { return new NarikHttpService(ɵɵinject(HttpClient), ɵɵinject(INJECTOR)); }, token: NarikHttpService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikHttpService.prototype.httpClient;
    /**
     * @type {?}
     * @private
     */
    NarikHttpService.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikJsonService extends JsonService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        super();
        this.httpService = httpService;
        this.jsons = new Map();
    }
    /**
     * @param {?} path
     * @return {?}
     */
    getJson(path) {
        /** @type {?} */
        const jsonData = this.jsons.get(path);
        return jsonData
            ? of(jsonData)
            : this.httpService.get(path).pipe(mergeMap((/**
             * @param {?} x
             * @return {?}
             */
            x => this.applyExtends(path, x))), map((/**
             * @param {?} data
             * @return {?}
             */
            data => {
                delete data["extends"];
                delete data["imports"];
                delete data["variables"];
                delete data["removeItems"];
                return data;
            })), tap((/**
             * @param {?} x
             * @return {?}
             */
            x => {
                this.jsons.set(path, x);
            })));
    }
    /**
     * @private
     * @param {?} dataPath
     * @param {?} data
     * @return {?}
     */
    applyExtends(dataPath, data) {
        if (data && data.extends) {
            /** @type {?} */
            const extendsPath = this.resolvePath(dataPath, data.extends);
            return this.getJson(extendsPath).pipe(mergeMap((/**
             * @param {?} parentData
             * @return {?}
             */
            parentData => this.applyImports(dataPath, this.applyJsonExtends(parentData, data)))));
        }
        else {
            return this.applyImports(dataPath, data);
        }
    }
    /**
     * @private
     * @param {?} basePath
     * @param {?} path
     * @return {?}
     */
    resolvePath(basePath, path) {
        /** @type {?} */
        const stack = basePath.split("/");
        /** @type {?} */
        const parts = path.split("/");
        stack.pop();
        for (let i = 0; i < parts.length; i++) {
            if (parts[i] === ".") {
                continue;
            }
            if (parts[i] === "..") {
                stack.pop();
            }
            else {
                stack.push(parts[i]);
            }
        }
        return stack.join("/");
    }
    /**
     * @private
     * @param {?} dataPath
     * @param {?} data
     * @return {?}
     */
    applyImports(dataPath, data) {
        if (data && data.imports) {
            /** @type {?} */
            const loaders = [];
            for (const key in data.imports) {
                if (data.imports.hasOwnProperty(key)) {
                    /** @type {?} */
                    const element = data.imports[key];
                    /** @type {?} */
                    const importPath = this.resolvePath(dataPath, element);
                    loaders.push(this.getJson(importPath).pipe(map((/**
                     * @param {?} x
                     * @return {?}
                     */
                    x => {
                        return { key, data: x };
                    }))));
                }
            }
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            observer => {
                forkJoin(loaders).subscribe((/**
                 * @param {?} items
                 * @return {?}
                 */
                items => {
                    observer.next(this.applyVariables(this.applyJsonImports(data, items)));
                }));
            }));
        }
        else {
            return of(this.applyVariables(data));
        }
    }
    /**
     * @private
     * @param {?} json
     * @return {?}
     */
    isJSON(json) {
        if (json && json.constructor.name === "Object") {
            return true;
        }
        else {
            return false;
        }
    }
    /**
     * @private
     * @param {?} data
     * @return {?}
     */
    cloneJSON(data) {
        return this.applyJsonExtends({}, data);
    }
    /**
     * @private
     * @param {?} data
     * @param {?} removeItems
     * @return {?}
     */
    applyRemoves(data, removeItems) {
        if (removeItems) {
            this.applyJsonRemoves(data, removeItems);
        }
        return data;
    }
    /**
     * @private
     * @param {?} data
     * @param {?} removeItems
     * @return {?}
     */
    applyJsonRemoves(data, removeItems) {
        if (this.isJSON(data)) {
            for (const removeItem of removeItems) {
                if (removeItem.indexOf("[") >= 0) {
                    /** @type {?} */
                    const dataItemKey = removeItem.substr(0, removeItem.indexOf("["));
                    /** @type {?} */
                    const dataItem = getNestedValue(data, dataItemKey);
                    if (isArray(dataItem)) {
                        /** @type {?} */
                        let dataItemIndex = removeItem.substring(removeItem.indexOf("[") + 1, removeItem.lastIndexOf("]"));
                        if (!isNaN(+dataItemIndex)) {
                            dataItem.splice(+dataItemIndex, 1);
                        }
                        else {
                            dataItemIndex = dataItemIndex.replace(/'/g, '"');
                            /** @type {?} */
                            const filterFunction = toFilterFunction((/** @type {?} */ (JSON.parse(dataItemIndex))));
                            /** @type {?} */
                            const removedDataItems = dataItem.filter(filterFunction);
                            for (const removedDataItem of removedDataItems) {
                                /** @type {?} */
                                const dataItemPos = dataItem.indexOf(removedDataItem);
                                if (dataItemPos >= 0) {
                                    dataItem.splice(dataItemPos, 1);
                                }
                            }
                        }
                    }
                }
                else {
                    delete data[removeItem];
                }
            }
        }
        return data;
    }
    /**
     * @private
     * @param {?} data
     * @return {?}
     */
    applyVariables(data) {
        if (data && data.variables) {
            this.applyJsonVariables(data, data.variables);
        }
        return data;
    }
    /**
     * @private
     * @param {?} data
     * @param {?} variables
     * @return {?}
     */
    applyJsonVariables(data, variables) {
        if (this.isJSON(data)) {
            for (const key in data) {
                if (this.isJSON(data[key])) {
                    this.applyJsonVariables(data[key], variables);
                }
                else if (Array.isArray(data[key])) {
                    for (const item of data[key]) {
                        this.applyJsonVariables(item, variables);
                    }
                }
                else if (isString(data[key]) && data[key].startsWith("@")) {
                    if (variables[data[key]]) {
                        data[key] = variables[data[key]];
                    }
                }
            }
        }
        return data;
    }
    /**
     * @private
     * @param {?} data
     * @param {?} importedData
     * @return {?}
     */
    applyJsonImports(data, importedData) {
        if (this.isJSON(data)) {
            for (const key in data) {
                if (this.isJSON(data[key])) {
                    this.applyJsonImports(data[key], importedData);
                }
                else if (Array.isArray(data[key])) {
                    /** @type {?} */
                    let index = 0;
                    for (const item of data[key]) {
                        if (isString(item) && item.startsWith("$$")) {
                            data[key][index] = this.applyImportValue(item, importedData);
                        }
                        else {
                            this.applyJsonImports(item, importedData);
                        }
                        index++;
                    }
                }
                else if (isString(data[key]) && data[key].startsWith("$$")) {
                    data[key] = this.applyImportValue(data[key], importedData);
                }
            }
        }
        return data;
    }
    /**
     * @private
     * @param {?} expr
     * @param {?} importedData
     * @return {?}
     */
    applyImportValue(expr, importedData) {
        for (const importItem of importedData) {
            /** @type {?} */
            const itemKey = expr.substr(0, expr.indexOf("."));
            if (importItem.key === itemKey) {
                return importItem.data[expr.replace(itemKey + ".", "")];
            }
        }
        return expr;
    }
    /**
     * @private
     * @param {?} parentData
     * @param {?} data
     * @return {?}
     */
    applyJsonExtends(parentData, data) {
        this.applyRemoves(parentData, data.removeItems);
        /** @type {?} */
        let result = null;
        if (this.isJSON(data)) {
            result = {};
            if (this.isJSON(parentData)) {
                for (const key in parentData) {
                    if (this.isJSON(parentData[key]) || Array.isArray(parentData[key])) {
                        result[key] = this.cloneJSON(parentData[key]);
                    }
                    else {
                        result[key] = parentData[key];
                    }
                }
            }
            for (const key in data) {
                if (this.isJSON(data[key]) || Array.isArray(data[key])) {
                    result[key] = this.applyJsonExtends(result[key], data[key]);
                }
                else {
                    result[key] = data[key];
                }
            }
        }
        else if (Array.isArray(parentData) && Array.isArray(data)) {
            result = parentData;
            for (let i = 0; i < data.length; i++) {
                if (result.indexOf(data[i]) === -1) {
                    result[result.length] = data[i];
                }
            }
        }
        else {
            result = data;
        }
        return result;
    }
}
NarikJsonService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikJsonService.ctorParameters = () => [
    { type: NarikHttpService }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikJsonService.prototype.jsons;
    /**
     * @type {?}
     * @private
     */
    NarikJsonService.prototype.httpService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikConfigService extends ConfigService {
    /**
     * @param {?} httpService
     * @param {?} configOptions
     * @param {?} configPath
     */
    constructor(httpService, configOptions, configPath) {
        super();
        this.httpService = httpService;
        this.configOptions = configOptions;
        this.configPath = configPath;
        this.configData = {};
        this.configKeys = [];
        if (configOptions && configOptions.configFilePath) {
            this.configPath = configOptions.configFilePath;
        }
        this.configLoadedSubject = new ReplaySubject(1);
    }
    /**
     * @return {?}
     */
    get configLoaded() {
        return this.configLoadedSubject.asObservable();
    }
    /**
     * @return {?}
     */
    init() {
        return this.httpService
            .get(this.configPath +
            (this.configOptions &&
                this.configOptions.addTimeParameterToConfigFilePath
                ? "?t=" + new Date().getTime()
                : ""))
            .pipe(tap$1((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            this.configData = x;
            for (const key in x) {
                if (x.hasOwnProperty(key)) {
                    this.configKeys.push(key);
                }
            }
            this.configLoadedSubject.next(true);
        })))
            .toPromise();
    }
    /**
     * @template T
     * @param {?} key
     * @return {?}
     */
    getConfig(key) {
        return (/** @type {?} */ (this.configData[key]));
    }
    /**
     * @return {?}
     */
    getAllKeys() {
        return this.configKeys;
    }
}
NarikConfigService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikConfigService.ctorParameters = () => [
    { type: NarikHttpService },
    { type: undefined, decorators: [{ type: Inject, args: [CONFIG_OPTIONS,] }] },
    { type: String, decorators: [{ type: Inject, args: [CONFIG_PATH,] }] }
];
if (false) {
    /** @type {?} */
    NarikConfigService.prototype.configData;
    /** @type {?} */
    NarikConfigService.prototype.configKeys;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.configLoadedSubject;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.configOptions;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.configPath;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const COMPONENTS = [];
/** @type {?} */
const EXPORT_COMPONENTS = [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class NarikBaseDataProvider {
    /**
     * @param {?} injector
     */
    constructor(injector) {
        this.injector = injector;
        this.dayaKeyTemplate = "{0}_{1}";
        this.dataStreams = new Map();
    }
    /**
     * @protected
     * @param {?} dataInfo
     * @return {?}
     */
    getFullKey(dataInfo) {
        /** @type {?} */
        let moduleKey = dataInfo.moduleKey;
        if (!moduleKey) {
            moduleKey = this.injector.get(MODULE_DATA_KEY);
        }
        return formatString(this.dayaKeyTemplate, moduleKey, dataInfo.dataKey);
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getDataStream(dataInfo) {
        /** @type {?} */
        const fullKey = this.getFullKey(dataInfo);
        if (this.dataStreams.has(fullKey)) {
            return this.dataStreams.get(fullKey);
        }
        else {
            /** @type {?} */
            const dataSubject = new ReplaySubject(1);
            this.dataStreams.set(fullKey, dataSubject);
            /** @type {?} */
            const dataProviderService = this.injector.get(DataProviderService);
            dataProviderService
                .getData(dataInfo)
                .pipe(first())
                .subscribe((/**
             * @param {?} data
             * @return {?}
             */
            data => dataSubject.next(data)));
            return dataSubject.asObservable();
        }
    }
    /**
     * @param {?} dataInfo
     * @param {?} data
     * @return {?}
     */
    raiseDataStream(dataInfo, data) {
        /** @type {?} */
        const fullKey = this.getFullKey(dataInfo);
        if (this.dataStreams.has(fullKey)) {
            this.dataStreams.get(fullKey).next(data);
        }
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    dataChanged(dataInfo) {
        /** @type {?} */
        const dataInfoArray = isArray(dataInfo)
            ? (/** @type {?} */ (dataInfo))
            : [(/** @type {?} */ (dataInfo))];
        /** @type {?} */
        const loadAndRaiseDataStream = (/**
         * @return {?}
         */
        () => {
            for (const dataInfoItem of dataInfoArray) {
                /** @type {?} */
                const fullKey = this.getFullKey(dataInfoItem);
                if (this.dataStreams.has(fullKey)) {
                    /** @type {?} */
                    const dataStream = this.dataStreams.get(fullKey);
                    if (dataStream.observers.length) {
                        ((/** @type {?} */ (this))).getData(dataInfoItem).subscribe((/**
                         * @param {?} result
                         * @return {?}
                         */
                        result => {
                            dataStream.next(result);
                        }));
                    }
                }
            }
        });
        if (isDataStorage(this)) {
            /** @type {?} */
            const storage = (/** @type {?} */ (((/** @type {?} */ (this)))));
            storage.removeItems(dataInfoArray).subscribe((/**
             * @param {?} x
             * @return {?}
             */
            x => {
                loadAndRaiseDataStream();
            }));
        }
        else {
            loadAndRaiseDataStream();
        }
    }
}
if (false) {
    /** @type {?} */
    NarikBaseDataProvider.prototype.key;
    /** @type {?} */
    NarikBaseDataProvider.prototype.order;
    /** @type {?} */
    NarikBaseDataProvider.prototype.belongsInChain;
    /** @type {?} */
    NarikBaseDataProvider.prototype.dayaKeyTemplate;
    /**
     * @type {?}
     * @protected
     */
    NarikBaseDataProvider.prototype.dataStreams;
    /**
     * @type {?}
     * @private
     */
    NarikBaseDataProvider.prototype.injector;
    /**
     * @abstract
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataProvider.prototype.getData = function (dataInfo) { };
    /**
     * @abstract
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataProvider.prototype.isDataProviderFor = function (dataInfo) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikTranslateService {
    /**
     * @param {?} translateService
     * @param {?} http
     */
    constructor(translateService, http) {
        this.translateService = translateService;
        this.http = http;
    }
    /**
     * @param {?} key
     * @param {?=} interpolateParams
     * @return {?}
     */
    instant(key, interpolateParams) {
        if (isString(key) && key.indexOf("_") > 0) {
            /** @type {?} */
            const items = ((/** @type {?} */ (key))).split("_");
            return items
                .map((/**
             * @param {?} item
             * @return {?}
             */
            item => this.translateService.instant(item, interpolateParams)))
                .join(" ");
        }
        return this.translateService.instant(key, interpolateParams);
    }
    /**
     * @param {?} lang
     * @return {?}
     */
    use(lang) {
        return this.translateService.use(lang);
    }
    /**
     * @param {?} lang
     * @return {?}
     */
    setDefaultLang(lang) {
        this.translateService.setDefaultLang(lang);
    }
    /**
     * @param {?} item
     * @param {?=} reLoad
     * @return {?}
     */
    addTranslationItem(item, reLoad = false) {
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        (resolve, reject) => {
            /** @type {?} */
            const translateLoader = (/** @type {?} */ ((this.translateService.currentLoader)));
            translateLoader.addTranslationItem(item);
            if (reLoad) {
                this.translateService
                    .reloadLang(this.translateService.currentLang)
                    .subscribe((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => {
                    this.translateService.use(this.translateService.currentLang);
                    resolve(true);
                }));
            }
            else {
                /** @type {?} */
                const url = translateLoader.getTranslateFilePath(this.translateService.currentLang, item);
                this.http.get(url).subscribe((/**
                 * @param {?} result
                 * @return {?}
                 */
                result => {
                    this.translateService.setTranslation(this.translateService.currentLang, result, true);
                    resolve(true);
                }));
            }
        }));
    }
}
NarikTranslateService.decorators = [
    { type: Injectable, args: [{
                providedIn: "root"
            },] }
];
/** @nocollapse */
NarikTranslateService.ctorParameters = () => [
    { type: TranslateService },
    { type: HttpClient }
];
/** @nocollapse */ NarikTranslateService.ɵprov = ɵɵdefineInjectable({ factory: function NarikTranslateService_Factory() { return new NarikTranslateService(ɵɵinject(TranslateService), ɵɵinject(HttpClient)); }, token: NarikTranslateService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikTranslateService.prototype.translateService;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class StaticDataProvider extends NarikBaseDataProvider {
    /**
     * @param {?} injector
     * @param {?} moduleManager
     * @param {?} translateor
     */
    constructor(injector, moduleManager, translateor) {
        super(injector);
        this.moduleManager = moduleManager;
        this.translateor = translateor;
        this.key = "static";
        this.order = 0;
        this.belongsInChain = false;
        this.modulesStaticData = new Map();
        for (const module of this.moduleManager.modules.entriesArray()) {
            if (module.value.metaData) {
                this.addStaticData(module.key, module.value.metaData["staticData"]);
            }
        }
        this.moduleManager.modulesChanged.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            if (x.moduleInfo.metaData) {
                this.addStaticData(x.moduleKey, x.moduleInfo.metaData["staticData"]);
            }
        }));
    }
    /**
     * @private
     * @param {?} moduleKey
     * @param {?} staticData
     * @return {?}
     */
    addStaticData(moduleKey, staticData) {
        if (staticData && !this.modulesStaticData.has(moduleKey)) {
            this.modulesStaticData.set(moduleKey, staticData);
        }
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    isDataProviderFor(dataInfo) {
        return false;
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    getData(dataInfo) {
        /** @type {?} */
        const moduleData = this.modulesStaticData.get(dataInfo.moduleKey);
        if (moduleData) {
            /** @type {?} */
            const staticDataInfo = moduleData.get(dataInfo.dataKey);
            if (staticDataInfo && staticDataInfo.data) {
                /** @type {?} */
                const resultData = staticDataInfo.convertToDto === false
                    ? staticDataInfo.data
                    : toDtoArray(staticDataInfo.data);
                if (staticDataInfo.ignoreTranslate !== true) {
                    /** @type {?} */
                    const translateField = staticDataInfo.translateField || "title";
                    for (const item of resultData) {
                        item[translateField] = this.translateor.instant(item[translateField]);
                    }
                }
                return of$1(resultData);
            }
        }
        return of$1([]);
    }
}
StaticDataProvider.decorators = [
    { type: Injectable }
];
/** @nocollapse */
StaticDataProvider.ctorParameters = () => [
    { type: Injector },
    { type: ModuleManager },
    { type: NarikTranslateService }
];
if (false) {
    /** @type {?} */
    StaticDataProvider.prototype.key;
    /** @type {?} */
    StaticDataProvider.prototype.order;
    /** @type {?} */
    StaticDataProvider.prototype.belongsInChain;
    /**
     * @type {?}
     * @private
     */
    StaticDataProvider.prototype.modulesStaticData;
    /**
     * @type {?}
     * @private
     */
    StaticDataProvider.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    StaticDataProvider.prototype.translateor;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const LOCAL_STORAGE_VALIDITY_LEN = new InjectionToken("LOCAL_STORAGE_VALIDITY_LEN");
/** @type {?} */
const SESSION_STORAGE_VALIDITY_LEN = new InjectionToken("SESSION_STORAGE_VALIDITY_LEN");
/** @type {?} */
const MEMORY_STORAGE_VALIDITY_LEN = new InjectionToken("MEMORY_STORAGE_VALIDITY_LEN");

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class NarikBaseDataStorage extends NarikBaseDataProvider {
    constructor() {
        super(...arguments);
        this.validityLen = 0;
    }
    /**
     * @param {?} data
     * @param {?=} validityLen
     * @return {?}
     */
    compeleteStorageData(data, validityLen) {
        return {
            data: data,
            dataTime: new Date(),
            validityLen: validityLen
        };
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getData(dataInfo) {
        return this.getStorageModel(dataInfo).pipe(map$1((/**
         * @param {?} result
         * @return {?}
         */
        result => this.checkAndReturn(result))));
    }
    /**
     * @template T
     * @param {?} storageData
     * @return {?}
     */
    checkAndReturn(storageData) {
        if (storageData == null || storageData === undefined) {
            return null;
        }
        /** @type {?} */
        let result = storageData.data;
        if (storageData.dataTime && this.validityLen) {
            if (isString(storageData.dataTime)) {
                storageData.dataTime = new Date(storageData.dataTime);
            }
            /** @type {?} */
            const validTime = new Date(storageData.dataTime.getTime() +
                (storageData.validityLen || this.validityLen) * 60000);
            if (validTime < new Date()) {
                result = null;
            }
        }
        return result;
    }
    /**
     * @param {?} dataItems
     * @return {?}
     */
    applyValidity(dataItems) {
        /** @type {?} */
        const mustRemoveItems = [];
        for (const dataItem of dataItems) {
            this.getStorageModel(dataItem.dataInfo).subscribe((/**
             * @param {?} storageData
             * @return {?}
             */
            (storageData) => {
                if (storageData) {
                    if (isString(storageData.dataTime)) {
                        storageData.dataTime = new Date(storageData.dataTime);
                    }
                    if (storageData.dataTime < dataItem.validDate) {
                        mustRemoveItems.push(dataItem.dataInfo);
                    }
                }
            }));
        }
        if (mustRemoveItems.length !== 0) {
            this.removeItems(mustRemoveItems);
        }
    }
}
if (false) {
    /** @type {?} */
    NarikBaseDataStorage.prototype.validityLen;
    /**
     * @abstract
     * @return {?}
     */
    NarikBaseDataStorage.prototype.clear = function () { };
    /**
     * @abstract
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataStorage.prototype.getStorageModel = function (dataInfo) { };
    /**
     * @abstract
     * @param {?} items
     * @return {?}
     */
    NarikBaseDataStorage.prototype.removeItems = function (items) { };
    /**
     * @abstract
     * @param {?} dataItmes
     * @return {?}
     */
    NarikBaseDataStorage.prototype.addItem = function (dataItmes) { };
}
/**
 * @record
 */
function StorageModel() { }
if (false) {
    /** @type {?|undefined} */
    StorageModel.prototype.validityLen;
    /** @type {?|undefined} */
    StorageModel.prototype.dataTime;
    /** @type {?} */
    StorageModel.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LocalStorageDataProvider extends NarikBaseDataStorage {
    /**
     * @param {?} injector
     * @param {?} validityLen
     */
    constructor(injector, validityLen) {
        super(injector);
        this.key = "localStorage";
        this.order = 3;
        this.belongsInChain = true;
        this.validityLen = validityLen || 2 * 60;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getStorageModel(dataInfo) {
        /** @type {?} */
        const dataStorage = JSON.parse(localStorage.getItem(this.getFullKey(dataInfo)));
        return of$1(dataStorage);
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    isDataProviderFor(dataInfo) {
        return false;
    }
    /**
     * @param {?} dataItmes
     * @return {?}
     */
    addItem(dataItmes) {
        for (const data of dataItmes) {
            localStorage.setItem(this.getFullKey(data.dataInfo), JSON.stringify(this.compeleteStorageData(data.data, data.dataInfo.validityLen)));
            this.raiseDataStream(data.dataInfo, data.data);
        }
        return of$1(true);
    }
    /**
     * @return {?}
     */
    clear() {
        localStorage.clear();
        return of$1(true);
    }
    /**
     * @param {?} items
     * @return {?}
     */
    removeItems(items) {
        items.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            localStorage.removeItem(this.getFullKey(x));
        }));
        return of$1(true);
    }
}
LocalStorageDataProvider.decorators = [
    { type: Injectable }
];
/** @nocollapse */
LocalStorageDataProvider.ctorParameters = () => [
    { type: Injector },
    { type: Number, decorators: [{ type: Optional }, { type: Inject, args: [LOCAL_STORAGE_VALIDITY_LEN,] }] }
];
if (false) {
    /** @type {?} */
    LocalStorageDataProvider.prototype.key;
    /** @type {?} */
    LocalStorageDataProvider.prototype.order;
    /** @type {?} */
    LocalStorageDataProvider.prototype.belongsInChain;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MemoryDataProvider extends NarikBaseDataStorage {
    /**
     * @param {?} injector
     * @param {?} validityLen
     */
    constructor(injector, validityLen) {
        super(injector);
        this.key = "memory";
        this.order = 1;
        this.belongsInChain = true;
        this.storage = new Map();
        this.validityLen = validityLen || 2 * 60;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getStorageModel(dataInfo) {
        /** @type {?} */
        const dataStorage = (/** @type {?} */ (this.storage.get(this.getFullKey(dataInfo))));
        return of$1(dataStorage);
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    isDataProviderFor(dataInfo) {
        return false;
    }
    /**
     * @param {?} dataItmes
     * @return {?}
     */
    addItem(dataItmes) {
        for (const data of dataItmes) {
            /** @type {?} */
            const fullkey = this.getFullKey(data.dataInfo);
            this.storage.set(fullkey, this.compeleteStorageData(data.data, data.dataInfo.validityLen));
            this.raiseDataStream(data.dataInfo, data.data);
        }
        return of$1(true);
    }
    /**
     * @return {?}
     */
    clear() {
        this.storage.clear();
        return of$1(true);
    }
    /**
     * @param {?} items
     * @return {?}
     */
    removeItems(items) {
        items.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            this.storage.delete(this.getFullKey(x));
        }));
        return of$1(true);
    }
}
MemoryDataProvider.decorators = [
    { type: Injectable }
];
/** @nocollapse */
MemoryDataProvider.ctorParameters = () => [
    { type: Injector },
    { type: Number, decorators: [{ type: Optional }, { type: Inject, args: [MEMORY_STORAGE_VALIDITY_LEN,] }] }
];
if (false) {
    /** @type {?} */
    MemoryDataProvider.prototype.key;
    /** @type {?} */
    MemoryDataProvider.prototype.order;
    /** @type {?} */
    MemoryDataProvider.prototype.belongsInChain;
    /**
     * @type {?}
     * @private
     */
    MemoryDataProvider.prototype.storage;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class RemoteDataProvider extends NarikBaseDataProvider {
    /**
     * @param {?} injector
     * @param {?} remoteDataProvider
     */
    constructor(injector, remoteDataProvider) {
        super(injector);
        this.remoteDataProvider = remoteDataProvider;
        this.key = "remote";
        this.order = 5;
        this.belongsInChain = true;
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    isDataProviderFor(dataInfo) {
        return true;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getData(dataInfo) {
        return this.remoteDataProvider.getData(dataInfo);
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getDataStream(dataInfo) {
        return this.remoteDataProvider.getDataStream(dataInfo);
    }
}
RemoteDataProvider.decorators = [
    { type: Injectable }
];
/** @nocollapse */
RemoteDataProvider.ctorParameters = () => [
    { type: Injector },
    { type: RemoteDataProviderService }
];
if (false) {
    /** @type {?} */
    RemoteDataProvider.prototype.key;
    /** @type {?} */
    RemoteDataProvider.prototype.order;
    /** @type {?} */
    RemoteDataProvider.prototype.belongsInChain;
    /**
     * @type {?}
     * @private
     */
    RemoteDataProvider.prototype.remoteDataProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SessionStorageDataProvider extends NarikBaseDataStorage {
    /**
     * @param {?} injector
     * @param {?} validityLen
     */
    constructor(injector, validityLen) {
        super(injector);
        this.key = "sessionStorage";
        this.order = 2;
        this.supportAdd = true;
        this.belongsInChain = true;
        this.validityLen = validityLen || 2 * 60;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getStorageModel(dataInfo) {
        /** @type {?} */
        const dataStorage = JSON.parse(sessionStorage.getItem(this.getFullKey(dataInfo)));
        return of$1(dataStorage);
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    isDataProviderFor(dataInfo) {
        return false;
    }
    /**
     * @param {?} dataItmes
     * @return {?}
     */
    addItem(dataItmes) {
        for (const data of dataItmes) {
            sessionStorage.setItem(this.getFullKey(data.dataInfo), JSON.stringify(this.compeleteStorageData(data.data, data.dataInfo.validityLen)));
            this.raiseDataStream(data.dataInfo, data.data);
        }
        return of$1(true);
    }
    /**
     * @return {?}
     */
    clear() {
        sessionStorage.clear();
        return of$1(true);
    }
    /**
     * @param {?} items
     * @return {?}
     */
    removeItems(items) {
        items.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            sessionStorage.removeItem(this.getFullKey(x));
        }));
        return of$1(true);
    }
}
SessionStorageDataProvider.decorators = [
    { type: Injectable }
];
/** @nocollapse */
SessionStorageDataProvider.ctorParameters = () => [
    { type: Injector },
    { type: Number, decorators: [{ type: Optional }, { type: Inject, args: [SESSION_STORAGE_VALIDITY_LEN,] }] }
];
if (false) {
    /** @type {?} */
    SessionStorageDataProvider.prototype.key;
    /** @type {?} */
    SessionStorageDataProvider.prototype.order;
    /** @type {?} */
    SessionStorageDataProvider.prototype.supportAdd;
    /** @type {?} */
    SessionStorageDataProvider.prototype.belongsInChain;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class HttpErrorInterceptor {
    /**
     * @param {?} dialogService
     */
    constructor(dialogService) {
        this.dialogService = dialogService;
    }
    /**
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    intercept(request, next) {
        return next.handle(request).pipe(catchError((/**
         * @param {?} err
         * @return {?}
         */
        err => {
            if (err.status === 403) {
                this.dialogService.error("errors.STATUS_401");
            }
            if (err.status === 400) {
                if (err.error && err.error.errors) {
                    this.dialogService.error(err.error.errors);
                }
            }
            return throwError(err);
        })));
    }
}
HttpErrorInterceptor.decorators = [
    { type: Injectable }
];
/** @nocollapse */
HttpErrorInterceptor.ctorParameters = () => [
    { type: DialogService }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    HttpErrorInterceptor.prototype.dialogService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikDataProviderService extends DataProviderService {
    /**
     * @param {?} providers
     * @param {?} moduleManager
     * @param {?} injector
     * @param {?} eventAggregatorService
     * @param {?} remoteMessagingService
     */
    constructor(providers, moduleManager, injector, eventAggregatorService, remoteMessagingService) {
        super();
        this.moduleManager = moduleManager;
        this.injector = injector;
        this.eventAggregatorService = eventAggregatorService;
        this.remoteMessagingService = remoteMessagingService;
        this.dataProviders = new Map();
        this.modulesDataItems = new Map();
        this.modulesDafaultProviderKey = new Map();
        this.modulesDafaultOriginProviderKey = new Map();
        providers.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => this.dataProviders.set(x.key, x)));
        this.moduleManager.narikLoaded.subscribe((/**
         * @return {?}
         */
        () => {
            this.eventAggregatorService
                .listen("CLIENT_DATA_CHANGED")
                .pipe(merge(remoteMessagingService
                ? this.remoteMessagingService.listen("DATA-CHANGE")
                : empty()))
                .subscribe((/**
             * @param {?} dataInfo
             * @return {?}
             */
            (dataInfo) => {
                for (const provider of this.dataProviders.valuesArray()) {
                    if (!isDataStorage(provider)) {
                        provider.dataChanged(dataInfo);
                    }
                }
            }));
        }));
        for (const module of this.moduleManager.modules.entriesArray()) {
            if (module.value.metaData) {
                this.addDataItems(module.key, module.value.metaData);
            }
        }
        this.moduleManager.modulesChanged.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            if (x.moduleInfo.metaData) {
                this.addDataItems(x.moduleKey, x.moduleInfo.metaData);
            }
        }));
    }
    /**
     * @private
     * @param {?} moduleKey
     * @param {?} metaData
     * @return {?}
     */
    addDataItems(moduleKey, metaData) {
        if (metaData.dataInfo) {
            /** @type {?} */
            const dataInfo = metaData.dataInfo;
            if (dataInfo.defaultDataProvider) {
                this.modulesDafaultProviderKey.set(moduleKey, dataInfo.defaultDataProvider);
            }
            if (dataInfo.defaultOriginDataProvider) {
                this.modulesDafaultOriginProviderKey.set(moduleKey, dataInfo.defaultOriginDataProvider);
            }
        }
        if (!this.modulesDataItems.has(moduleKey)) {
            /** @type {?} */
            let dataItems = metaData["dataItems"];
            if (!dataItems) {
                dataItems = new Map();
            }
            this.modulesDataItems.set(moduleKey, dataItems);
        }
    }
    /**
     * @protected
     * @param {?} dataInfo
     * @param {?=} fromOrigin
     * @return {?}
     */
    tryToFindDataProviderKey(dataInfo, fromOrigin = false) {
        /** @type {?} */
        let dataProviderKey = null;
        /** @type {?} */
        const moduleKey = dataInfo.moduleKey
            ? dataInfo.moduleKey
            : this.injector.get(MODULE_DATA_KEY);
        if (this.modulesDataItems.has(moduleKey)) {
            if (this.modulesDataItems.get(moduleKey).get(dataInfo.dataKey)) {
                /** @type {?} */
                const dataProviderInformation = this.modulesDataItems
                    .get(moduleKey)
                    .get(dataInfo.dataKey);
                dataProviderKey = fromOrigin
                    ? dataProviderInformation.originDataProviderKey
                    : dataProviderInformation.dataProviderKey;
            }
        }
        if (!dataProviderKey &&
            !fromOrigin &&
            this.modulesDafaultProviderKey.has(moduleKey)) {
            dataProviderKey = this.modulesDafaultProviderKey.get(moduleKey);
        }
        if (!dataProviderKey &&
            fromOrigin &&
            this.modulesDafaultProviderKey.has(moduleKey)) {
            dataProviderKey = this.modulesDafaultOriginProviderKey.get(moduleKey);
        }
        if (!dataProviderKey) {
            /** @type {?} */
            const providers = this.dataProviders.valuesArray().sort((/**
             * @param {?} x
             * @return {?}
             */
            x => x.order));
            for (const x of providers) {
                if (x.isDataProviderFor(dataInfo)) {
                    return x.key;
                }
            }
        }
        return dataProviderKey;
    }
    /**
     * @protected
     * @template T
     * @param {?} dataInfo
     * @param {?} faultDataProvider
     * @return {?}
     */
    tryToFindFromOtherProvidersOnNotFound(dataInfo, faultDataProvider) {
        /** @type {?} */
        const faultDataProviders = [faultDataProvider];
        /** @type {?} */
        const otherDataProvidrs = this.dataProviders
            .valuesArray()
            .filter((/**
         * @param {?} dp
         * @return {?}
         */
        dp => dp.belongsInChain && dp.order > faultDataProvider.order))
            .sort((/**
         * @param {?} dp
         * @return {?}
         */
        dp => dp.order));
        /** @type {?} */
        let returnObs;
        if (otherDataProvidrs[0]) {
            returnObs = otherDataProvidrs[0].getData(dataInfo);
        }
        /** @type {?} */
        let index = 0;
        for (const item of otherDataProvidrs) {
            if (index !== 0) {
                returnObs = returnObs.pipe(mergeMap$1((/**
                 * @param {?} result
                 * @return {?}
                 */
                result => {
                    if (result != null && result !== undefined) {
                        return of$1(result);
                    }
                    else {
                        faultDataProviders.push(item);
                        return item.getData(dataInfo);
                    }
                })));
            }
            index++;
        }
        return returnObs.pipe(tap((/**
         * @param {?} result
         * @return {?}
         */
        result => {
            if (result != null && result !== undefined) {
                if (faultDataProviders.length !== 1) {
                    faultDataProviders.pop();
                }
                for (const item of faultDataProviders) {
                    if (isDataStorage(item)) {
                        item.addItem([
                            {
                                dataInfo: dataInfo,
                                data: result
                            }
                        ]);
                    }
                }
            }
        })));
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @param {?=} options
     * @return {?}
     */
    getData(dataInfo, options) {
        /** @type {?} */
        let dataProviderKey = dataInfo.dataProviderKey;
        if (options && options.fromOrigin) {
            dataProviderKey = dataInfo.originDataProviderKey;
            if (!dataProviderKey) {
                dataProviderKey = this.tryToFindDataProviderKey(dataInfo, true);
            }
        }
        if (!dataProviderKey) {
            dataProviderKey = this.tryToFindDataProviderKey(dataInfo);
        }
        if (dataProviderKey) {
            /** @type {?} */
            const dataProvider = this.dataProviders.get(dataProviderKey);
            return dataProvider.getData(dataInfo).pipe(mergeMap$1((/**
             * @param {?} x
             * @return {?}
             */
            x => {
                if (x != null && x !== undefined) {
                    if (options && options.fromOrigin) {
                        if (dataInfo.dataProviderKey &&
                            dataInfo.dataProviderKey !== dataProviderKey) {
                            /** @type {?} */
                            const originalDataProvider = this.dataProviders.get(dataInfo.dataProviderKey);
                            if (isDataStorage(originalDataProvider)) {
                                originalDataProvider.addItem([
                                    {
                                        dataInfo: dataInfo,
                                        data: x
                                    }
                                ]);
                            }
                        }
                    }
                    return of$1(x);
                }
                else {
                    return this.tryToFindFromOtherProvidersOnNotFound(dataInfo, dataProvider);
                }
            })), first$1());
        }
        else {
            return of$1(null);
        }
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @param {?=} options
     * @return {?}
     */
    getDataStream(dataInfo, options) {
        /** @type {?} */
        let dataProviderKey;
        if (options.fromOrigin) {
            dataProviderKey = dataInfo.originDataProviderKey;
            if (!dataProviderKey) {
                dataInfo.dataProviderKey = this.tryToFindDataProviderKey(dataInfo, true);
            }
        }
        if (dataProviderKey) {
            dataProviderKey = this.tryToFindDataProviderKey(dataInfo);
        }
        if (!dataProviderKey) {
            throw new Error("For dataStream the dataProviderKey must be set");
        }
        /** @type {?} */
        const dataProvider = this.dataProviders.get(dataProviderKey);
        return dataProvider.getDataStream(dataInfo);
    }
}
NarikDataProviderService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikDataProviderService.ctorParameters = () => [
    { type: Array, decorators: [{ type: Inject, args: [DATA_PROVIDER,] }] },
    { type: ModuleManager },
    { type: Injector },
    { type: EventAggregatorService },
    { type: RemoteMessagingService, decorators: [{ type: Optional }] }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.dataProviders;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.modulesDataItems;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.modulesDafaultProviderKey;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.modulesDafaultOriginProviderKey;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.remoteMessagingService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikDataStorageService extends DataStorageService {
    /**
     * @param {?} storages
     * @param {?} defaultStorageKey
     * @param {?} moduleManager
     * @param {?} eventAggregatorService
     * @param {?} remoteMessagingService
     */
    constructor(storages, defaultStorageKey, moduleManager, eventAggregatorService, remoteMessagingService) {
        super();
        this.defaultStorageKey = defaultStorageKey;
        this.moduleManager = moduleManager;
        this.eventAggregatorService = eventAggregatorService;
        this.remoteMessagingService = remoteMessagingService;
        this.dataStorages = new Map();
        storages.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => this.dataStorages.set(x.key, x)));
        this.moduleManager.narikLoaded.subscribe((/**
         * @return {?}
         */
        () => {
            this.eventAggregatorService
                .listen("CLIENT_DATA_CHANGED")
                .pipe(merge(remoteMessagingService
                ? this.remoteMessagingService.listen("DATA-CHANGE")
                : empty()))
                .subscribe((/**
             * @param {?} dataInfo
             * @return {?}
             */
            (dataInfo) => {
                for (const storage of this.dataStorages.valuesArray()) {
                    storage.dataChanged(dataInfo);
                }
            }));
            this.eventAggregatorService
                .listen("CLIENT_DATA_INVALIDATE")
                .pipe(merge(remoteMessagingService
                ? this.remoteMessagingService.listen("DATA-INVALIDATE")
                : empty()))
                .subscribe((/**
             * @param {?} dataItems
             * @return {?}
             */
            (dataItems) => {
                this.applyValidity(dataItems);
            }));
        }));
    }
    /**
     * @template T
     * @param {?} key
     * @param {?} dataInfo
     * @return {?}
     */
    getDataStream(key, dataInfo) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        /** @type {?} */
        const dataStorage = this.getStorage(key);
        return dataStorage.getDataStream(dataInfo);
    }
    /**
     * @template T
     * @param {?} key
     * @param {?} dataInfo
     * @return {?}
     */
    getData(key, dataInfo) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.getStorage(key).getData(dataInfo);
    }
    /**
     * @param {?} key
     * @return {?}
     */
    clear(key) {
        this.checkKey(key);
        return this.getStorage(key).clear();
    }
    /**
     * @param {?} key
     * @param {?} items
     * @return {?}
     */
    removeItems(key, items) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.getStorage(key).removeItems(items);
    }
    /**
     * @param {?} key
     * @param {?} dataItmes
     * @return {?}
     */
    addData(key, dataItmes) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.getStorage(key).addItem(dataItmes);
    }
    /**
     * @private
     * @param {?} key
     * @return {?}
     */
    getStorage(key) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.dataStorages.get(key);
    }
    /**
     * @param {?} dataItems
     * @return {?}
     */
    applyValidity(dataItems) {
        for (const storage of this.dataStorages.valuesArray()) {
            storage.applyValidity(dataItems);
        }
    }
    /**
     * @private
     * @param {?} key
     * @return {?}
     */
    checkKey(key) {
        if (!key) {
            throw new Error("You must specify storage  key. Either by DEFAULT_DATA_STORAGE_KEY or send it  with method parameter");
        }
    }
}
NarikDataStorageService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikDataStorageService.ctorParameters = () => [
    { type: Array, decorators: [{ type: Inject, args: [DATA_STORAGE,] }] },
    { type: String, decorators: [{ type: Optional }, { type: Inject, args: [DEFAULT_DATA_STORAGE_KEY,] }] },
    { type: ModuleManager },
    { type: EventAggregatorService },
    { type: RemoteMessagingService, decorators: [{ type: Optional }] }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.dataStorages;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.defaultStorageKey;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.remoteMessagingService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AppInjector {
}
AppInjector.injector = undefined;
if (false) {
    /** @type {?} */
    AppInjector.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 * @param {?} token
 * @param {?=} notFoundValue
 * @param {?=} flags
 * @return {?}
 */
function NarikInject(token, notFoundValue = null, flags) {
    return (/**
     * @param {?} target
     * @param {?} key
     * @return {?}
     */
    function (target, key) {
        /** @type {?} */
        const prev = Object.getOwnPropertyDescriptor(target, key);
        /** @type {?} */
        const getter = (/**
         * @return {?}
         */
        function () {
            if (this["$$$Inject_" + token.toString()]) {
                return this["$$$Inject_" + token.toString()];
            }
            /** @type {?} */
            let localInjector = this.injector || this["$$$_Injector"];
            if (!localInjector) {
                for (const filedKey in this) {
                    if (this.hasOwnProperty(filedKey)) {
                        if (this[filedKey] instanceof Injector ||
                            (this[filedKey] &&
                                this[filedKey].constructor.name === "Injector_")) {
                            localInjector = this[filedKey];
                            this["$$$_Injector"] = localInjector;
                        }
                    }
                }
            }
            if (!localInjector) {
                console.warn("Could not find local Injector in  (" +
                    target.constructor.name +
                    "), use root injector instead!");
            }
            else {
                if (localInjector.constructor.name === "StaticInjector" &&
                    localInjector.parent) {
                    localInjector = localInjector.parent;
                }
            }
            /** @type {?} */
            const value = (localInjector || AppInjector.injector).get(token, notFoundValue, flags);
            this["$$$" + token.toString()] = value;
            return value;
        });
        Object.defineProperty(target, key, {
            get: getter,
            enumerable: prev == null ? true : prev.enumerable,
            configurable: prev == null ? true : prev.configurable
        });
    });
}
/**
 * @template T
 * @param {?} token
 * @param {?=} notFoundValue
 * @param {?=} flags
 * @return {?}
 */
function NarikGlobalInject(token, notFoundValue = null, flags) {
    return (/**
     * @param {?} target
     * @param {?} key
     * @return {?}
     */
    function (target, key) {
        /** @type {?} */
        const prev = Object.getOwnPropertyDescriptor(target, key);
        /** @type {?} */
        const getter = (/**
         * @return {?}
         */
        function () {
            if (this["$$$Inject_" + token.toString()]) {
                return this["$$$Inject_" + token.toString()];
            }
            /** @type {?} */
            const localInjectors = this.injectors;
            if (!localInjectors) {
                console.warn("Could not find local Injectors in  (" +
                    target.constructor.name +
                    ")!");
            }
            else {
                for (let i = localInjectors.length - 1; i >= 0; --i) {
                    /** @type {?} */
                    const injector = localInjectors[i];
                    /** @type {?} */
                    const value = injector.get(token, notFoundValue, flags);
                    this["$$$" + token.toString()] = value;
                    return value;
                }
                return undefined;
            }
        });
        Object.defineProperty(target, key, {
            get: getter,
            enumerable: prev == null ? true : prev.enumerable,
            configurable: prev == null ? true : prev.configurable
        });
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikDialogService extends DialogService {
    // componentFactories = new Map<
    //   Type<any>,
    //   {
    //     factory: ComponentFactory<any>;
    //     module?: NgModuleRef<any>;
    //   }
    // >();
    /**
     * @param {?} injector
     * @param {?} dialogOverlayContainerType
     * @param {?} applicationRef
     * @param {?} componentFactoryResolver
     * @param {?} eventAggregatorService
     * @param {?} moduleManager
     * @param {?} moduleRef
     * @param {?} document
     */
    constructor(injector, dialogOverlayContainerType, applicationRef, componentFactoryResolver, eventAggregatorService, moduleManager, moduleRef, document) {
        super();
        this.injector = injector;
        this.dialogOverlayContainerType = dialogOverlayContainerType;
        this.applicationRef = applicationRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.eventAggregatorService = eventAggregatorService;
        this.moduleManager = moduleManager;
        this.document = document;
        this.openDialogs = new Map();
        this.injectors = [];
        this.nextUniqueId = 1;
        this.registerModule(moduleRef, componentFactoryResolver, injector);
        this.moduleManager.narikLoaded.subscribe((/**
         * @return {?}
         */
        () => {
            this.eventAggregatorService
                .listen("MODULE_LOAD_COMPLETELY")
                .subscribe((/**
             * @param {?} module
             * @return {?}
             */
            (module) => {
                if (module.moduleInfo && module.moduleInfo.module) {
                    this.registerModule(module.moduleInfo.module, module.moduleInfo.module.componentFactoryResolver, module.moduleInfo.module.injector);
                }
            }));
        }));
    }
    /**
     * @private
     * @param {?} moduleRef
     * @param {?} componentFactoryResolver
     * @param {?} injector
     * @return {?}
     */
    registerModule(moduleRef, componentFactoryResolver, injector) {
        // const factories = componentFactoryResolver["_factories"].entriesArray();
        // for (const factory of factories) {
        //   this.componentFactories.set(factory.key, {
        //     factory: factory.value,
        //     module: moduleRef
        //   });
        // }
        if (injector) {
            this.injectors.push(injector);
        }
    }
    /**
     * @return {?}
     */
    activeDialogId() {
        /** @type {?} */
        const itemKeys = this.openDialogs.entriesArray();
        if (itemKeys.length > 0) {
            return itemKeys[itemKeys.length - 1].key;
        }
        return undefined;
    }
    /**
     * @param {?} el
     * @return {?}
     */
    isElementInActiveDialog(el) {
        /** @type {?} */
        const activeDialogId = this.activeDialogId();
        if (!activeDialogId) {
            return true;
        }
        /** @type {?} */
        const parent = el.nativeElement.closest(`[narik-dialog-id="${activeDialogId}"]`);
        return !!parent;
    }
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} options
     * @return {?}
     */
    error(message, title, options) {
        this.showMessage(message, title, MessageType.Error, options);
    }
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} type
     * @param {?=} options
     * @return {?}
     */
    showMessage(message, title, type, options) {
        if (isArray(message)) {
            message = ((/** @type {?} */ (message)))
                .map((/**
             * @param {?} x
             * @return {?}
             */
            x => this.translateService.instant(x)))
                .join(" ");
        }
        else if (isString(message)) {
            message = this.translateService.instant(message);
        }
        else {
            message = Object.keys(message)
                .map((/**
             * @param {?} x
             * @return {?}
             */
            x => this.translateService.instant(message[x])))
                .join(" ");
        }
        type = type || MessageType.Success;
        switch (type) {
            case MessageType.Success: {
                this.toastrService.success((/** @type {?} */ (message)), title, options);
                break;
            }
            case MessageType.Info: {
                this.toastrService.info((/** @type {?} */ (message)), title, options);
                break;
            }
            case MessageType.Warn: {
                this.toastrService.warning((/** @type {?} */ (message)), title, options);
                break;
            }
            case MessageType.Error: {
                this.toastrService.error((/** @type {?} */ (message)), title, options);
                break;
            }
            default:
                this.toastrService.success((/** @type {?} */ (message)), title, options);
        }
    }
    /**
     * @template T
     * @param {?} content
     * @param {?=} title
     * @param {?=} data
     * @param {?=} actions
     * @param {?=} options
     * @param {?=} validateOnClose
     * @param {?=} onClose
     * @param {?=} providers
     * @return {?}
     */
    showDialog(content, title, data, actions, options, validateOnClose, onClose, providers) {
        options = options || {};
        /** @type {?} */
        const containers = this.createDialogContainer(options, actions, title);
        /** @type {?} */
        const dialogContainerRef = containers.container;
        /** @type {?} */
        const dialogOverlayContainerRef = containers.overLaycontainer;
        /** @type {?} */
        const result = new NarikDialogRef("dialog-" + UUID.UUID(), null);
        /** @type {?} */
        const renderer = this.rendererFactory.createRenderer(null, null);
        renderer.setAttribute(dialogContainerRef.location.nativeElement, "narik-dialog-id", result.id);
        result.container = dialogContainerRef.instance;
        if (content instanceof TemplateRef) {
            /** @type {?} */
            const dialogContent = dialogContainerRef.instance.contentContainerRef.createEmbeddedView(content);
        }
        else if (content instanceof Type) {
            // let factoryModule = this.componentFactories.get(content);
            // if (!factoryModule) {
            //   factoryModule = {
            //     factory: this.componentFactoryResolver.resolveComponentFactory(
            //       content as Type<T>
            //     )
            //   };
            // }
            /** @type {?} */
            const factory = this.componentFactoryResolver.resolveComponentFactory((/** @type {?} */ (content)));
            providers = providers || [];
            providers.push({ provide: DIALOG_REF, useValue: result });
            /** @type {?} */
            const localInjector = Injector.create(providers, this.injector);
            /** @type {?} */
            const dialogContent = dialogContainerRef.instance.contentContainerRef.createComponent(factory, undefined, localInjector);
            result.componentInstance = dialogContent.instance;
            if (data) {
                for (const key in data) {
                    if (data.hasOwnProperty(key)) {
                        /** @type {?} */
                        const element = data[key];
                        dialogContent.instance[key] = element;
                    }
                }
            }
        }
        result.element = dialogOverlayContainerRef.location.nativeElement;
        /** @type {?} */
        const overlayContainer = this.injector.get(OverlayContainer, undefined);
        if (overlayContainer) {
            /** @type {?} */
            const host = overlayContainer.getContainerElement();
            /** @type {?} */
            const pane = this.document.createElement("div");
            pane.id = `cdk-overlay-dialog-${this.nextUniqueId++}`;
            pane.classList.add("cdk-overlay-pane");
            host.appendChild(pane);
            pane.appendChild(dialogOverlayContainerRef.location.nativeElement);
        }
        else {
            this.document.body.appendChild(dialogOverlayContainerRef.location.nativeElement);
        }
        setTimeout((/**
         * @return {?}
         */
        () => {
            dialogContainerRef.instance.isOpen = true;
        }), 100);
        dialogOverlayContainerRef.instance.dialogRef = result;
        dialogContainerRef.instance.dialogRef = result;
        result.dialogOverlayContainerRef = dialogOverlayContainerRef;
        this.openDialogs.set(result.id, result);
        if (onClose) {
            result.closed.then((/**
             * @param {?} x
             * @return {?}
             */
            x => {
                onClose(x);
            }));
        }
        result.events
            .pipe(filter((/**
         * @param {?} x
         * @return {?}
         */
        x => x.eventType === "CLOSE_REQUEST")))
            .subscribe((/**
         * @param {?} e
         * @return {?}
         */
        (e) => {
            if (result.componentInstance &&
                isFunction(((/** @type {?} */ (result.componentInstance))).onCloseRequest)) {
                ((/** @type {?} */ (result.componentInstance))).onCloseRequest(e);
            }
            if (validateOnClose) {
                /** @type {?} */
                const validateResult = validateOnClose(e.eventData);
                if (validateResult instanceof Promise) {
                    ((/** @type {?} */ (validateResult))).then((/**
                     * @param {?} x
                     * @return {?}
                     */
                    x => {
                        if (x) {
                            this.close(result, e.eventData, e.eventSource);
                        }
                    }));
                }
                else if (validateResult === true) {
                    this.close(result, e.eventData, e.eventSource);
                }
            }
            else {
                this.close(result, e.eventData, e.eventSource);
            }
        }));
        return result;
    }
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} actions
     * @param {?=} onResult
     * @return {?}
     */
    showConfirm(message, title, actions, onResult) {
        return this.showDialog(this.messageComponent, title, {
            message: message
        }, actions || [...DialogActions.yes_no], undefined, undefined, onResult);
    }
    /**
     * @param {?} message
     * @param {?=} title
     * @return {?}
     */
    showMessageBox(message, title) {
        return this.showDialog(this.messageComponent, title, {
            message: message
        }, [DialogActions.ok]);
    }
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} fields
     * @param {?=} entity
     * @param {?=} onResult
     * @param {?=} actions
     * @param {?=} options
     * @return {?}
     */
    showInput(message, title, fields, entity, onResult, actions, options) {
        /** @type {?} */
        const dialogRef = this.showDialog(this.inputComponent, title, {
            message: message,
            fields: fields,
            entity: entity
        }, actions || [...DialogActions.ok_cancel], options || {
            showBackdrop: true,
            disableAutoClose: true
        }, undefined, onResult);
        dialogRef.dialogResultTransformer = (/**
         * @param {?} dr
         * @return {?}
         */
        (dr) => {
            return {
                componentInstance: dr.componentInstance,
                data: dr.componentInstance.entity,
                dialogResult: dr.dialogResult
            };
        });
        return dialogRef;
    }
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} placeHolder
     * @param {?=} fieldType
     * @param {?=} defaultValue
     * @param {?=} onResult
     * @param {?=} actions
     * @param {?=} options
     * @return {?}
     */
    showTextInput(message, title, placeHolder, fieldType, defaultValue, onResult, actions, options) {
        return this.showInput(message, title, [
            {
                name: "input",
                fieldType: fieldType || FieldTypes.Text,
                options: {
                    plaveHolder: placeHolder
                }
            }
        ], {
            input: defaultValue
        }, onResult, actions, options);
    }
    /**
     * @param {?} content
     * @param {?=} title
     * @return {?}
     */
    showContent(content, title) {
        return this.showDialog(this.contentComponent, title, {
            content: content
        }, [DialogActions.ok]);
    }
    /**
     * @param {?=} force
     * @return {?}
     */
    closeAll(force) {
        for (const dialog of this.openDialogs.valuesArray()) {
            dialog.close();
        }
    }
    /**
     * @param {?} dialog
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    close(dialog, dialogResult, eventSource) {
        /** @type {?} */
        let _dialog;
        if (isString(dialog)) {
            _dialog = this.openDialogs.get((/** @type {?} */ (dialog)));
        }
        else {
            _dialog = (/** @type {?} */ (dialog));
        }
        if (_dialog.container.closeAnimationCompleted) {
            _dialog.container.closeAnimationCompleted.pipe(take(1)).subscribe((/**
             * @param {?} x
             * @return {?}
             */
            x => {
                this.doClose(_dialog, dialogResult, eventSource);
            }));
            _dialog.container.isOpen = false;
        }
        else {
            this.doClose(_dialog, dialogResult, eventSource);
        }
    }
    /**
     * @private
     * @param {?} _dialog
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    doClose(_dialog, dialogResult, eventSource) {
        _dialog.events.next({
            eventType: "CLOSED",
            eventData: dialogResult,
            eventSource: eventSource
        });
        /** @type {?} */
        const parentElement = ((/** @type {?} */ (_dialog.element))).parentElement || this.document.body;
        parentElement.removeChild(_dialog.element);
        this.openDialogs.delete(_dialog.id);
    }
    /**
     * @private
     * @param {?} options
     * @param {?} actions
     * @param {?} title
     * @return {?}
     */
    createDialogContainer(options, actions, title) {
        /** @type {?} */
        const overlayRef = this.createOverlay(options);
        /** @type {?} */
        const factory = this.componentFactoryResolver.resolveComponentFactory(this.dialogContainerType);
        /** @type {?} */
        const containerRef = overlayRef.instance.contentContainerRef.createComponent(factory);
        containerRef.instance.options = options || {};
        containerRef.instance.title = title;
        containerRef.instance.actions = actions;
        return {
            overLaycontainer: overlayRef,
            container: containerRef
        };
    }
    /**
     * @param {?} options
     * @return {?}
     */
    createOverlay(options) {
        /** @type {?} */
        const overlayFactory = this.componentFactoryResolver.resolveComponentFactory(this.dialogOverlayContainerType);
        /** @type {?} */
        const componentRef = overlayFactory.create(this.injector);
        this.applicationRef.attachView(componentRef.hostView);
        componentRef.instance.options = options || {};
        return componentRef;
    }
}
NarikDialogService.decorators = [
    { type: Injectable, args: [{
                providedIn: "root"
            },] }
];
/** @nocollapse */
NarikDialogService.ctorParameters = () => [
    { type: Injector },
    { type: Type, decorators: [{ type: Inject, args: [DIALOG_OVERLAY_CONTAINER,] }] },
    { type: ApplicationRef },
    { type: ComponentFactoryResolver },
    { type: EventAggregatorService },
    { type: ModuleManager },
    { type: NgModuleRef },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
/** @nocollapse */ NarikDialogService.ɵprov = ɵɵdefineInjectable({ factory: function NarikDialogService_Factory() { return new NarikDialogService(ɵɵinject(INJECTOR), ɵɵinject(DIALOG_OVERLAY_CONTAINER), ɵɵinject(ApplicationRef), ɵɵinject(ComponentFactoryResolver), ɵɵinject(EventAggregatorService), ɵɵinject(ModuleManager), ɵɵinject(NgModuleRef), ɵɵinject(DOCUMENT)); }, token: NarikDialogService, providedIn: "root" });
__decorate([
    NarikInject(ToastrService),
    __metadata("design:type", ToastrService)
], NarikDialogService.prototype, "toastrService", void 0);
__decorate([
    NarikInject(TranslateService),
    __metadata("design:type", TranslateService)
], NarikDialogService.prototype, "translateService", void 0);
__decorate([
    NarikGlobalInject(DIALOG_MESSAGE_COMPONENT),
    __metadata("design:type", Type)
], NarikDialogService.prototype, "messageComponent", void 0);
__decorate([
    NarikGlobalInject(DIALOG_INPUT_COMPONENT),
    __metadata("design:type", Type)
], NarikDialogService.prototype, "inputComponent", void 0);
__decorate([
    NarikInject(DIALOG_CONTENT_COMPONENT),
    __metadata("design:type", Type)
], NarikDialogService.prototype, "contentComponent", void 0);
__decorate([
    NarikGlobalInject(DIALOG_CONTAINER),
    __metadata("design:type", Type)
], NarikDialogService.prototype, "dialogContainerType", void 0);
__decorate([
    NarikInject(RendererFactory2),
    __metadata("design:type", RendererFactory2)
], NarikDialogService.prototype, "rendererFactory", void 0);
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.openDialogs;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.injectors;
    /** @type {?} */
    NarikDialogService.prototype.nextUniqueId;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.toastrService;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.translateService;
    /** @type {?} */
    NarikDialogService.prototype.messageComponent;
    /** @type {?} */
    NarikDialogService.prototype.inputComponent;
    /** @type {?} */
    NarikDialogService.prototype.contentComponent;
    /** @type {?} */
    NarikDialogService.prototype.dialogContainerType;
    /** @type {?} */
    NarikDialogService.prototype.rendererFactory;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.dialogOverlayContainerType;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.applicationRef;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.document;
}
/**
 * @template T
 */
class NarikDialogRef {
    /**
     * @param {?} id
     * @param {?} componentInstance
     */
    constructor(id, componentInstance) {
        this.eventSubject = new ReplaySubject(10);
        this.id = id;
        this.componentInstance = componentInstance;
        this._closed = new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        (resolve, reject) => {
            this.events
                .pipe(filter((/**
             * @param {?} x
             * @return {?}
             */
            x => x.eventType === "CLOSED")), first())
                .subscribe((/**
             * @param {?} e
             * @return {?}
             */
            (e) => {
                resolve(this.dialogResultTransformer
                    ? this.dialogResultTransformer(e.eventData)
                    : e.eventData);
                if (this.dialogOverlayContainerRef) {
                    this.dialogOverlayContainerRef.destroy();
                }
            }));
        }));
    }
    /**
     * @return {?}
     */
    get closed() {
        return this._closed;
    }
    /**
     * @return {?}
     */
    get events() {
        return this.eventSubject;
    }
    /**
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    close(dialogResult, eventSource) {
        this.eventSubject.next({
            eventType: "CLOSE_REQUEST",
            eventData: dialogResult,
            eventSource: eventSource
        });
    }
}
if (false) {
    /** @type {?} */
    NarikDialogRef.prototype._closed;
    /** @type {?} */
    NarikDialogRef.prototype.dialogResultTransformer;
    /** @type {?} */
    NarikDialogRef.prototype.eventSubject;
    /** @type {?} */
    NarikDialogRef.prototype.id;
    /** @type {?} */
    NarikDialogRef.prototype.componentInstance;
    /** @type {?} */
    NarikDialogRef.prototype.container;
    /** @type {?} */
    NarikDialogRef.prototype.dialogOverlayContainerRef;
    /** @type {?} */
    NarikDialogRef.prototype.element;
}
class DialogActions {
}
DialogActions.ok = {
    label: "ok",
    dialogResult: "ok"
};
DialogActions.cancel = {
    label: "cancel",
    dialogResult: "cancel"
};
DialogActions.yes = {
    label: "yes",
    dialogResult: "yes"
};
DialogActions.no = {
    label: "no",
    dialogResult: "no"
};
DialogActions.ok_cancel = [DialogActions.ok, DialogActions.cancel];
DialogActions.yes_no = [DialogActions.yes, DialogActions.no];
if (false) {
    /** @type {?} */
    DialogActions.ok;
    /** @type {?} */
    DialogActions.cancel;
    /** @type {?} */
    DialogActions.yes;
    /** @type {?} */
    DialogActions.no;
    /** @type {?} */
    DialogActions.ok_cancel;
    /** @type {?} */
    DialogActions.yes_no;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikErrorHandleService extends ErrorHandleService {
    /**
     * @param {?} handles
     */
    constructor(handles) {
        super();
        this.errorHandlers = new Map();
        /** @type {?} */
        const data = groupBy(handles, "key");
        data.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => this.errorHandlers.set(x.key, x.value)));
    }
    /**
     * @param {?} errorTypeKey
     * @param {?} err
     * @return {?}
     */
    HandleError(errorTypeKey, err) {
        /** @type {?} */
        const handlers = this.errorHandlers
            .get(errorTypeKey)
            .sort((/**
         * @param {?} x
         * @return {?}
         */
        x => x.order));
        /** @type {?} */
        let handled = false;
        for (const x of handlers) {
            handled = x.HandleError(err);
            if (handled) {
                return true;
            }
        }
        return handled;
    }
}
NarikErrorHandleService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikErrorHandleService.ctorParameters = () => [
    { type: Array, decorators: [{ type: Inject, args: [ErrorHandler,] }] }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikErrorHandleService.prototype.errorHandlers;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikEventAggregatorService extends EventAggregatorService {
    /**
     * @param {?} metadataService
     */
    constructor(metadataService) {
        super();
        this.metadataService = metadataService;
        this.eventsInfo = new Map();
        this.subjects = new Map();
        /** @type {?} */
        const metaDataItems = this.metadataService.getAllMetaData().valuesArray();
        for (const metaData of metaDataItems) {
            this.addMetaDataEvents(metaData);
        }
        this.metadataService.metaDataAdded.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            this.addMetaDataEvents(x.metaData);
        }));
    }
    /**
     * @private
     * @param {?} metaData
     * @return {?}
     */
    addMetaDataEvents(metaData) {
        if (metaData["events"]) {
            for (const event of metaData["events"].valuesArray()) {
                this.eventsInfo.set(event.key, event);
            }
        }
    }
    /**
     * @param {?} eventType
     * @return {?}
     */
    getSubject(eventType) {
        /** @type {?} */
        let subject = this.subjects.get(eventType);
        if (!subject) {
            subject = this.createSubject(this.eventsInfo.get(eventType));
            this.subjects.set(eventType, subject);
        }
        return subject;
    }
    /**
     * @param {?} eventInfo
     * @return {?}
     */
    createSubject(eventInfo) {
        if (!eventInfo || !eventInfo.info) {
            return new Subject();
        }
        else {
            if (eventInfo.info.subjectType === "ReplaySubject") {
                return new ReplaySubject(eventInfo.info.subjectParam || 1);
            }
            else if (eventInfo.info.subjectType === "ReplaySubject") {
                return new BehaviorSubject(eventInfo.info.subjectParam);
            }
        }
        return new Subject();
    }
    /**
     * @param {?} eventType
     * @param {?} eventArgs
     * @return {?}
     */
    publish(eventType, eventArgs) {
        /** @type {?} */
        const subject = this.getSubject(eventType);
        subject.next({
            eventType: eventType,
            eventArgs: eventArgs
        });
    }
    /**
     * @template T
     * @param {?} eventType
     * @return {?}
     */
    listen(eventType) {
        /** @type {?} */
        const subject = this.getSubject(eventType);
        return subject.pipe(filter((/**
         * @param {?} x
         * @return {?}
         */
        x => x.eventType === eventType)), pluck("eventArgs"), share());
    }
}
NarikEventAggregatorService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikEventAggregatorService.ctorParameters = () => [
    { type: MetaDataService }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikEventAggregatorService.prototype.eventsInfo;
    /**
     * @type {?}
     * @private
     */
    NarikEventAggregatorService.prototype.subjects;
    /**
     * @type {?}
     * @private
     */
    NarikEventAggregatorService.prototype.metadataService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikModuleManager extends ModuleManager {
    /**
     * @param {?} injector
     * @param {?} httpService
     * @param {?} configService
     * @param {?} translateService
     */
    constructor(injector, httpService, configService, translateService) {
        super();
        this.injector = injector;
        this.httpService = httpService;
        this.configService = configService;
        this.translateService = translateService;
        this.modules = new Map();
        this.modulesChangedSubject = new Subject();
        this.modulesChanged = this.modulesChangedSubject.asObservable();
        this.narikLoadedSubject = new ReplaySubject(1);
    }
    /**
     * @return {?}
     */
    get narikLoaded() {
        return this.narikLoadedSubject.asObservable();
    }
    /**
     * @private
     * @param {?=} moduleInfo
     * @return {?}
     */
    fixModuleInformation(moduleInfo) { }
    /**
     * @param {?} key
     * @param {?=} moduleInfo
     * @return {?}
     */
    addOrUpdateModule(key, moduleInfo) {
        this.fixModuleInformation(moduleInfo);
        /** @type {?} */
        const isExists = this.modules.has(key);
        this.modules.set(key, moduleInfo);
        /** @type {?} */
        const translatePromices = [];
        if (moduleInfo.metaData && moduleInfo.metaData.translateItems) {
            for (const translateItem of moduleInfo.metaData.translateItems) {
                translatePromices.push(this.translateService.addTranslationItem(translateItem));
            }
        }
        this.modulesChangedSubject.next({
            moduleEventType: isExists ? ModuleEventType.Update : ModuleEventType.Add,
            moduleKey: key,
            moduleInfo: moduleInfo
        });
        Promise.all(translatePromices).then((/**
         * @return {?}
         */
        () => {
            this.eventAggregatorService.publish("MODULE_LOAD_COMPLETELY", {
                moduleKey: key,
                moduleInfo: moduleInfo
            });
        }));
    }
    /**
     * @param {?} key
     * @return {?}
     */
    removeModule(key) {
        /** @type {?} */
        const info = this.modules.get(key);
        this.modules.delete(key);
        this.modulesChangedSubject.next({
            moduleEventType: ModuleEventType.Remove,
            moduleKey: key,
            moduleInfo: info
        });
    }
    /**
     * @return {?}
     */
    init() {
        /** @type {?} */
        const moduleRootPath = this.configService.getConfig("modulesMetaDataRoot");
        return this.httpService
            .get(`${moduleRootPath}/narik.json`)
            .pipe(tap$1((/**
         * @param {?} info
         * @return {?}
         */
        (info) => {
            this.addOrUpdateModule("narik", info);
            this.narikLoadedSubject.next();
        })))
            .toPromise();
    }
}
NarikModuleManager.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikModuleManager.ctorParameters = () => [
    { type: Injector },
    { type: NarikHttpService },
    { type: ConfigService },
    { type: NarikTranslateService }
];
__decorate([
    NarikInject(EventAggregatorService),
    __metadata("design:type", EventAggregatorService)
], NarikModuleManager.prototype, "eventAggregatorService", void 0);
if (false) {
    /** @type {?} */
    NarikModuleManager.prototype.modules;
    /** @type {?} */
    NarikModuleManager.prototype.modulesChanged;
    /** @type {?} */
    NarikModuleManager.prototype.modulesChangedSubject;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.narikLoadedSubject;
    /** @type {?} */
    NarikModuleManager.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.configService;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.translateService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikNavigationService {
    /**
     * @param {?} providers
     */
    constructor(providers) {
        this.navigationProviders = new Map();
        providers.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => this.navigationProviders.set(x.key, x)));
    }
    /**
     * @param {?} commands
     * @param {?=} providerKey
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    navigate(commands, providerKey = "", extras, data, dialogOptions) {
        return this.navigationProviders
            .get(providerKey)
            .navigate(commands, extras, data, dialogOptions);
    }
    /**
     * @param {?} providerKey
     * @param {?} path
     * @return {?}
     */
    createNavigationCommand(providerKey, path) {
        return this.navigationProviders
            .get(providerKey)
            .createNavigationCommand(path);
    }
    /**
     * @param {?} providerKey
     * @param {?} outlet
     * @return {?}
     */
    setOutlet(providerKey, outlet) {
        this.navigationProviders.get(providerKey).outlet = outlet;
    }
}
NarikNavigationService.decorators = [
    { type: Injectable, args: [{
                providedIn: "root"
            },] }
];
/** @nocollapse */
NarikNavigationService.ctorParameters = () => [
    { type: Array, decorators: [{ type: Inject, args: [NavigationProvider,] }] }
];
/** @nocollapse */ NarikNavigationService.ɵprov = ɵɵdefineInjectable({ factory: function NarikNavigationService_Factory() { return new NarikNavigationService(ɵɵinject(NavigationProvider)); }, token: NarikNavigationService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikNavigationService.prototype.navigationProviders;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikRemoteDataProviderService extends RemoteDataProviderService {
    /**
     * @param {?} httpService
     * @param {?} injector
     * @param {?} moduleManager
     * @param {?} metaDataService
     */
    constructor(httpService, injector, moduleManager, metaDataService) {
        super();
        this.httpService = httpService;
        this.injector = injector;
        this.moduleManager = moduleManager;
        this.metaDataService = metaDataService;
        this.key = "remote";
        this.order = 100;
        this.dayaKeyTemplate = "{0}_{1}";
        this.dataStreams = new Map();
        this.modulesDataInformations = new Map();
        for (const module of this.moduleManager.modules.entriesArray()) {
            if (module.value.metaData && module.value.metaData.dataInfo) {
                this.addRemoteDataInfo(module.key, module.value.metaData.dataInfo);
            }
        }
        this.moduleManager.modulesChanged.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            if (x.moduleInfo.metaData && x.moduleInfo.metaData.dataInfo) {
                this.addRemoteDataInfo(x.moduleKey, x.moduleInfo.metaData.dataInfo);
            }
        }));
    }
    /**
     * @protected
     * @param {?} moduleKey
     * @param {?} dataInfo
     * @return {?}
     */
    addRemoteDataInfo(moduleKey, dataInfo) {
        if (!this.modulesDataInformations.has(moduleKey)) {
            this.modulesDataInformations.set(moduleKey, dataInfo);
        }
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    isDataProviderFor(dataInfo) {
        return true;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getData(dataInfo) {
        /** @type {?} */
        let _dataUrl = dataInfo.dataUrl;
        /** @type {?} */
        let _remoteDataProvider = dataInfo.remoteDataProvider;
        /** @type {?} */
        let _parameterPrefix = "";
        if (!_dataUrl) {
            /** @type {?} */
            let _dataInfo = Object.assign({}, dataInfo);
            if (!_dataInfo.moduleKey) {
                _dataInfo.moduleKey = this.injector.get(MODULE_DATA_KEY);
            }
            if (!dataInfo.actionType || dataInfo.actionType === "DATA") {
                /** @type {?} */
                const dataItemInformations = this.metaDataService.getDataItemInformation(_dataInfo.moduleKey, _dataInfo.dataKey);
                if (dataItemInformations) {
                    _dataInfo = Object.assign(dataItemInformations, _dataInfo);
                }
            }
            /** @type {?} */
            const moduleDataItemInformations = this.modulesDataInformations.get(_dataInfo.moduleKey);
            if (moduleDataItemInformations) {
                if (!_dataInfo.dataUrl) {
                    /** @type {?} */
                    const urlInfo = moduleDataItemInformations.dataUrlInfo;
                    if (!dataInfo.actionType || dataInfo.actionType === "DATA") {
                        _dataInfo.dataUrl = urlInfo.dataPathTemplate;
                    }
                    else if (dataInfo.actionType === "GET") {
                        _dataInfo.dataUrl = urlInfo.getPathTemplate;
                    }
                    else if (dataInfo.actionType === "LIST") {
                        _dataInfo.dataUrl = urlInfo.listPathTemplate;
                    }
                    else if (dataInfo.actionType === "POST") {
                        _dataInfo.dataUrl = urlInfo.postPathTemplate;
                    }
                    else if (dataInfo.actionType === "UPDATE") {
                        _dataInfo.dataUrl = urlInfo.updatePathTemplate;
                    }
                    else if (dataInfo.actionType === "DELETE") {
                        _dataInfo.dataUrl = urlInfo.deletePathTemplate;
                    }
                    else if (dataInfo.actionType === "COMPLETE") {
                        _dataInfo.dataUrl = urlInfo.completePathTemplate;
                    }
                    else {
                        _dataInfo.dataUrl = urlInfo[dataInfo.actionType + "PathTemplate"];
                    }
                    _parameterPrefix = urlInfo.parameterPrefix;
                    if (!_remoteDataProvider) {
                        _remoteDataProvider = urlInfo.defaultRemoteDataProvider;
                    }
                    if (!_dataInfo.dataUrlMethod &&
                        (!dataInfo.actionType || dataInfo.actionType === "DATA")) {
                        _dataInfo.dataUrlMethod = urlInfo.defaultDataUrlMethod;
                    }
                }
            }
            if (!_dataInfo.dataUrlMethod) {
                _dataInfo.dataUrlMethod = "";
            }
            _dataUrl = replaceString(_dataInfo.dataUrl, _dataInfo, "", "{", "}");
        }
        if (!dataInfo.dataMethod ||
            dataInfo.dataMethod === "GET" ||
            dataInfo.dataMethod === "PUT") {
            _parameterPrefix = _parameterPrefix || "";
            if (dataInfo.urlParameters || dataInfo.dataParameters) {
                if (_parameterPrefix && _dataUrl.indexOf(_parameterPrefix) >= 0) {
                    _dataUrl = replaceString(_dataUrl, dataInfo.urlParameters || dataInfo.dataParameters, _parameterPrefix);
                }
                else {
                    if (!_remoteDataProvider) {
                        throw new Error("RemoteDataProvider Dos Not Determined");
                    }
                    /** @type {?} */
                    const urlCreatorService = this.injector.get(UrlCreatorService);
                    _dataUrl = urlCreatorService.applyParameters(_remoteDataProvider, _dataUrl, dataInfo.urlParameters || dataInfo.dataParameters);
                }
            }
            if (dataInfo.pagingParameter) {
                /** @type {?} */
                const urlCreatorService = this.injector.get(UrlCreatorService);
                _dataUrl = urlCreatorService.applyPagingParameters(_remoteDataProvider, _dataUrl, dataInfo.pagingParameter);
            }
        }
        if (dataInfo.dataMethod === "POST") {
            return (/** @type {?} */ (this.httpService.post(_dataUrl, dataInfo.dataParameters || {})));
        }
        else if (dataInfo.dataMethod === "DELETE") {
            return (/** @type {?} */ (this.httpService.delete(_dataUrl, dataInfo.dataParameters || {})));
        }
        else if (dataInfo.dataMethod === "PUT") {
            return (/** @type {?} */ (this.httpService.put(_dataUrl, dataInfo.dataParameters || {})));
        }
        else {
            return (/** @type {?} */ (this.httpService.get(_dataUrl)));
        }
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    getDataStream(dataInfo) {
        /** @type {?} */
        const fullKey = this.getFullKey(dataInfo);
        if (this.dataStreams.has(fullKey)) {
            return this.dataStreams.get(fullKey);
        }
        else {
            /** @type {?} */
            const dataSubject = new ReplaySubject(1);
            this.dataStreams.set(fullKey, dataSubject);
            this.getData(dataInfo)
                .pipe(first())
                .subscribe((/**
             * @param {?} data
             * @return {?}
             */
            data => dataSubject.next(data)));
            return dataSubject.asObservable();
        }
    }
    /**
     * @protected
     * @param {?} dataInfo
     * @return {?}
     */
    getFullKey(dataInfo) {
        /** @type {?} */
        let moduleKey = dataInfo.moduleKey;
        if (!moduleKey) {
            moduleKey = this.injector.get(MODULE_DATA_KEY);
        }
        return formatString(this.dayaKeyTemplate, moduleKey, dataInfo.dataKey);
    }
}
NarikRemoteDataProviderService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikRemoteDataProviderService.ctorParameters = () => [
    { type: NarikHttpService },
    { type: Injector },
    { type: ModuleManager },
    { type: MetaDataService }
];
if (false) {
    /** @type {?} */
    NarikRemoteDataProviderService.prototype.key;
    /** @type {?} */
    NarikRemoteDataProviderService.prototype.order;
    /** @type {?} */
    NarikRemoteDataProviderService.prototype.dayaKeyTemplate;
    /**
     * @type {?}
     * @protected
     */
    NarikRemoteDataProviderService.prototype.dataStreams;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.modulesDataInformations;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.metaDataService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikRoleBasedAuthorizationService extends AuthorizationService {
    /**
     *
     * @param {?} authenticationService
     */
    constructor(authenticationService) {
        super();
        this.authenticationService = authenticationService;
    }
    /**
     * @param {?} itemKey
     * @return {?}
     */
    hasAccess(itemKey) {
        if (this.authenticationService.currentUserValue &&
            this.authenticationService.currentUserValue.roles) {
            /** @type {?} */
            const key = this.extractItemKey(itemKey);
            if (key) {
                /** @type {?} */
                const that = this;
                return of$1(!!key.filter((/**
                 * @param {?} n
                 * @return {?}
                 */
                function (n) {
                    return (that.authenticationService.currentUserValue.roles.indexOf(n) > -1);
                }))[0]);
            }
        }
        return of$1(false);
    }
    /**
     * @protected
     * @param {?} itemKey
     * @return {?}
     */
    extractItemKey(itemKey) {
        if (isString(itemKey)) {
            return [itemKey];
        }
        else if (isArray(itemKey)) {
            return itemKey;
        }
        return null;
    }
}
NarikRoleBasedAuthorizationService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikRoleBasedAuthorizationService.ctorParameters = () => [
    { type: AuthenticationService }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikRoleBasedAuthorizationService.prototype.authenticationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikUrlCreatorService extends UrlCreatorService {
    /**
     * @param {?} creators
     */
    constructor(creators) {
        super();
        this.urlCreators = new Map();
        creators.forEach((/**
         * @param {?} x
         * @return {?}
         */
        x => this.urlCreators.set(x.key, x)));
    }
    /**
     * @param {?} key
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    applyParameters(key, url, parameters) {
        /** @type {?} */
        const creator = this.urlCreators.get(key);
        return creator.applyParameters(url, parameters);
    }
    /**
     * @param {?} key
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    applyPagingParameters(key, url, pagingParameter) {
        /** @type {?} */
        const creator = this.urlCreators.get(key);
        return creator.applyPagingParameters(url, pagingParameter);
    }
}
NarikUrlCreatorService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikUrlCreatorService.ctorParameters = () => [
    { type: Array, decorators: [{ type: Inject, args: [UrlCreator,] }] }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikUrlCreatorService.prototype.urlCreators;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ApiUrlCreator extends UrlCreator {
    constructor() {
        super(...arguments);
        this.key = "api";
    }
    /**
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    applyParameters(url, parameters) {
        if (!parameters) {
            return url;
        }
        return formatString("{0}{1}{2}", url, url.indexOf("?") >= 0 ? "" : "?", Object.keys(parameters)
            .map((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            return formatString("{0}={1}", x, parameters[x]);
        }))
            .join("&"));
    }
    /**
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    applyPagingParameters(url, pagingParameter) {
        throw new Error("Method not implemented.");
    }
}
ApiUrlCreator.decorators = [
    { type: Injectable }
];
if (false) {
    /** @type {?} */
    ApiUrlCreator.prototype.key;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ODataUrlCreator extends UrlCreator {
    constructor() {
        super(...arguments);
        this.key = "odata";
        this.odataFilters = {
            eq: "eq",
            neq: "ne",
            gt: "gt",
            gte: "ge",
            lt: "lt",
            lte: "le",
            contains: "contains",
            doesnotcontain: "substringof",
            endswith: "endswith",
            startswith: "startswith",
            isnull: "eq",
            isnotnull: "ne",
            isnullorempty: "eq",
            isnotnullorempty: "ne",
            isempty: "eq",
            isnotempty: "ne"
        };
    }
    /**
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    applyParameters(url, parameters) {
        if (!parameters) {
            return url;
        }
        if (isObject(parameters)) {
            return formatString("{0}({1})", url, Object.keys(parameters)
                .map((/**
             * @param {?} x
             * @return {?}
             */
            x => {
                return formatString("{0}={2}{1}{2}", x, parameters[x], isString(parameters[x]) ? "'" : "");
            }))
                .join(","));
        }
        else {
            return formatString("{0}({2}{1}{2})", url, parameters, isString(parameters) ? "'" : "");
        }
    }
    /**
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    applyPagingParameters(url, pagingParameter) {
        if (!pagingParameter) {
            return url;
        }
        /** @type {?} */
        let orderBy = "";
        if (pagingParameter.sort && pagingParameter.sort.length !== 0) {
            orderBy = `&%24orderby=`;
            orderBy += pagingParameter.sort
                .map((/**
             * @param {?} s
             * @return {?}
             */
            s => {
                return `${s.field}${s.order === "desc" ? " desc" : ""}`;
            }))
                .join(",");
        }
        /** @type {?} */
        let filter = "";
        if (pagingParameter.filter && pagingParameter.filter.filters) {
            filter = `&%24filter=${this.toOdataFilter(pagingParameter.filter)}`;
        }
        pagingParameter.skip =
            pagingParameter.skip ||
                pagingParameter.pageIndex * pagingParameter.pageCount;
        return (url +
            `?%24format=json&%24top=${pagingParameter.pageCount}&%24skip=${pagingParameter.skip}${orderBy}${filter}&%24count=true`);
    }
    /**
     * @private
     * @param {?} filter
     * @return {?}
     */
    toOdataFilter(filter) {
        /** @type {?} */
        const result = [];
        /** @type {?} */
        const condition = filter.condition || "and";
        /** @type {?} */
        let idx;
        /** @type {?} */
        let length;
        /** @type {?} */
        let field;
        /** @type {?} */
        let type;
        /** @type {?} */
        let format;
        /** @type {?} */
        let operator;
        /** @type {?} */
        let value;
        /** @type {?} */
        let ignoreCase;
        /** @type {?} */
        const filters = filter.filters;
        for (idx = 0, length = filters.length; idx < length; idx++) {
            filter = filters[idx];
            field = filter.field;
            value = filter.value;
            operator = filter.operator;
            if (filter.filters) {
                filter = this.toOdataFilter(filter);
            }
            else {
                ignoreCase = filter.ignoreCase;
                field = field.replace(/\./g, "/");
                filter = this.odataFilters[operator];
                if (operator === "isnullorempty") {
                    filter = formatString("{0} {1} null or {0} {1} ''", field, filter);
                }
                else if (operator === "isnotnullorempty") {
                    filter = formatString("{0} {1} null and {0} {1} ''", field, filter);
                }
                else if (operator === "isnull" || operator === "isnotnull") {
                    filter = formatString("{0} {1} null", field, filter);
                }
                else if (operator === "isempty" || operator === "isnotempty") {
                    filter = formatString("{0} {1} ''", field, filter);
                }
                else if (filter && value !== undefined) {
                    type = typeof value;
                    if (type === "string") {
                        format = "'{1}'";
                        value = value.replace(/'/g, "''");
                        if (ignoreCase === true) {
                            field = "tolower(" + field + ")";
                        }
                    }
                    else if (type === "date") {
                        format = "{1:yyyy-MM-ddTHH:mm:ss+00:00}";
                        // value = kendo.timezone.apply(value, "Etc/UTC");
                    }
                    else {
                        format = "{1}";
                    }
                    if (filter.length > 3) {
                        if (filter !== "substringof") {
                            format = "{0}({2}," + format + ")";
                        }
                        else {
                            format = "{0}(" + format + ",{2})";
                            if (operator === "doesnotcontain") {
                                format = "{0}({2},'{1}') eq -1";
                                filter = "indexof";
                            }
                        }
                    }
                    else {
                        format = "{2} {0} " + format;
                    }
                    filter = formatString(format, filter, value, field);
                }
            }
            result.push(filter);
        }
        filter = result.join(" " + condition + " ");
        if (result.length > 1) {
            filter = "(" + filter + ")";
        }
        return filter;
    }
}
ODataUrlCreator.decorators = [
    { type: Injectable }
];
if (false) {
    /** @type {?} */
    ODataUrlCreator.prototype.key;
    /** @type {?} */
    ODataUrlCreator.prototype.odataFilters;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikEmptyCommandProcessor {
    /**
     * @param {?} sender
     * @param {?} cmd
     * @return {?}
     */
    processCommand(sender, cmd) { }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikValidationService extends ValidationService {
    constructor() {
        super(...arguments);
        this._validators = {
            email: {
                func: Validators.email
            },
            max: {
                func: Validators.max,
                params: ["max"]
            },
            maxLength: {
                func: Validators.maxLength,
                params: ["maxLength"]
            },
            min: {
                func: Validators.min,
                params: ["min"]
            },
            minLength: {
                func: Validators.minLength,
                params: ["minLength"]
            },
            pattern: {
                func: Validators.pattern,
                params: ["pattern"]
            },
            required: {
                func: Validators.required
            },
            requiredTrue: {
                func: Validators.requiredTrue
            },
            base64: {
                func: CustomValidators.base64,
                params: ["min"]
            },
            creditCard: {
                func: CustomValidators.creditCard
            },
            date: {
                func: CustomValidators.date
            },
            dateISO: {
                func: CustomValidators.dateISO
            },
            digits: {
                func: CustomValidators.digits
            },
            equal: {
                func: CustomValidators.equal,
                params: ["equal"]
            },
            equalTo: {
                func: CustomValidators.equalTo,
                params: ["equalTo"]
            },
            gt: {
                func: CustomValidators.gt,
                params: ["gt"]
            },
            gte: {
                func: CustomValidators.gte,
                params: ["gte"]
            },
            json: {
                func: CustomValidators.json
            },
            lt: {
                func: CustomValidators.lt,
                params: ["lt"]
            },
            lte: {
                func: CustomValidators.lte,
                params: ["lte"]
            },
            maxDate: {
                func: CustomValidators.maxDate,
                params: ["maxDate"]
            },
            minDate: {
                func: CustomValidators.minDate,
                params: ["minDate"]
            },
            notEqual: {
                func: CustomValidators.notEqual,
                params: ["notEqual"]
            },
            notEqualTo: {
                func: CustomValidators.notEqualTo,
                params: ["notEqualTo"]
            },
            number: {
                func: CustomValidators.number
            },
            range: {
                func: CustomValidators.range,
                params: ["range"]
            },
            rangeLength: {
                func: CustomValidators.rangeLength,
                params: ["rangeLength"]
            },
            url: {
                func: CustomValidators.url
            },
            uuid: {
                func: CustomValidators.uuid
            }
        };
    }
    /**
     * @param {?} key
     * @param {?} validator
     * @return {?}
     */
    addValidator(key, validator) {
        this._validators[key] = validator;
    }
    /**
     * @return {?}
     */
    validators() {
        return this._validators;
    }
}
if (false) {
    /** @type {?} */
    NarikValidationService.prototype._validators;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikShortcutService extends ShortcutService {
    /**
     * @param {?} eventManager
     * @param {?} document
     */
    constructor(eventManager, document) {
        super();
        this.eventManager = eventManager;
        this.document = document;
        this.hotkeys = new Map();
        this.defaults = {
            element: this.document
        };
    }
    /**
     * @param {?} options
     * @return {?}
     */
    addShortcut(options) {
        /** @type {?} */
        const merged = Object.assign(Object.assign({}, this.defaults), options);
        /** @type {?} */
        const event = `keydown.${merged.keys}`;
        if (merged.description) {
            this.hotkeys.set(merged.keys, merged.description);
        }
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        observer => {
            /** @type {?} */
            const handler = (/**
             * @param {?} e
             * @return {?}
             */
            e => {
                e.preventDefault();
                observer.next({
                    event: e,
                    uniqueId: merged.uniqueId
                });
            });
            /** @type {?} */
            const dispose = this.eventManager.addEventListener(merged.element, event, handler);
            return (/**
             * @return {?}
             */
            () => {
                dispose();
                this.hotkeys.delete(merged.keys);
            });
        }));
    }
}
NarikShortcutService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikShortcutService.ctorParameters = () => [
    { type: EventManager },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
if (false) {
    /** @type {?} */
    NarikShortcutService.prototype.hotkeys;
    /** @type {?} */
    NarikShortcutService.prototype.defaults;
    /**
     * @type {?}
     * @private
     */
    NarikShortcutService.prototype.eventManager;
    /**
     * @type {?}
     * @private
     */
    NarikShortcutService.prototype.document;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikBaseNavigationProvider {
    /**
     * @param {?} router
     */
    constructor(router) {
        this.router = router;
    }
    /**
     * @param {?} config
     * @param {?} segments
     * @param {?} segmentGroup
     * @return {?}
     */
    findRoute(config, segments, segmentGroup) {
        /** @type {?} */
        let item;
        for (const route of config) {
            if (route.path === "**") {
                return {
                    route: route
                };
            }
            else {
                if (route.path === "") {
                    if (route.pathMatch === "full" &&
                        (segmentGroup.hasChildren() || segments.length > 0)) {
                        throw new Error("");
                    }
                    item = {
                        component: null,
                        match: { consumed: [], posParams: {} }
                    };
                }
                else {
                    item = {
                        component: null,
                        match: this.defaultUrlMatcher(segments, segmentGroup, route)
                    };
                }
                if (item && item.match && item.match.consumed) {
                    /** @type {?} */
                    const childRoutes = this.getChildConfig(route);
                    if (item.match.consumed.length !== 0) {
                        segments.splice(0, 1);
                    }
                    item = this.findRoute(childRoutes, segments, segmentGroup);
                    if (item) {
                        return item;
                    }
                }
            }
        }
        return item;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    getChildConfig(route) {
        if (route.children) {
            return route.children;
        }
        if (route.loadChildren) {
            return route["_loadedConfig"].routes;
        }
        return [];
    }
    /**
     * @param {?} segments
     * @param {?} segmentGroup
     * @param {?} route
     * @return {?}
     */
    defaultUrlMatcher(segments, segmentGroup, route) {
        /** @type {?} */
        const parts = route.path.split("/");
        if (parts.length > segments.length) {
            // The actual URL is shorter than the config, no match
            return null;
        }
        if (route.pathMatch === "full" &&
            (segmentGroup.hasChildren() || parts.length < segments.length)) {
            // The config is longer than the actual URL but we are looking for a full match, return null
            return null;
        }
        /** @type {?} */
        const posParams = {};
        // Check each config part against the actual URL
        for (let index = 0; index < parts.length; index++) {
            /** @type {?} */
            const part = parts[index];
            /** @type {?} */
            const segment = segments[index];
            /** @type {?} */
            const isParameter = part.startsWith(":");
            if (isParameter) {
                posParams[part.substring(1)] = segment;
            }
            else if (part !== segment.path) {
                // The actual URL part does not match the config, no match
                return null;
            }
        }
        return { consumed: segments.slice(0, parts.length), posParams };
    }
}
if (false) {
    /** @type {?} */
    NarikBaseNavigationProvider.prototype.outlet;
    /**
     * @type {?}
     * @protected
     */
    NarikBaseNavigationProvider.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikDialogNavigationProvider extends NarikBaseNavigationProvider {
    /**
     * @param {?} dialogService
     * @param {?} router
     */
    constructor(dialogService, router) {
        super(router);
        this.dialogService = dialogService;
        this.key = "dialog";
    }
    /**
     * @param {?} path
     * @return {?}
     */
    createNavigationCommand(path) {
        return [path];
    }
    /**
     * @param {?} commands
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    navigate(commands, extras, data, dialogOptions) {
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        (resolve, reject) => {
            /** @type {?} */
            let tree;
            if (isArray(commands)) {
                tree = this.router.createUrlTree((/** @type {?} */ (commands)), extras);
            }
            else if (isString(commands)) {
                tree = this.router.parseUrl((/** @type {?} */ (commands)));
            }
            else {
                tree = (/** @type {?} */ (commands));
            }
            /** @type {?} */
            const primary = tree.root.children[PRIMARY_OUTLET];
            /** @type {?} */
            const route = this.findRoute(this.router.config, primary.segments, primary);
            if (route && route.route) {
                /** @type {?} */
                const dialog = this.dialogService.showDialog(route.route.component, data ? data["__dialogTitle"] : undefined, {
                    parameters: Object.assign(Object.assign({ routeByCustomProvider: true, path: primary.segments[0].path }, route.route.data), data)
                }, [], dialogOptions || {
                    isFullScreen: false,
                    showBackdrop: true,
                    disableAutoClose: true
                }, undefined, undefined, [{ provide: ActivatedRoute, useValue: extras.relativeTo }]);
                resolve(dialog);
            }
            else {
                reject(false);
            }
        }));
    }
}
NarikDialogNavigationProvider.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikDialogNavigationProvider.ctorParameters = () => [
    { type: DialogService },
    { type: Router }
];
if (false) {
    /** @type {?} */
    NarikDialogNavigationProvider.prototype.key;
    /**
     * @type {?}
     * @private
     */
    NarikDialogNavigationProvider.prototype.dialogService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikRouteNavigationProvider {
    /**
     * @param {?} router
     */
    constructor(router) {
        this.router = router;
        this.key = "route";
    }
    /**
     * @param {?} path
     * @return {?}
     */
    createNavigationCommand(path) {
        return ["../" + path];
    }
    /**
     * @param {?} commands
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    navigate(commands, extras, data, dialogOptions) {
        extras = extras || {};
        if (data) {
            ((/** @type {?} */ (extras))).data = data;
        }
        if (isArray(commands)) {
            return this.router.navigate((/** @type {?} */ (commands)), extras);
        }
        else {
            return this.router.navigateByUrl((/** @type {?} */ (commands)), extras);
        }
    }
}
NarikRouteNavigationProvider.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikRouteNavigationProvider.ctorParameters = () => [
    { type: Router }
];
if (false) {
    /** @type {?} */
    NarikRouteNavigationProvider.prototype.key;
    /** @type {?} */
    NarikRouteNavigationProvider.prototype.outlet;
    /**
     * @type {?}
     * @private
     */
    NarikRouteNavigationProvider.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikFormTitleResolver extends FormTitleResolver {
    /**
     * @param {?} translateService
     */
    constructor(translateService) {
        super();
        this.translateService = translateService;
    }
    /**
     * @param {?} routeSnapshot
     * @param {?=} path
     * @return {?}
     */
    resolveTitle(routeSnapshot, path) {
        if (routeSnapshot) {
            /** @type {?} */
            const title = (routeSnapshot.data && routeSnapshot.data.title) ||
                (routeSnapshot.url[0] && routeSnapshot.url[0].path);
            if (title) {
                return this.translateService.instant(this.getFirst(title));
            }
        }
        if (path) {
            return this.translateService.instant(this.getFirst(path));
        }
        return "";
    }
    /**
     * @private
     * @param {?} title
     * @return {?}
     */
    getFirst(title) {
        return title ? title.split("-")[0] : "";
    }
}
NarikFormTitleResolver.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikFormTitleResolver.ctorParameters = () => [
    { type: TranslateService }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikFormTitleResolver.prototype.translateService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikCoreModule {
    /**
     * @param {?} translateService
     * @param {?} defaultLang
     * @param {?} useDefaultLang
     * @param {?} injector
     */
    constructor(translateService, defaultLang, useDefaultLang, injector) {
        translateService.setDefaultLang(defaultLang);
        if (useDefaultLang) {
            translateService.use(defaultLang);
        }
        AppInjector.injector = injector;
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    static forRoot(config) {
        return {
            ngModule: NarikCoreModule,
            providers: [
                {
                    provide: ErrorHandleService,
                    useClass: (config && config.errorHandleService) || NarikErrorHandleService
                },
                {
                    provide: DataProviderService,
                    useClass: (config && config.dataProviderService) || NarikDataProviderService
                },
                {
                    provide: DataStorageService,
                    useClass: (config && config.dataStorageService) || NarikDataStorageService
                },
                {
                    provide: DialogService,
                    useClass: (config && config.dialogService) || NarikDialogService
                },
                {
                    provide: UrlCreatorService,
                    useClass: (config && config.urlCreatorService) || NarikUrlCreatorService
                },
                {
                    provide: ModuleManager,
                    useClass: (config && config.moduleManagerService) || NarikModuleManager
                },
                {
                    provide: ValidationService,
                    useClass: (config && config.validationService) || NarikValidationService
                },
                {
                    provide: EventAggregatorService,
                    useClass: (config && config.eventAggregatorService) ||
                        NarikEventAggregatorService
                },
                {
                    provide: AuthorizationService,
                    useClass: (config && config.authorizationService) ||
                        NarikRoleBasedAuthorizationService
                },
                {
                    provide: ConfigService,
                    useClass: (config && config.configService) || NarikConfigService
                },
                {
                    provide: JsonService,
                    useClass: (config && config.jsonService) || NarikJsonService
                },
                {
                    provide: ComponentTypeResolver,
                    useClass: (config && config.componentTypeResolver) || NarikComponentTypeResolver
                },
                {
                    provide: FormTitleResolver,
                    useClass: (config && config.formTitleResolver) || NarikFormTitleResolver
                },
                {
                    provide: CommandProcessor,
                    useClass: (config && config.commandProcessor) || NarikEmptyCommandProcessor
                },
                {
                    provide: DEFAULT_LANG,
                    useValue: (config && config.defaultLang) || "en"
                },
                {
                    provide: NavigationService,
                    useClass: NarikNavigationService
                },
                {
                    provide: USE_DEFAULT_LANG,
                    useValue: config && config.useDefaultLang
                },
                { provide: CONFIG_PATH, useValue: config && config.configFilePath },
                { provide: CONFIG_OPTIONS, useValue: config && config.configOptions },
                {
                    provide: APP_INITIALIZER,
                    useFactory: initConfig,
                    deps: [ConfigService, ModuleManager],
                    multi: true
                },
                {
                    provide: ShortcutService,
                    useClass: NarikShortcutService
                }
            ]
        };
    }
}
NarikCoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [ToastrModule.forRoot()],
                declarations: [COMPONENTS],
                exports: [EXPORT_COMPONENTS],
                providers: [
                    {
                        provide: RemoteDataProviderService,
                        useClass: NarikRemoteDataProviderService
                    },
                    {
                        provide: SessionStorageDataProvider,
                        useClass: SessionStorageDataProvider
                    },
                    {
                        provide: LocalStorageDataProvider,
                        useClass: LocalStorageDataProvider
                    },
                    {
                        provide: MemoryDataProvider,
                        useClass: MemoryDataProvider
                    },
                    {
                        provide: DATA_PROVIDER,
                        useExisting: SessionStorageDataProvider,
                        multi: true
                    },
                    {
                        provide: DATA_PROVIDER,
                        useClass: StaticDataProvider,
                        multi: true
                    },
                    {
                        provide: DATA_PROVIDER,
                        useExisting: LocalStorageDataProvider,
                        multi: true
                    },
                    {
                        provide: DATA_PROVIDER,
                        useExisting: MemoryDataProvider,
                        multi: true
                    },
                    {
                        provide: DATA_PROVIDER,
                        useClass: RemoteDataProvider,
                        multi: true
                    },
                    {
                        provide: DATA_STORAGE,
                        useExisting: SessionStorageDataProvider,
                        multi: true
                    },
                    {
                        provide: DATA_STORAGE,
                        useExisting: LocalStorageDataProvider,
                        multi: true
                    },
                    {
                        provide: DATA_STORAGE,
                        useExisting: MemoryDataProvider,
                        multi: true
                    },
                    {
                        provide: UrlCreator,
                        useClass: ApiUrlCreator,
                        multi: true
                    },
                    {
                        provide: UrlCreator,
                        useClass: ODataUrlCreator,
                        multi: true
                    },
                    {
                        provide: NavigationProvider,
                        useClass: NarikDialogNavigationProvider,
                        multi: true
                    },
                    {
                        provide: NavigationProvider,
                        useClass: NarikRouteNavigationProvider,
                        multi: true
                    },
                    { provide: HTTP_INTERCEPTORS, useClass: HttpErrorInterceptor, multi: true }
                ]
            },] }
];
/** @nocollapse */
NarikCoreModule.ctorParameters = () => [
    { type: NarikTranslateService },
    { type: String, decorators: [{ type: Inject, args: [DEFAULT_LANG,] }] },
    { type: Boolean, decorators: [{ type: Inject, args: [USE_DEFAULT_LANG,] }] },
    { type: Injector }
];
/**
 * @param {?} configService
 * @param {?} moduleManager
 * @return {?}
 */
function initConfig(configService, moduleManager) {
    /** @type {?} */
    const promise = (/**
     * @return {?}
     */
    () => {
        // return configService.init().then(() => {
        //   moduleManager.init();
        // });
        return promiseSerial([
            (/**
             * @return {?}
             */
            () => configService.init()),
            (/**
             * @return {?}
             */
            () => moduleManager.init())
        ]);
    });
    return promise;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ResourceModel() { }
if (false) {
    /** @type {?} */
    ResourceModel.prototype.src;
    /** @type {?|undefined} */
    ResourceModel.prototype.loaded;
}
class NarikResourceLoaderService {
    /**
     * @param {?} configService
     */
    constructor(configService) {
        this.resources = [];
        this.dynamicResourcesPath = "";
        this.dynamicResourcesPath = configService.getConfig("dynamicResourcesPath");
        if (this.dynamicResourcesPath) {
            this.dynamicResourcesPath += "/";
        }
    }
    /**
     * @param {?} items
     * @return {?}
     */
    load(items) {
        /** @type {?} */
        const loaders = items.map((/**
         * @param {?} x
         * @return {?}
         */
        x => {
            if (Array.isArray(x)) {
                return Observable$1.create((/**
                 * @param {?} o
                 * @return {?}
                 */
                o => {
                    /** @type {?} */
                    const allloaders = x.map((/**
                     * @param {?} t
                     * @return {?}
                     */
                    t => this.loadInternall(t)));
                    concat(...allloaders).subscribe((/**
                     * @param {?} t
                     * @return {?}
                     */
                    t => { }), (/**
                     * @return {?}
                     */
                    () => { }), (/**
                     * @return {?}
                     */
                    () => {
                        o.next();
                        o.complete();
                    }));
                }));
            }
            else {
                return this.loadInternall(x);
            }
        }));
        return Observable$1.create((/**
         * @param {?} observer
         * @return {?}
         */
        observer => {
            forkJoin(loaders).subscribe((/**
             * @param {?} results
             * @return {?}
             */
            results => {
                observer.next(results);
            }));
        }));
    }
    /**
     * @private
     * @param {?} resource
     * @return {?}
     */
    loadInternall(resource) {
        return new Observable$1((/**
         * @param {?} observer
         * @return {?}
         */
        (observer) => {
            /** @type {?} */
            const existingResources = this.resources.find((/**
             * @param {?} s
             * @return {?}
             */
            s => s.src === resource.src));
            // Complete if already loaded
            if (existingResources && existingResources.loaded) {
                observer.next(existingResources);
                observer.complete();
            }
            else {
                // Add the script
                this.resources = [...this.resources, resource];
                if (resource.src.toLowerCase().endsWith(".js")) {
                    /** @type {?} */
                    const scriptElement = document.createElement("script");
                    scriptElement.type = "text/javascript";
                    scriptElement.src = this.dynamicResourcesPath + resource.src;
                    scriptElement.onload = (/**
                     * @return {?}
                     */
                    () => {
                        resource.loaded = true;
                        observer.next(resource);
                        observer.complete();
                    });
                    scriptElement.onerror = (/**
                     * @param {?} error
                     * @return {?}
                     */
                    (error) => {
                        observer.error("Couldn't load script " + resource.src);
                    });
                    document.getElementsByTagName("body")[0].appendChild(scriptElement);
                }
                else {
                    /** @type {?} */
                    const cssElement = document.createElement("link");
                    cssElement.rel = "stylesheet";
                    cssElement.href = this.dynamicResourcesPath + resource.src;
                    cssElement.onload = (/**
                     * @return {?}
                     */
                    () => {
                        resource.loaded = true;
                        observer.next(resource);
                        observer.complete();
                    });
                    cssElement.onerror = (/**
                     * @param {?} error
                     * @return {?}
                     */
                    (error) => {
                        observer.error("Couldn't load style " + resource.src);
                    });
                    document.getElementsByTagName("head")[0].appendChild(cssElement);
                }
            }
        }));
    }
}
NarikResourceLoaderService.decorators = [
    { type: Injectable, args: [{
                providedIn: "root"
            },] }
];
/** @nocollapse */
NarikResourceLoaderService.ctorParameters = () => [
    { type: ConfigService }
];
/** @nocollapse */ NarikResourceLoaderService.ɵprov = ɵɵdefineInjectable({ factory: function NarikResourceLoaderService_Factory() { return new NarikResourceLoaderService(ɵɵinject(ConfigService)); }, token: NarikResourceLoaderService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikResourceLoaderService.prototype.resources;
    /**
     * @type {?}
     * @private
     */
    NarikResourceLoaderService.prototype.dynamicResourcesPath;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikTranslateLoader {
    /**
     * @param {?} http
     * @param {?} configService
     * @param {?=} items
     */
    constructor(http, configService, items = []) {
        this.http = http;
        this.configService = configService;
        this.items = items;
        this.root = "";
        this.slash = "/";
    }
    /**
     * @param {?} lang
     * @return {?}
     */
    getTranslation(lang) {
        if (this.root) {
            return this.getTranslationInternal(lang);
        }
        else {
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            observer => {
                this.configService.configLoaded.pipe(first()).subscribe((/**
                 * @return {?}
                 */
                () => {
                    this.root = this.configService.getConfig("translationsPath");
                    this.getTranslationInternal(lang).subscribe((/**
                     * @param {?} x
                     * @return {?}
                     */
                    x => observer.next(x)));
                }));
            }));
        }
    }
    /**
     * @private
     * @param {?} lang
     * @return {?}
     */
    getTranslationInternal(lang) {
        if (this.items.length !== 0) {
            /** @type {?} */
            const loaders = this.items.map((/**
             * @param {?} x
             * @return {?}
             */
            x => {
                return this.http.get(`${this.root}${this.slash}${lang}${this.slash}${x}.json`);
            }));
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            observer => {
                forkJoin$1(loaders).subscribe((/**
                 * @param {?} trnslations
                 * @return {?}
                 */
                trnslations => {
                    /** @type {?} */
                    let result = {};
                    trnslations.map((/**
                     * @param {?} x
                     * @return {?}
                     */
                    x => (result = Object.assign(result, x))));
                    observer.next(result);
                }));
            }));
        }
        else {
            return of$1({});
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    addTranslationItem(item) {
        this.items.push(item);
    }
    /**
     * @param {?} lang
     * @param {?} item
     * @return {?}
     */
    getTranslateFilePath(lang, item) {
        return `${this.root}${this.slash}${lang}${this.slash}${item}.json`;
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.root;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.slash;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.http;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.configService;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.items;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikResourceBasedAuthorizationService extends AuthorizationService {
    /**
     *
     */
    constructor() {
        super();
    }
    /**
     * @param {?} itemKey
     * @return {?}
     */
    hasAccess(itemKey) {
        /** @type {?} */
        const key = this.extractItemKey(itemKey);
        return of$1(false);
    }
    /**
     * @protected
     * @param {?} itemKey
     * @return {?}
     */
    extractItemKey(itemKey) {
        if (isString(itemKey)) {
            return [
                {
                    key: itemKey
                }
            ];
        }
        else if (isArray(itemKey)) {
            return itemKey;
        }
        return null;
    }
}
NarikResourceBasedAuthorizationService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NarikResourceBasedAuthorizationService.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function NarikCoreModuleConfig() { }
if (false) {
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.configFilePath;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.configOptions;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.errorHandleService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.dataProviderService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.dialogService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.dataStorageService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.moduleManagerService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.eventAggregatorService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.urlCreatorService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.authorizationService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.configService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.jsonService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.formTitleResolver;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.commandProcessor;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.validationService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.componentTypeResolver;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.defaultLang;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.useDefaultLang;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class NarikModule {
    /**
     * @param {?} injector
     */
    constructor(injector) {
        this.injector = injector;
        this.configService.configLoaded.pipe(first$1()).subscribe((/**
         * @return {?}
         */
        () => {
            this.moduleRootPath = this.configService.getConfig("modulesMetaDataRoot");
            if (!this.moduleRootPath) {
                throw new Error("modulesMetaDataRoot is null");
            }
            this.registerModule();
        }));
    }
    /**
     * @protected
     * @return {?}
     */
    registerModule() {
        /** @type {?} */
        const moduleInfo = this.moduleInfo;
        if (moduleInfo) {
            moduleInfo.subscribe((/**
             * @param {?} info
             * @return {?}
             */
            info => {
                info.module = this.moduleRef;
                this.moduleManager.addOrUpdateModule(this.key, info);
            }));
        }
    }
    /**
     * @protected
     * @return {?}
     */
    loadInfoFromJson() {
        return this.jsonService
            .getJson(`${this.moduleRootPath}/${this.key.toLowerCase()}.json`)
            .pipe(map((/**
         * @param {?} x
         * @return {?}
         */
        x => (/** @type {?} */ (x)))));
    }
    /**
     * @protected
     * @param {?} info
     * @return {?}
     */
    loadInfoFromData(info) {
        return of$1(info);
    }
}
__decorate([
    NarikInject(ModuleManager),
    __metadata("design:type", ModuleManager)
], NarikModule.prototype, "moduleManager", void 0);
__decorate([
    NarikInject(NgModuleRef),
    __metadata("design:type", NgModuleRef)
], NarikModule.prototype, "moduleRef", void 0);
__decorate([
    NarikInject(NarikHttpService),
    __metadata("design:type", NarikHttpService)
], NarikModule.prototype, "httpService", void 0);
__decorate([
    NarikInject(JsonService),
    __metadata("design:type", JsonService)
], NarikModule.prototype, "jsonService", void 0);
__decorate([
    NarikInject(ConfigService),
    __metadata("design:type", ConfigService)
], NarikModule.prototype, "configService", void 0);
if (false) {
    /** @type {?} */
    NarikModule.prototype.key;
    /** @type {?} */
    NarikModule.prototype.moduleInfo;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.moduleRef;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.jsonService;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.configService;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.moduleRootPath;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NarikDialogContainer {
    constructor() {
        this.isOpen = false;
        this.closeAnimationCompleted = new EventEmitter();
        this.actions = [];
    }
    /**
     * @return {?}
     */
    get contentContainerRef() {
        return this.loaderHost.viewContainerRef;
    }
    /**
     * @param {?} item
     * @return {?}
     */
    actionClick(item) {
        this.dialogRef.close({
            componentInstance: this.dialogRef.componentInstance,
            dialogResult: item.dialogResult
        }, "DIALOG");
    }
    /**
     * @param {?} event
     * @return {?}
     */
    _onAnimationDone(event) {
        if (event.toState === "closed") {
            this.closeAnimationCompleted.emit(event);
        }
    }
}
NarikDialogContainer.propDecorators = {
    loaderHost: [{ type: ViewChild, args: [ComponentLoaderHostDirective, { static: true },] }]
};
if (false) {
    /** @type {?} */
    NarikDialogContainer.prototype.isOpen;
    /** @type {?} */
    NarikDialogContainer.prototype.closeAnimationCompleted;
    /** @type {?} */
    NarikDialogContainer.prototype.loaderHost;
    /** @type {?} */
    NarikDialogContainer.prototype.options;
    /** @type {?} */
    NarikDialogContainer.prototype.title;
    /** @type {?} */
    NarikDialogContainer.prototype.actions;
    /** @type {?} */
    NarikDialogContainer.prototype.dialogRef;
}
/** @type {?} */
const DialogAnimationBody = [
    state("closed", style({ opacity: 0, transform: "scale(0.7)" })),
    state("open", style({ transform: "none" })),
    transition("closed => open", animate("150ms cubic-bezier(0, 0, 0.2, 1)", style({ transform: "none", opacity: 1 }))),
    transition("open => closed", animate("75ms cubic-bezier(0.4, 0.0, 0.2, 1)", style({ opacity: 0 })))
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} cls
 * @param {?} template
 * @return {?}
 */
function applyBaseTemplate(cls, template) {
    template =
        typeof template === "string" ? template : ((/** @type {?} */ (template))).default;
    /** @type {?} */
    const annotations = cls["__annotations__"];
    if (annotations) {
        for (const annotation of annotations) {
            if (annotation && annotation.hasOwnProperty("template")) {
                /** @type {?} */
                const parser = new DOMParser();
                /** @type {?} */
                const parentDoc = parser.parseFromString(template, "text/html");
                /** @type {?} */
                const childDoc = parser.parseFromString(annotation.template, "text/html");
                /** @type {?} */
                const sectionItems = parentDoc.querySelectorAll("[narik-section]");
                for (let index = 0; index < sectionItems.length; index++) {
                    /** @type {?} */
                    const element = sectionItems[index];
                    /** @type {?} */
                    const sectionName = element.attributes["narik-section"].value;
                    /** @type {?} */
                    const contentItem = childDoc.querySelector(`[\\#${sectionName}]`);
                    if (contentItem &&
                        contentItem.tagName.toLowerCase() === "ng-template") {
                        template = template.replace(`narik-section="${sectionName}"`, `*ngIf="false; else ${sectionName}"`);
                    }
                }
                annotation.template = template + annotation.template;
            }
        }
    }
    return cls;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} templateKey
 * @return {?}
 */
function NarikBaseTemplate(templateKey) {
    /** @type {?} */
    const typeDecorator = (/** @type {?} */ (((
    // tslint:disable-next-line:no-shadowed-variable
    /**
     * @param {?} cls
     * @return {?}
     */
    function TypeDecorator(cls) {
        return applyBaseTemplate(cls, templateKey);
    }))));
    return typeDecorator;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ApiUrlCreator, AppInjector, DialogActions, DialogAnimationBody, HttpErrorInterceptor, LOCAL_STORAGE_VALIDITY_LEN, LocalStorageDataProvider, MEMORY_STORAGE_VALIDITY_LEN, MemoryDataProvider, NarikBaseDataProvider, NarikBaseDataStorage, NarikBaseNavigationProvider, NarikBaseTemplate, NarikComponentTypeResolver, NarikCoreModule, NarikDataProviderService, NarikDialogContainer, NarikDialogNavigationProvider, NarikDialogRef, NarikDialogService, NarikErrorHandleService, NarikGlobalInject, NarikHttpService, NarikInject, NarikModule, NarikModuleManager, NarikRemoteDataProviderService, NarikResourceBasedAuthorizationService, NarikResourceLoaderService, NarikRoleBasedAuthorizationService, NarikRouteNavigationProvider, NarikShortcutService, NarikTranslateLoader, NarikTranslateService, NarikUrlCreatorService, NarikValidationService, ODataUrlCreator, RemoteDataProvider, SESSION_STORAGE_VALIDITY_LEN, StaticDataProvider, applyBaseTemplate, initConfig, COMPONENTS as ɵa, EXPORT_COMPONENTS as ɵb, SessionStorageDataProvider as ɵc, NarikDataStorageService as ɵd, NarikEventAggregatorService as ɵe, NarikConfigService as ɵf, NarikJsonService as ɵg, NarikFormTitleResolver as ɵh, NarikEmptyCommandProcessor as ɵi, NarikNavigationService as ɵj };
//# sourceMappingURL=narik-core.js.map
