import { __extends, __values, __spread, __decorate, __metadata, __assign } from 'tslib';
import { DYNAMIC_COMPONENTS, ComponentTypeResolver, JsonService, CONFIG_OPTIONS, CONFIG_PATH, ConfigService, MODULE_DATA_KEY, DataProviderService, isDataStorage, ModuleManager, RemoteDataProviderService, DialogService, DATA_PROVIDER, EventAggregatorService, RemoteMessagingService, DATA_STORAGE, DEFAULT_DATA_STORAGE_KEY, DataStorageService, MessageType, DIALOG_REF, FieldTypes, DIALOG_OVERLAY_CONTAINER, DIALOG_MESSAGE_COMPONENT, DIALOG_INPUT_COMPONENT, DIALOG_CONTENT_COMPONENT, DIALOG_CONTAINER, ErrorHandler, ErrorHandleService, MetaDataService, ModuleEventType, NavigationProvider, UrlCreatorService, AuthenticationService, AuthorizationService, UrlCreator, ValidationService, ShortcutService, FormTitleResolver, CommandProcessor, DEFAULT_LANG, NavigationService, USE_DEFAULT_LANG } from 'narik-infrastructure';
import { Injectable, Inject, Injector, ɵɵdefineInjectable, ɵɵinject, INJECTOR, InjectionToken, Optional, TemplateRef, Type, ApplicationRef, ComponentFactoryResolver, NgModuleRef, RendererFactory2, APP_INITIALIZER, NgModule, EventEmitter, ViewChild } from '@angular/core';
import { getNestedValue, isArray, toFilterFunction, isString, formatString, toDtoArray, isFunction, groupBy, replaceString, isObject, promiseSerial, ComponentLoaderHostDirective } from 'narik-common';
import { map, tap, merge, mergeMap as mergeMap$1, first as first$1, pluck, share } from 'rxjs/operators';
import { HttpClient, HTTP_INTERCEPTORS } from '@angular/common/http';
import { Observable } from 'rxjs/internal/Observable';
import { mergeMap } from 'rxjs/internal/operators/mergeMap';
import { of, forkJoin, empty, Observable as Observable$1, concat } from 'rxjs';
import { tap as tap$1 } from 'rxjs/internal/operators/tap';
import { ReplaySubject } from 'rxjs/internal/ReplaySubject';
import { ToastrService, ToastrModule } from 'ngx-toastr';
import { first } from 'rxjs/internal/operators/first';
import { of as of$1 } from 'rxjs/internal/observable/of';
import { TranslateService } from '@ngx-translate/core';
import { map as map$1 } from 'rxjs/internal/operators/map';
import { throwError } from 'rxjs/internal/observable/throwError';
import { catchError } from 'rxjs/internal/operators/catchError';
import { UUID } from 'angular2-uuid';
import { DOCUMENT } from '@angular/common';
import { filter } from 'rxjs/internal/operators/filter';
import { OverlayContainer } from '@angular/cdk/overlay';
import { take } from 'rxjs/internal/operators/take';
import { Subject } from 'rxjs/internal/Subject';
import { BehaviorSubject } from 'rxjs/internal/BehaviorSubject';
import { Validators } from '@angular/forms';
import { CustomValidators } from 'ngx-custom-validators';
import { EventManager } from '@angular/platform-browser';
import { PRIMARY_OUTLET, ActivatedRoute, Router } from '@angular/router';
import { forkJoin as forkJoin$1 } from 'rxjs/internal/observable/forkJoin';
import { state, style, transition, animate } from '@angular/animations';
import 'reflect-metadata';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikComponentTypeResolver = /** @class */ (function (_super) {
    __extends(NarikComponentTypeResolver, _super);
    function NarikComponentTypeResolver(components) {
        var _this = _super.call(this) || this;
        _this.components = [];
        _this.components = [].concat.apply([], components);
        return _this;
    }
    /**
     * @param {?} key
     * @return {?}
     */
    NarikComponentTypeResolver.prototype.resolveComponentType = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return this.components.filter((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x.name === key || x["COMPONENT_NAME"] === key; }))[0];
    };
    NarikComponentTypeResolver.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikComponentTypeResolver.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [DYNAMIC_COMPONENTS,] }] }
    ]; };
    return NarikComponentTypeResolver;
}(ComponentTypeResolver));
if (false) {
    /** @type {?} */
    NarikComponentTypeResolver.prototype.components;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikHttpService = /** @class */ (function () {
    function NarikHttpService(httpClient, injector) {
        this.httpClient = httpClient;
        this.injector = injector;
    }
    /**
     * @param {?} url
     * @return {?}
     */
    NarikHttpService.prototype.get = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        var _this = this;
        return this.httpClient
            .get(url)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) { return _this.extractData(result); })));
    };
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    NarikHttpService.prototype.post = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        var _this = this;
        return this.httpClient
            .post(url, data)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) { return _this.extractData(result); })));
    };
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    NarikHttpService.prototype.delete = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        return this.httpClient.delete(url, data);
    };
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    NarikHttpService.prototype.put = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        return this.httpClient.put(url, data);
    };
    /**
     * @private
     * @param {?} result
     * @return {?}
     */
    NarikHttpService.prototype.extractData = /**
     * @private
     * @param {?} result
     * @return {?}
     */
    function (result) {
        if (result && result["@odata.context"]) {
            if (result["@odata.count"] || result["@odata.count"] === 0) {
                return {
                    count: result["@odata.count"],
                    result: result.value
                };
            }
            else if (result["@odata.null"]) {
                return null;
            }
            else {
                return ((/** @type {?} */ (result["@odata.context"]))).endsWith("$entity")
                    ? result
                    : result.hasOwnProperty("value")
                        ? result.value
                        : result;
            }
        }
        return result || result === 0 || result === false
            ? result.data || result
            : null;
    };
    NarikHttpService.decorators = [
        { type: Injectable, args: [{
                    providedIn: "root"
                },] }
    ];
    /** @nocollapse */
    NarikHttpService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: Injector }
    ]; };
    /** @nocollapse */ NarikHttpService.ɵprov = ɵɵdefineInjectable({ factory: function NarikHttpService_Factory() { return new NarikHttpService(ɵɵinject(HttpClient), ɵɵinject(INJECTOR)); }, token: NarikHttpService, providedIn: "root" });
    return NarikHttpService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikHttpService.prototype.httpClient;
    /**
     * @type {?}
     * @private
     */
    NarikHttpService.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikJsonService = /** @class */ (function (_super) {
    __extends(NarikJsonService, _super);
    function NarikJsonService(httpService) {
        var _this = _super.call(this) || this;
        _this.httpService = httpService;
        _this.jsons = new Map();
        return _this;
    }
    /**
     * @param {?} path
     * @return {?}
     */
    NarikJsonService.prototype.getJson = /**
     * @param {?} path
     * @return {?}
     */
    function (path) {
        var _this = this;
        /** @type {?} */
        var jsonData = this.jsons.get(path);
        return jsonData
            ? of(jsonData)
            : this.httpService.get(path).pipe(mergeMap((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return _this.applyExtends(path, x); })), map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                delete data["extends"];
                delete data["imports"];
                delete data["variables"];
                delete data["removeItems"];
                return data;
            })), tap((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                _this.jsons.set(path, x);
            })));
    };
    /**
     * @private
     * @param {?} dataPath
     * @param {?} data
     * @return {?}
     */
    NarikJsonService.prototype.applyExtends = /**
     * @private
     * @param {?} dataPath
     * @param {?} data
     * @return {?}
     */
    function (dataPath, data) {
        var _this = this;
        if (data && data.extends) {
            /** @type {?} */
            var extendsPath = this.resolvePath(dataPath, data.extends);
            return this.getJson(extendsPath).pipe(mergeMap((/**
             * @param {?} parentData
             * @return {?}
             */
            function (parentData) {
                return _this.applyImports(dataPath, _this.applyJsonExtends(parentData, data));
            })));
        }
        else {
            return this.applyImports(dataPath, data);
        }
    };
    /**
     * @private
     * @param {?} basePath
     * @param {?} path
     * @return {?}
     */
    NarikJsonService.prototype.resolvePath = /**
     * @private
     * @param {?} basePath
     * @param {?} path
     * @return {?}
     */
    function (basePath, path) {
        /** @type {?} */
        var stack = basePath.split("/");
        /** @type {?} */
        var parts = path.split("/");
        stack.pop();
        for (var i = 0; i < parts.length; i++) {
            if (parts[i] === ".") {
                continue;
            }
            if (parts[i] === "..") {
                stack.pop();
            }
            else {
                stack.push(parts[i]);
            }
        }
        return stack.join("/");
    };
    /**
     * @private
     * @param {?} dataPath
     * @param {?} data
     * @return {?}
     */
    NarikJsonService.prototype.applyImports = /**
     * @private
     * @param {?} dataPath
     * @param {?} data
     * @return {?}
     */
    function (dataPath, data) {
        var _this = this;
        if (data && data.imports) {
            /** @type {?} */
            var loaders_1 = [];
            var _loop_1 = function (key) {
                if (data.imports.hasOwnProperty(key)) {
                    /** @type {?} */
                    var element = data.imports[key];
                    /** @type {?} */
                    var importPath = this_1.resolvePath(dataPath, element);
                    loaders_1.push(this_1.getJson(importPath).pipe(map((/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) {
                        return { key: key, data: x };
                    }))));
                }
            };
            var this_1 = this;
            for (var key in data.imports) {
                _loop_1(key);
            }
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                forkJoin(loaders_1).subscribe((/**
                 * @param {?} items
                 * @return {?}
                 */
                function (items) {
                    observer.next(_this.applyVariables(_this.applyJsonImports(data, items)));
                }));
            }));
        }
        else {
            return of(this.applyVariables(data));
        }
    };
    /**
     * @private
     * @param {?} json
     * @return {?}
     */
    NarikJsonService.prototype.isJSON = /**
     * @private
     * @param {?} json
     * @return {?}
     */
    function (json) {
        if (json && json.constructor.name === "Object") {
            return true;
        }
        else {
            return false;
        }
    };
    /**
     * @private
     * @param {?} data
     * @return {?}
     */
    NarikJsonService.prototype.cloneJSON = /**
     * @private
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return this.applyJsonExtends({}, data);
    };
    /**
     * @private
     * @param {?} data
     * @param {?} removeItems
     * @return {?}
     */
    NarikJsonService.prototype.applyRemoves = /**
     * @private
     * @param {?} data
     * @param {?} removeItems
     * @return {?}
     */
    function (data, removeItems) {
        if (removeItems) {
            this.applyJsonRemoves(data, removeItems);
        }
        return data;
    };
    /**
     * @private
     * @param {?} data
     * @param {?} removeItems
     * @return {?}
     */
    NarikJsonService.prototype.applyJsonRemoves = /**
     * @private
     * @param {?} data
     * @param {?} removeItems
     * @return {?}
     */
    function (data, removeItems) {
        var e_1, _a, e_2, _b;
        if (this.isJSON(data)) {
            try {
                for (var removeItems_1 = __values(removeItems), removeItems_1_1 = removeItems_1.next(); !removeItems_1_1.done; removeItems_1_1 = removeItems_1.next()) {
                    var removeItem = removeItems_1_1.value;
                    if (removeItem.indexOf("[") >= 0) {
                        /** @type {?} */
                        var dataItemKey = removeItem.substr(0, removeItem.indexOf("["));
                        /** @type {?} */
                        var dataItem = getNestedValue(data, dataItemKey);
                        if (isArray(dataItem)) {
                            /** @type {?} */
                            var dataItemIndex = removeItem.substring(removeItem.indexOf("[") + 1, removeItem.lastIndexOf("]"));
                            if (!isNaN(+dataItemIndex)) {
                                dataItem.splice(+dataItemIndex, 1);
                            }
                            else {
                                dataItemIndex = dataItemIndex.replace(/'/g, '"');
                                /** @type {?} */
                                var filterFunction = toFilterFunction((/** @type {?} */ (JSON.parse(dataItemIndex))));
                                /** @type {?} */
                                var removedDataItems = dataItem.filter(filterFunction);
                                try {
                                    for (var removedDataItems_1 = (e_2 = void 0, __values(removedDataItems)), removedDataItems_1_1 = removedDataItems_1.next(); !removedDataItems_1_1.done; removedDataItems_1_1 = removedDataItems_1.next()) {
                                        var removedDataItem = removedDataItems_1_1.value;
                                        /** @type {?} */
                                        var dataItemPos = dataItem.indexOf(removedDataItem);
                                        if (dataItemPos >= 0) {
                                            dataItem.splice(dataItemPos, 1);
                                        }
                                    }
                                }
                                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                                finally {
                                    try {
                                        if (removedDataItems_1_1 && !removedDataItems_1_1.done && (_b = removedDataItems_1.return)) _b.call(removedDataItems_1);
                                    }
                                    finally { if (e_2) throw e_2.error; }
                                }
                            }
                        }
                    }
                    else {
                        delete data[removeItem];
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (removeItems_1_1 && !removeItems_1_1.done && (_a = removeItems_1.return)) _a.call(removeItems_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return data;
    };
    /**
     * @private
     * @param {?} data
     * @return {?}
     */
    NarikJsonService.prototype.applyVariables = /**
     * @private
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (data && data.variables) {
            this.applyJsonVariables(data, data.variables);
        }
        return data;
    };
    /**
     * @private
     * @param {?} data
     * @param {?} variables
     * @return {?}
     */
    NarikJsonService.prototype.applyJsonVariables = /**
     * @private
     * @param {?} data
     * @param {?} variables
     * @return {?}
     */
    function (data, variables) {
        var e_3, _a;
        if (this.isJSON(data)) {
            for (var key in data) {
                if (this.isJSON(data[key])) {
                    this.applyJsonVariables(data[key], variables);
                }
                else if (Array.isArray(data[key])) {
                    try {
                        for (var _b = (e_3 = void 0, __values(data[key])), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var item = _c.value;
                            this.applyJsonVariables(item, variables);
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                }
                else if (isString(data[key]) && data[key].startsWith("@")) {
                    if (variables[data[key]]) {
                        data[key] = variables[data[key]];
                    }
                }
            }
        }
        return data;
    };
    /**
     * @private
     * @param {?} data
     * @param {?} importedData
     * @return {?}
     */
    NarikJsonService.prototype.applyJsonImports = /**
     * @private
     * @param {?} data
     * @param {?} importedData
     * @return {?}
     */
    function (data, importedData) {
        var e_4, _a;
        if (this.isJSON(data)) {
            for (var key in data) {
                if (this.isJSON(data[key])) {
                    this.applyJsonImports(data[key], importedData);
                }
                else if (Array.isArray(data[key])) {
                    /** @type {?} */
                    var index = 0;
                    try {
                        for (var _b = (e_4 = void 0, __values(data[key])), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var item = _c.value;
                            if (isString(item) && item.startsWith("$$")) {
                                data[key][index] = this.applyImportValue(item, importedData);
                            }
                            else {
                                this.applyJsonImports(item, importedData);
                            }
                            index++;
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
                else if (isString(data[key]) && data[key].startsWith("$$")) {
                    data[key] = this.applyImportValue(data[key], importedData);
                }
            }
        }
        return data;
    };
    /**
     * @private
     * @param {?} expr
     * @param {?} importedData
     * @return {?}
     */
    NarikJsonService.prototype.applyImportValue = /**
     * @private
     * @param {?} expr
     * @param {?} importedData
     * @return {?}
     */
    function (expr, importedData) {
        var e_5, _a;
        try {
            for (var importedData_1 = __values(importedData), importedData_1_1 = importedData_1.next(); !importedData_1_1.done; importedData_1_1 = importedData_1.next()) {
                var importItem = importedData_1_1.value;
                /** @type {?} */
                var itemKey = expr.substr(0, expr.indexOf("."));
                if (importItem.key === itemKey) {
                    return importItem.data[expr.replace(itemKey + ".", "")];
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (importedData_1_1 && !importedData_1_1.done && (_a = importedData_1.return)) _a.call(importedData_1);
            }
            finally { if (e_5) throw e_5.error; }
        }
        return expr;
    };
    /**
     * @private
     * @param {?} parentData
     * @param {?} data
     * @return {?}
     */
    NarikJsonService.prototype.applyJsonExtends = /**
     * @private
     * @param {?} parentData
     * @param {?} data
     * @return {?}
     */
    function (parentData, data) {
        this.applyRemoves(parentData, data.removeItems);
        /** @type {?} */
        var result = null;
        if (this.isJSON(data)) {
            result = {};
            if (this.isJSON(parentData)) {
                for (var key in parentData) {
                    if (this.isJSON(parentData[key]) || Array.isArray(parentData[key])) {
                        result[key] = this.cloneJSON(parentData[key]);
                    }
                    else {
                        result[key] = parentData[key];
                    }
                }
            }
            for (var key in data) {
                if (this.isJSON(data[key]) || Array.isArray(data[key])) {
                    result[key] = this.applyJsonExtends(result[key], data[key]);
                }
                else {
                    result[key] = data[key];
                }
            }
        }
        else if (Array.isArray(parentData) && Array.isArray(data)) {
            result = parentData;
            for (var i = 0; i < data.length; i++) {
                if (result.indexOf(data[i]) === -1) {
                    result[result.length] = data[i];
                }
            }
        }
        else {
            result = data;
        }
        return result;
    };
    NarikJsonService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikJsonService.ctorParameters = function () { return [
        { type: NarikHttpService }
    ]; };
    return NarikJsonService;
}(JsonService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikJsonService.prototype.jsons;
    /**
     * @type {?}
     * @private
     */
    NarikJsonService.prototype.httpService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikConfigService = /** @class */ (function (_super) {
    __extends(NarikConfigService, _super);
    function NarikConfigService(httpService, configOptions, configPath) {
        var _this = _super.call(this) || this;
        _this.httpService = httpService;
        _this.configOptions = configOptions;
        _this.configPath = configPath;
        _this.configData = {};
        _this.configKeys = [];
        if (configOptions && configOptions.configFilePath) {
            _this.configPath = configOptions.configFilePath;
        }
        _this.configLoadedSubject = new ReplaySubject(1);
        return _this;
    }
    Object.defineProperty(NarikConfigService.prototype, "configLoaded", {
        get: /**
         * @return {?}
         */
        function () {
            return this.configLoadedSubject.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NarikConfigService.prototype.init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.httpService
            .get(this.configPath +
            (this.configOptions &&
                this.configOptions.addTimeParameterToConfigFilePath
                ? "?t=" + new Date().getTime()
                : ""))
            .pipe(tap$1((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            _this.configData = x;
            for (var key in x) {
                if (x.hasOwnProperty(key)) {
                    _this.configKeys.push(key);
                }
            }
            _this.configLoadedSubject.next(true);
        })))
            .toPromise();
    };
    /**
     * @template T
     * @param {?} key
     * @return {?}
     */
    NarikConfigService.prototype.getConfig = /**
     * @template T
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return (/** @type {?} */ (this.configData[key]));
    };
    /**
     * @return {?}
     */
    NarikConfigService.prototype.getAllKeys = /**
     * @return {?}
     */
    function () {
        return this.configKeys;
    };
    NarikConfigService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikConfigService.ctorParameters = function () { return [
        { type: NarikHttpService },
        { type: undefined, decorators: [{ type: Inject, args: [CONFIG_OPTIONS,] }] },
        { type: String, decorators: [{ type: Inject, args: [CONFIG_PATH,] }] }
    ]; };
    return NarikConfigService;
}(ConfigService));
if (false) {
    /** @type {?} */
    NarikConfigService.prototype.configData;
    /** @type {?} */
    NarikConfigService.prototype.configKeys;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.configLoadedSubject;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.configOptions;
    /**
     * @type {?}
     * @private
     */
    NarikConfigService.prototype.configPath;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var COMPONENTS = [];
/** @type {?} */
var EXPORT_COMPONENTS = [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
NarikBaseDataProvider = /** @class */ (function () {
    function NarikBaseDataProvider(injector) {
        this.injector = injector;
        this.dayaKeyTemplate = "{0}_{1}";
        this.dataStreams = new Map();
    }
    /**
     * @protected
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataProvider.prototype.getFullKey = /**
     * @protected
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var moduleKey = dataInfo.moduleKey;
        if (!moduleKey) {
            moduleKey = this.injector.get(MODULE_DATA_KEY);
        }
        return formatString(this.dayaKeyTemplate, moduleKey, dataInfo.dataKey);
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataProvider.prototype.getDataStream = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var fullKey = this.getFullKey(dataInfo);
        if (this.dataStreams.has(fullKey)) {
            return this.dataStreams.get(fullKey);
        }
        else {
            /** @type {?} */
            var dataSubject_1 = new ReplaySubject(1);
            this.dataStreams.set(fullKey, dataSubject_1);
            /** @type {?} */
            var dataProviderService = this.injector.get(DataProviderService);
            dataProviderService
                .getData(dataInfo)
                .pipe(first())
                .subscribe((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return dataSubject_1.next(data); }));
            return dataSubject_1.asObservable();
        }
    };
    /**
     * @param {?} dataInfo
     * @param {?} data
     * @return {?}
     */
    NarikBaseDataProvider.prototype.raiseDataStream = /**
     * @param {?} dataInfo
     * @param {?} data
     * @return {?}
     */
    function (dataInfo, data) {
        /** @type {?} */
        var fullKey = this.getFullKey(dataInfo);
        if (this.dataStreams.has(fullKey)) {
            this.dataStreams.get(fullKey).next(data);
        }
    };
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataProvider.prototype.dataChanged = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        var _this = this;
        /** @type {?} */
        var dataInfoArray = isArray(dataInfo)
            ? (/** @type {?} */ (dataInfo))
            : [(/** @type {?} */ (dataInfo))];
        /** @type {?} */
        var loadAndRaiseDataStream = (/**
         * @return {?}
         */
        function () {
            var e_1, _a;
            var _loop_1 = function (dataInfoItem) {
                /** @type {?} */
                var fullKey = _this.getFullKey(dataInfoItem);
                if (_this.dataStreams.has(fullKey)) {
                    /** @type {?} */
                    var dataStream_1 = _this.dataStreams.get(fullKey);
                    if (dataStream_1.observers.length) {
                        ((/** @type {?} */ (_this))).getData(dataInfoItem).subscribe((/**
                         * @param {?} result
                         * @return {?}
                         */
                        function (result) {
                            dataStream_1.next(result);
                        }));
                    }
                }
            };
            try {
                for (var dataInfoArray_1 = __values(dataInfoArray), dataInfoArray_1_1 = dataInfoArray_1.next(); !dataInfoArray_1_1.done; dataInfoArray_1_1 = dataInfoArray_1.next()) {
                    var dataInfoItem = dataInfoArray_1_1.value;
                    _loop_1(dataInfoItem);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (dataInfoArray_1_1 && !dataInfoArray_1_1.done && (_a = dataInfoArray_1.return)) _a.call(dataInfoArray_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        });
        if (isDataStorage(this)) {
            /** @type {?} */
            var storage = (/** @type {?} */ (((/** @type {?} */ (this)))));
            storage.removeItems(dataInfoArray).subscribe((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                loadAndRaiseDataStream();
            }));
        }
        else {
            loadAndRaiseDataStream();
        }
    };
    return NarikBaseDataProvider;
}());
if (false) {
    /** @type {?} */
    NarikBaseDataProvider.prototype.key;
    /** @type {?} */
    NarikBaseDataProvider.prototype.order;
    /** @type {?} */
    NarikBaseDataProvider.prototype.belongsInChain;
    /** @type {?} */
    NarikBaseDataProvider.prototype.dayaKeyTemplate;
    /**
     * @type {?}
     * @protected
     */
    NarikBaseDataProvider.prototype.dataStreams;
    /**
     * @type {?}
     * @private
     */
    NarikBaseDataProvider.prototype.injector;
    /**
     * @abstract
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataProvider.prototype.getData = function (dataInfo) { };
    /**
     * @abstract
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataProvider.prototype.isDataProviderFor = function (dataInfo) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikTranslateService = /** @class */ (function () {
    function NarikTranslateService(translateService, http) {
        this.translateService = translateService;
        this.http = http;
    }
    /**
     * @param {?} key
     * @param {?=} interpolateParams
     * @return {?}
     */
    NarikTranslateService.prototype.instant = /**
     * @param {?} key
     * @param {?=} interpolateParams
     * @return {?}
     */
    function (key, interpolateParams) {
        var _this = this;
        if (isString(key) && key.indexOf("_") > 0) {
            /** @type {?} */
            var items = ((/** @type {?} */ (key))).split("_");
            return items
                .map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return _this.translateService.instant(item, interpolateParams); }))
                .join(" ");
        }
        return this.translateService.instant(key, interpolateParams);
    };
    /**
     * @param {?} lang
     * @return {?}
     */
    NarikTranslateService.prototype.use = /**
     * @param {?} lang
     * @return {?}
     */
    function (lang) {
        return this.translateService.use(lang);
    };
    /**
     * @param {?} lang
     * @return {?}
     */
    NarikTranslateService.prototype.setDefaultLang = /**
     * @param {?} lang
     * @return {?}
     */
    function (lang) {
        this.translateService.setDefaultLang(lang);
    };
    /**
     * @param {?} item
     * @param {?=} reLoad
     * @return {?}
     */
    NarikTranslateService.prototype.addTranslationItem = /**
     * @param {?} item
     * @param {?=} reLoad
     * @return {?}
     */
    function (item, reLoad) {
        var _this = this;
        if (reLoad === void 0) { reLoad = false; }
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            /** @type {?} */
            var translateLoader = (/** @type {?} */ ((_this.translateService.currentLoader)));
            translateLoader.addTranslationItem(item);
            if (reLoad) {
                _this.translateService
                    .reloadLang(_this.translateService.currentLang)
                    .subscribe((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) {
                    _this.translateService.use(_this.translateService.currentLang);
                    resolve(true);
                }));
            }
            else {
                /** @type {?} */
                var url = translateLoader.getTranslateFilePath(_this.translateService.currentLang, item);
                _this.http.get(url).subscribe((/**
                 * @param {?} result
                 * @return {?}
                 */
                function (result) {
                    _this.translateService.setTranslation(_this.translateService.currentLang, result, true);
                    resolve(true);
                }));
            }
        }));
    };
    NarikTranslateService.decorators = [
        { type: Injectable, args: [{
                    providedIn: "root"
                },] }
    ];
    /** @nocollapse */
    NarikTranslateService.ctorParameters = function () { return [
        { type: TranslateService },
        { type: HttpClient }
    ]; };
    /** @nocollapse */ NarikTranslateService.ɵprov = ɵɵdefineInjectable({ factory: function NarikTranslateService_Factory() { return new NarikTranslateService(ɵɵinject(TranslateService), ɵɵinject(HttpClient)); }, token: NarikTranslateService, providedIn: "root" });
    return NarikTranslateService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikTranslateService.prototype.translateService;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StaticDataProvider = /** @class */ (function (_super) {
    __extends(StaticDataProvider, _super);
    function StaticDataProvider(injector, moduleManager, translateor) {
        var e_1, _a;
        var _this = _super.call(this, injector) || this;
        _this.moduleManager = moduleManager;
        _this.translateor = translateor;
        _this.key = "static";
        _this.order = 0;
        _this.belongsInChain = false;
        _this.modulesStaticData = new Map();
        try {
            for (var _b = __values(_this.moduleManager.modules.entriesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var module = _c.value;
                if (module.value.metaData) {
                    _this.addStaticData(module.key, module.value.metaData["staticData"]);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        _this.moduleManager.modulesChanged.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (x.moduleInfo.metaData) {
                _this.addStaticData(x.moduleKey, x.moduleInfo.metaData["staticData"]);
            }
        }));
        return _this;
    }
    /**
     * @private
     * @param {?} moduleKey
     * @param {?} staticData
     * @return {?}
     */
    StaticDataProvider.prototype.addStaticData = /**
     * @private
     * @param {?} moduleKey
     * @param {?} staticData
     * @return {?}
     */
    function (moduleKey, staticData) {
        if (staticData && !this.modulesStaticData.has(moduleKey)) {
            this.modulesStaticData.set(moduleKey, staticData);
        }
    };
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    StaticDataProvider.prototype.isDataProviderFor = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return false;
    };
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    StaticDataProvider.prototype.getData = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        var e_2, _a;
        /** @type {?} */
        var moduleData = this.modulesStaticData.get(dataInfo.moduleKey);
        if (moduleData) {
            /** @type {?} */
            var staticDataInfo = moduleData.get(dataInfo.dataKey);
            if (staticDataInfo && staticDataInfo.data) {
                /** @type {?} */
                var resultData = staticDataInfo.convertToDto === false
                    ? staticDataInfo.data
                    : toDtoArray(staticDataInfo.data);
                if (staticDataInfo.ignoreTranslate !== true) {
                    /** @type {?} */
                    var translateField = staticDataInfo.translateField || "title";
                    try {
                        for (var resultData_1 = __values(resultData), resultData_1_1 = resultData_1.next(); !resultData_1_1.done; resultData_1_1 = resultData_1.next()) {
                            var item = resultData_1_1.value;
                            item[translateField] = this.translateor.instant(item[translateField]);
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (resultData_1_1 && !resultData_1_1.done && (_a = resultData_1.return)) _a.call(resultData_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
                return of$1(resultData);
            }
        }
        return of$1([]);
    };
    StaticDataProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    StaticDataProvider.ctorParameters = function () { return [
        { type: Injector },
        { type: ModuleManager },
        { type: NarikTranslateService }
    ]; };
    return StaticDataProvider;
}(NarikBaseDataProvider));
if (false) {
    /** @type {?} */
    StaticDataProvider.prototype.key;
    /** @type {?} */
    StaticDataProvider.prototype.order;
    /** @type {?} */
    StaticDataProvider.prototype.belongsInChain;
    /**
     * @type {?}
     * @private
     */
    StaticDataProvider.prototype.modulesStaticData;
    /**
     * @type {?}
     * @private
     */
    StaticDataProvider.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    StaticDataProvider.prototype.translateor;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var LOCAL_STORAGE_VALIDITY_LEN = new InjectionToken("LOCAL_STORAGE_VALIDITY_LEN");
/** @type {?} */
var SESSION_STORAGE_VALIDITY_LEN = new InjectionToken("SESSION_STORAGE_VALIDITY_LEN");
/** @type {?} */
var MEMORY_STORAGE_VALIDITY_LEN = new InjectionToken("MEMORY_STORAGE_VALIDITY_LEN");

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
NarikBaseDataStorage = /** @class */ (function (_super) {
    __extends(NarikBaseDataStorage, _super);
    function NarikBaseDataStorage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.validityLen = 0;
        return _this;
    }
    /**
     * @param {?} data
     * @param {?=} validityLen
     * @return {?}
     */
    NarikBaseDataStorage.prototype.compeleteStorageData = /**
     * @param {?} data
     * @param {?=} validityLen
     * @return {?}
     */
    function (data, validityLen) {
        return {
            data: data,
            dataTime: new Date(),
            validityLen: validityLen
        };
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataStorage.prototype.getData = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        var _this = this;
        return this.getStorageModel(dataInfo).pipe(map$1((/**
         * @param {?} result
         * @return {?}
         */
        function (result) { return _this.checkAndReturn(result); })));
    };
    /**
     * @template T
     * @param {?} storageData
     * @return {?}
     */
    NarikBaseDataStorage.prototype.checkAndReturn = /**
     * @template T
     * @param {?} storageData
     * @return {?}
     */
    function (storageData) {
        if (storageData == null || storageData === undefined) {
            return null;
        }
        /** @type {?} */
        var result = storageData.data;
        if (storageData.dataTime && this.validityLen) {
            if (isString(storageData.dataTime)) {
                storageData.dataTime = new Date(storageData.dataTime);
            }
            /** @type {?} */
            var validTime = new Date(storageData.dataTime.getTime() +
                (storageData.validityLen || this.validityLen) * 60000);
            if (validTime < new Date()) {
                result = null;
            }
        }
        return result;
    };
    /**
     * @param {?} dataItems
     * @return {?}
     */
    NarikBaseDataStorage.prototype.applyValidity = /**
     * @param {?} dataItems
     * @return {?}
     */
    function (dataItems) {
        var e_1, _a;
        /** @type {?} */
        var mustRemoveItems = [];
        var _loop_1 = function (dataItem) {
            this_1.getStorageModel(dataItem.dataInfo).subscribe((/**
             * @param {?} storageData
             * @return {?}
             */
            function (storageData) {
                if (storageData) {
                    if (isString(storageData.dataTime)) {
                        storageData.dataTime = new Date(storageData.dataTime);
                    }
                    if (storageData.dataTime < dataItem.validDate) {
                        mustRemoveItems.push(dataItem.dataInfo);
                    }
                }
            }));
        };
        var this_1 = this;
        try {
            for (var dataItems_1 = __values(dataItems), dataItems_1_1 = dataItems_1.next(); !dataItems_1_1.done; dataItems_1_1 = dataItems_1.next()) {
                var dataItem = dataItems_1_1.value;
                _loop_1(dataItem);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (dataItems_1_1 && !dataItems_1_1.done && (_a = dataItems_1.return)) _a.call(dataItems_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (mustRemoveItems.length !== 0) {
            this.removeItems(mustRemoveItems);
        }
    };
    return NarikBaseDataStorage;
}(NarikBaseDataProvider));
if (false) {
    /** @type {?} */
    NarikBaseDataStorage.prototype.validityLen;
    /**
     * @abstract
     * @return {?}
     */
    NarikBaseDataStorage.prototype.clear = function () { };
    /**
     * @abstract
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    NarikBaseDataStorage.prototype.getStorageModel = function (dataInfo) { };
    /**
     * @abstract
     * @param {?} items
     * @return {?}
     */
    NarikBaseDataStorage.prototype.removeItems = function (items) { };
    /**
     * @abstract
     * @param {?} dataItmes
     * @return {?}
     */
    NarikBaseDataStorage.prototype.addItem = function (dataItmes) { };
}
/**
 * @record
 */
function StorageModel() { }
if (false) {
    /** @type {?|undefined} */
    StorageModel.prototype.validityLen;
    /** @type {?|undefined} */
    StorageModel.prototype.dataTime;
    /** @type {?} */
    StorageModel.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LocalStorageDataProvider = /** @class */ (function (_super) {
    __extends(LocalStorageDataProvider, _super);
    function LocalStorageDataProvider(injector, validityLen) {
        var _this = _super.call(this, injector) || this;
        _this.key = "localStorage";
        _this.order = 3;
        _this.belongsInChain = true;
        _this.validityLen = validityLen || 2 * 60;
        return _this;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    LocalStorageDataProvider.prototype.getStorageModel = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var dataStorage = JSON.parse(localStorage.getItem(this.getFullKey(dataInfo)));
        return of$1(dataStorage);
    };
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    LocalStorageDataProvider.prototype.isDataProviderFor = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return false;
    };
    /**
     * @param {?} dataItmes
     * @return {?}
     */
    LocalStorageDataProvider.prototype.addItem = /**
     * @param {?} dataItmes
     * @return {?}
     */
    function (dataItmes) {
        var e_1, _a;
        try {
            for (var dataItmes_1 = __values(dataItmes), dataItmes_1_1 = dataItmes_1.next(); !dataItmes_1_1.done; dataItmes_1_1 = dataItmes_1.next()) {
                var data = dataItmes_1_1.value;
                localStorage.setItem(this.getFullKey(data.dataInfo), JSON.stringify(this.compeleteStorageData(data.data, data.dataInfo.validityLen)));
                this.raiseDataStream(data.dataInfo, data.data);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (dataItmes_1_1 && !dataItmes_1_1.done && (_a = dataItmes_1.return)) _a.call(dataItmes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return of$1(true);
    };
    /**
     * @return {?}
     */
    LocalStorageDataProvider.prototype.clear = /**
     * @return {?}
     */
    function () {
        localStorage.clear();
        return of$1(true);
    };
    /**
     * @param {?} items
     * @return {?}
     */
    LocalStorageDataProvider.prototype.removeItems = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        var _this = this;
        items.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            localStorage.removeItem(_this.getFullKey(x));
        }));
        return of$1(true);
    };
    LocalStorageDataProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    LocalStorageDataProvider.ctorParameters = function () { return [
        { type: Injector },
        { type: Number, decorators: [{ type: Optional }, { type: Inject, args: [LOCAL_STORAGE_VALIDITY_LEN,] }] }
    ]; };
    return LocalStorageDataProvider;
}(NarikBaseDataStorage));
if (false) {
    /** @type {?} */
    LocalStorageDataProvider.prototype.key;
    /** @type {?} */
    LocalStorageDataProvider.prototype.order;
    /** @type {?} */
    LocalStorageDataProvider.prototype.belongsInChain;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MemoryDataProvider = /** @class */ (function (_super) {
    __extends(MemoryDataProvider, _super);
    function MemoryDataProvider(injector, validityLen) {
        var _this = _super.call(this, injector) || this;
        _this.key = "memory";
        _this.order = 1;
        _this.belongsInChain = true;
        _this.storage = new Map();
        _this.validityLen = validityLen || 2 * 60;
        return _this;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    MemoryDataProvider.prototype.getStorageModel = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var dataStorage = (/** @type {?} */ (this.storage.get(this.getFullKey(dataInfo))));
        return of$1(dataStorage);
    };
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    MemoryDataProvider.prototype.isDataProviderFor = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return false;
    };
    /**
     * @param {?} dataItmes
     * @return {?}
     */
    MemoryDataProvider.prototype.addItem = /**
     * @param {?} dataItmes
     * @return {?}
     */
    function (dataItmes) {
        var e_1, _a;
        try {
            for (var dataItmes_1 = __values(dataItmes), dataItmes_1_1 = dataItmes_1.next(); !dataItmes_1_1.done; dataItmes_1_1 = dataItmes_1.next()) {
                var data = dataItmes_1_1.value;
                /** @type {?} */
                var fullkey = this.getFullKey(data.dataInfo);
                this.storage.set(fullkey, this.compeleteStorageData(data.data, data.dataInfo.validityLen));
                this.raiseDataStream(data.dataInfo, data.data);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (dataItmes_1_1 && !dataItmes_1_1.done && (_a = dataItmes_1.return)) _a.call(dataItmes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return of$1(true);
    };
    /**
     * @return {?}
     */
    MemoryDataProvider.prototype.clear = /**
     * @return {?}
     */
    function () {
        this.storage.clear();
        return of$1(true);
    };
    /**
     * @param {?} items
     * @return {?}
     */
    MemoryDataProvider.prototype.removeItems = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        var _this = this;
        items.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            _this.storage.delete(_this.getFullKey(x));
        }));
        return of$1(true);
    };
    MemoryDataProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    MemoryDataProvider.ctorParameters = function () { return [
        { type: Injector },
        { type: Number, decorators: [{ type: Optional }, { type: Inject, args: [MEMORY_STORAGE_VALIDITY_LEN,] }] }
    ]; };
    return MemoryDataProvider;
}(NarikBaseDataStorage));
if (false) {
    /** @type {?} */
    MemoryDataProvider.prototype.key;
    /** @type {?} */
    MemoryDataProvider.prototype.order;
    /** @type {?} */
    MemoryDataProvider.prototype.belongsInChain;
    /**
     * @type {?}
     * @private
     */
    MemoryDataProvider.prototype.storage;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RemoteDataProvider = /** @class */ (function (_super) {
    __extends(RemoteDataProvider, _super);
    function RemoteDataProvider(injector, remoteDataProvider) {
        var _this = _super.call(this, injector) || this;
        _this.remoteDataProvider = remoteDataProvider;
        _this.key = "remote";
        _this.order = 5;
        _this.belongsInChain = true;
        return _this;
    }
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    RemoteDataProvider.prototype.isDataProviderFor = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return true;
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    RemoteDataProvider.prototype.getData = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return this.remoteDataProvider.getData(dataInfo);
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    RemoteDataProvider.prototype.getDataStream = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return this.remoteDataProvider.getDataStream(dataInfo);
    };
    RemoteDataProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RemoteDataProvider.ctorParameters = function () { return [
        { type: Injector },
        { type: RemoteDataProviderService }
    ]; };
    return RemoteDataProvider;
}(NarikBaseDataProvider));
if (false) {
    /** @type {?} */
    RemoteDataProvider.prototype.key;
    /** @type {?} */
    RemoteDataProvider.prototype.order;
    /** @type {?} */
    RemoteDataProvider.prototype.belongsInChain;
    /**
     * @type {?}
     * @private
     */
    RemoteDataProvider.prototype.remoteDataProvider;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SessionStorageDataProvider = /** @class */ (function (_super) {
    __extends(SessionStorageDataProvider, _super);
    function SessionStorageDataProvider(injector, validityLen) {
        var _this = _super.call(this, injector) || this;
        _this.key = "sessionStorage";
        _this.order = 2;
        _this.supportAdd = true;
        _this.belongsInChain = true;
        _this.validityLen = validityLen || 2 * 60;
        return _this;
    }
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    SessionStorageDataProvider.prototype.getStorageModel = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var dataStorage = JSON.parse(sessionStorage.getItem(this.getFullKey(dataInfo)));
        return of$1(dataStorage);
    };
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    SessionStorageDataProvider.prototype.isDataProviderFor = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return false;
    };
    /**
     * @param {?} dataItmes
     * @return {?}
     */
    SessionStorageDataProvider.prototype.addItem = /**
     * @param {?} dataItmes
     * @return {?}
     */
    function (dataItmes) {
        var e_1, _a;
        try {
            for (var dataItmes_1 = __values(dataItmes), dataItmes_1_1 = dataItmes_1.next(); !dataItmes_1_1.done; dataItmes_1_1 = dataItmes_1.next()) {
                var data = dataItmes_1_1.value;
                sessionStorage.setItem(this.getFullKey(data.dataInfo), JSON.stringify(this.compeleteStorageData(data.data, data.dataInfo.validityLen)));
                this.raiseDataStream(data.dataInfo, data.data);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (dataItmes_1_1 && !dataItmes_1_1.done && (_a = dataItmes_1.return)) _a.call(dataItmes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return of$1(true);
    };
    /**
     * @return {?}
     */
    SessionStorageDataProvider.prototype.clear = /**
     * @return {?}
     */
    function () {
        sessionStorage.clear();
        return of$1(true);
    };
    /**
     * @param {?} items
     * @return {?}
     */
    SessionStorageDataProvider.prototype.removeItems = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        var _this = this;
        items.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            sessionStorage.removeItem(_this.getFullKey(x));
        }));
        return of$1(true);
    };
    SessionStorageDataProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SessionStorageDataProvider.ctorParameters = function () { return [
        { type: Injector },
        { type: Number, decorators: [{ type: Optional }, { type: Inject, args: [SESSION_STORAGE_VALIDITY_LEN,] }] }
    ]; };
    return SessionStorageDataProvider;
}(NarikBaseDataStorage));
if (false) {
    /** @type {?} */
    SessionStorageDataProvider.prototype.key;
    /** @type {?} */
    SessionStorageDataProvider.prototype.order;
    /** @type {?} */
    SessionStorageDataProvider.prototype.supportAdd;
    /** @type {?} */
    SessionStorageDataProvider.prototype.belongsInChain;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var HttpErrorInterceptor = /** @class */ (function () {
    function HttpErrorInterceptor(dialogService) {
        this.dialogService = dialogService;
    }
    /**
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    HttpErrorInterceptor.prototype.intercept = /**
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    function (request, next) {
        var _this = this;
        return next.handle(request).pipe(catchError((/**
         * @param {?} err
         * @return {?}
         */
        function (err) {
            if (err.status === 403) {
                _this.dialogService.error("errors.STATUS_401");
            }
            if (err.status === 400) {
                if (err.error && err.error.errors) {
                    _this.dialogService.error(err.error.errors);
                }
            }
            return throwError(err);
        })));
    };
    HttpErrorInterceptor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HttpErrorInterceptor.ctorParameters = function () { return [
        { type: DialogService }
    ]; };
    return HttpErrorInterceptor;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    HttpErrorInterceptor.prototype.dialogService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikDataProviderService = /** @class */ (function (_super) {
    __extends(NarikDataProviderService, _super);
    function NarikDataProviderService(providers, moduleManager, injector, eventAggregatorService, remoteMessagingService) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.moduleManager = moduleManager;
        _this.injector = injector;
        _this.eventAggregatorService = eventAggregatorService;
        _this.remoteMessagingService = remoteMessagingService;
        _this.dataProviders = new Map();
        _this.modulesDataItems = new Map();
        _this.modulesDafaultProviderKey = new Map();
        _this.modulesDafaultOriginProviderKey = new Map();
        providers.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return _this.dataProviders.set(x.key, x); }));
        _this.moduleManager.narikLoaded.subscribe((/**
         * @return {?}
         */
        function () {
            _this.eventAggregatorService
                .listen("CLIENT_DATA_CHANGED")
                .pipe(merge(remoteMessagingService
                ? _this.remoteMessagingService.listen("DATA-CHANGE")
                : empty()))
                .subscribe((/**
             * @param {?} dataInfo
             * @return {?}
             */
            function (dataInfo) {
                var e_2, _a;
                try {
                    for (var _b = __values(_this.dataProviders.valuesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var provider = _c.value;
                        if (!isDataStorage(provider)) {
                            provider.dataChanged(dataInfo);
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }));
        }));
        try {
            for (var _b = __values(_this.moduleManager.modules.entriesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var module = _c.value;
                if (module.value.metaData) {
                    _this.addDataItems(module.key, module.value.metaData);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        _this.moduleManager.modulesChanged.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (x.moduleInfo.metaData) {
                _this.addDataItems(x.moduleKey, x.moduleInfo.metaData);
            }
        }));
        return _this;
    }
    /**
     * @private
     * @param {?} moduleKey
     * @param {?} metaData
     * @return {?}
     */
    NarikDataProviderService.prototype.addDataItems = /**
     * @private
     * @param {?} moduleKey
     * @param {?} metaData
     * @return {?}
     */
    function (moduleKey, metaData) {
        if (metaData.dataInfo) {
            /** @type {?} */
            var dataInfo = metaData.dataInfo;
            if (dataInfo.defaultDataProvider) {
                this.modulesDafaultProviderKey.set(moduleKey, dataInfo.defaultDataProvider);
            }
            if (dataInfo.defaultOriginDataProvider) {
                this.modulesDafaultOriginProviderKey.set(moduleKey, dataInfo.defaultOriginDataProvider);
            }
        }
        if (!this.modulesDataItems.has(moduleKey)) {
            /** @type {?} */
            var dataItems = metaData["dataItems"];
            if (!dataItems) {
                dataItems = new Map();
            }
            this.modulesDataItems.set(moduleKey, dataItems);
        }
    };
    /**
     * @protected
     * @param {?} dataInfo
     * @param {?=} fromOrigin
     * @return {?}
     */
    NarikDataProviderService.prototype.tryToFindDataProviderKey = /**
     * @protected
     * @param {?} dataInfo
     * @param {?=} fromOrigin
     * @return {?}
     */
    function (dataInfo, fromOrigin) {
        var e_3, _a;
        if (fromOrigin === void 0) { fromOrigin = false; }
        /** @type {?} */
        var dataProviderKey = null;
        /** @type {?} */
        var moduleKey = dataInfo.moduleKey
            ? dataInfo.moduleKey
            : this.injector.get(MODULE_DATA_KEY);
        if (this.modulesDataItems.has(moduleKey)) {
            if (this.modulesDataItems.get(moduleKey).get(dataInfo.dataKey)) {
                /** @type {?} */
                var dataProviderInformation = this.modulesDataItems
                    .get(moduleKey)
                    .get(dataInfo.dataKey);
                dataProviderKey = fromOrigin
                    ? dataProviderInformation.originDataProviderKey
                    : dataProviderInformation.dataProviderKey;
            }
        }
        if (!dataProviderKey &&
            !fromOrigin &&
            this.modulesDafaultProviderKey.has(moduleKey)) {
            dataProviderKey = this.modulesDafaultProviderKey.get(moduleKey);
        }
        if (!dataProviderKey &&
            fromOrigin &&
            this.modulesDafaultProviderKey.has(moduleKey)) {
            dataProviderKey = this.modulesDafaultOriginProviderKey.get(moduleKey);
        }
        if (!dataProviderKey) {
            /** @type {?} */
            var providers = this.dataProviders.valuesArray().sort((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.order; }));
            try {
                for (var providers_1 = __values(providers), providers_1_1 = providers_1.next(); !providers_1_1.done; providers_1_1 = providers_1.next()) {
                    var x = providers_1_1.value;
                    if (x.isDataProviderFor(dataInfo)) {
                        return x.key;
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (providers_1_1 && !providers_1_1.done && (_a = providers_1.return)) _a.call(providers_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        return dataProviderKey;
    };
    /**
     * @protected
     * @template T
     * @param {?} dataInfo
     * @param {?} faultDataProvider
     * @return {?}
     */
    NarikDataProviderService.prototype.tryToFindFromOtherProvidersOnNotFound = /**
     * @protected
     * @template T
     * @param {?} dataInfo
     * @param {?} faultDataProvider
     * @return {?}
     */
    function (dataInfo, faultDataProvider) {
        var e_4, _a;
        /** @type {?} */
        var faultDataProviders = [faultDataProvider];
        /** @type {?} */
        var otherDataProvidrs = this.dataProviders
            .valuesArray()
            .filter((/**
         * @param {?} dp
         * @return {?}
         */
        function (dp) { return dp.belongsInChain && dp.order > faultDataProvider.order; }))
            .sort((/**
         * @param {?} dp
         * @return {?}
         */
        function (dp) { return dp.order; }));
        /** @type {?} */
        var returnObs;
        if (otherDataProvidrs[0]) {
            returnObs = otherDataProvidrs[0].getData(dataInfo);
        }
        /** @type {?} */
        var index = 0;
        var _loop_1 = function (item) {
            if (index !== 0) {
                returnObs = returnObs.pipe(mergeMap$1((/**
                 * @param {?} result
                 * @return {?}
                 */
                function (result) {
                    if (result != null && result !== undefined) {
                        return of$1(result);
                    }
                    else {
                        faultDataProviders.push(item);
                        return item.getData(dataInfo);
                    }
                })));
            }
            index++;
        };
        try {
            for (var otherDataProvidrs_1 = __values(otherDataProvidrs), otherDataProvidrs_1_1 = otherDataProvidrs_1.next(); !otherDataProvidrs_1_1.done; otherDataProvidrs_1_1 = otherDataProvidrs_1.next()) {
                var item = otherDataProvidrs_1_1.value;
                _loop_1(item);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (otherDataProvidrs_1_1 && !otherDataProvidrs_1_1.done && (_a = otherDataProvidrs_1.return)) _a.call(otherDataProvidrs_1);
            }
            finally { if (e_4) throw e_4.error; }
        }
        return returnObs.pipe(tap((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            var e_5, _a;
            if (result != null && result !== undefined) {
                if (faultDataProviders.length !== 1) {
                    faultDataProviders.pop();
                }
                try {
                    for (var faultDataProviders_1 = __values(faultDataProviders), faultDataProviders_1_1 = faultDataProviders_1.next(); !faultDataProviders_1_1.done; faultDataProviders_1_1 = faultDataProviders_1.next()) {
                        var item = faultDataProviders_1_1.value;
                        if (isDataStorage(item)) {
                            item.addItem([
                                {
                                    dataInfo: dataInfo,
                                    data: result
                                }
                            ]);
                        }
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (faultDataProviders_1_1 && !faultDataProviders_1_1.done && (_a = faultDataProviders_1.return)) _a.call(faultDataProviders_1);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
            }
        })));
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @param {?=} options
     * @return {?}
     */
    NarikDataProviderService.prototype.getData = /**
     * @template T
     * @param {?} dataInfo
     * @param {?=} options
     * @return {?}
     */
    function (dataInfo, options) {
        var _this = this;
        /** @type {?} */
        var dataProviderKey = dataInfo.dataProviderKey;
        if (options && options.fromOrigin) {
            dataProviderKey = dataInfo.originDataProviderKey;
            if (!dataProviderKey) {
                dataProviderKey = this.tryToFindDataProviderKey(dataInfo, true);
            }
        }
        if (!dataProviderKey) {
            dataProviderKey = this.tryToFindDataProviderKey(dataInfo);
        }
        if (dataProviderKey) {
            /** @type {?} */
            var dataProvider_1 = this.dataProviders.get(dataProviderKey);
            return dataProvider_1.getData(dataInfo).pipe(mergeMap$1((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                if (x != null && x !== undefined) {
                    if (options && options.fromOrigin) {
                        if (dataInfo.dataProviderKey &&
                            dataInfo.dataProviderKey !== dataProviderKey) {
                            /** @type {?} */
                            var originalDataProvider = _this.dataProviders.get(dataInfo.dataProviderKey);
                            if (isDataStorage(originalDataProvider)) {
                                originalDataProvider.addItem([
                                    {
                                        dataInfo: dataInfo,
                                        data: x
                                    }
                                ]);
                            }
                        }
                    }
                    return of$1(x);
                }
                else {
                    return _this.tryToFindFromOtherProvidersOnNotFound(dataInfo, dataProvider_1);
                }
            })), first$1());
        }
        else {
            return of$1(null);
        }
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @param {?=} options
     * @return {?}
     */
    NarikDataProviderService.prototype.getDataStream = /**
     * @template T
     * @param {?} dataInfo
     * @param {?=} options
     * @return {?}
     */
    function (dataInfo, options) {
        /** @type {?} */
        var dataProviderKey;
        if (options.fromOrigin) {
            dataProviderKey = dataInfo.originDataProviderKey;
            if (!dataProviderKey) {
                dataInfo.dataProviderKey = this.tryToFindDataProviderKey(dataInfo, true);
            }
        }
        if (dataProviderKey) {
            dataProviderKey = this.tryToFindDataProviderKey(dataInfo);
        }
        if (!dataProviderKey) {
            throw new Error("For dataStream the dataProviderKey must be set");
        }
        /** @type {?} */
        var dataProvider = this.dataProviders.get(dataProviderKey);
        return dataProvider.getDataStream(dataInfo);
    };
    NarikDataProviderService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikDataProviderService.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [DATA_PROVIDER,] }] },
        { type: ModuleManager },
        { type: Injector },
        { type: EventAggregatorService },
        { type: RemoteMessagingService, decorators: [{ type: Optional }] }
    ]; };
    return NarikDataProviderService;
}(DataProviderService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.dataProviders;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.modulesDataItems;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.modulesDafaultProviderKey;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.modulesDafaultOriginProviderKey;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikDataProviderService.prototype.remoteMessagingService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikDataStorageService = /** @class */ (function (_super) {
    __extends(NarikDataStorageService, _super);
    function NarikDataStorageService(storages, defaultStorageKey, moduleManager, eventAggregatorService, remoteMessagingService) {
        var _this = _super.call(this) || this;
        _this.defaultStorageKey = defaultStorageKey;
        _this.moduleManager = moduleManager;
        _this.eventAggregatorService = eventAggregatorService;
        _this.remoteMessagingService = remoteMessagingService;
        _this.dataStorages = new Map();
        storages.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return _this.dataStorages.set(x.key, x); }));
        _this.moduleManager.narikLoaded.subscribe((/**
         * @return {?}
         */
        function () {
            _this.eventAggregatorService
                .listen("CLIENT_DATA_CHANGED")
                .pipe(merge(remoteMessagingService
                ? _this.remoteMessagingService.listen("DATA-CHANGE")
                : empty()))
                .subscribe((/**
             * @param {?} dataInfo
             * @return {?}
             */
            function (dataInfo) {
                var e_1, _a;
                try {
                    for (var _b = __values(_this.dataStorages.valuesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var storage = _c.value;
                        storage.dataChanged(dataInfo);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }));
            _this.eventAggregatorService
                .listen("CLIENT_DATA_INVALIDATE")
                .pipe(merge(remoteMessagingService
                ? _this.remoteMessagingService.listen("DATA-INVALIDATE")
                : empty()))
                .subscribe((/**
             * @param {?} dataItems
             * @return {?}
             */
            function (dataItems) {
                _this.applyValidity(dataItems);
            }));
        }));
        return _this;
    }
    /**
     * @template T
     * @param {?} key
     * @param {?} dataInfo
     * @return {?}
     */
    NarikDataStorageService.prototype.getDataStream = /**
     * @template T
     * @param {?} key
     * @param {?} dataInfo
     * @return {?}
     */
    function (key, dataInfo) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        /** @type {?} */
        var dataStorage = this.getStorage(key);
        return dataStorage.getDataStream(dataInfo);
    };
    /**
     * @template T
     * @param {?} key
     * @param {?} dataInfo
     * @return {?}
     */
    NarikDataStorageService.prototype.getData = /**
     * @template T
     * @param {?} key
     * @param {?} dataInfo
     * @return {?}
     */
    function (key, dataInfo) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.getStorage(key).getData(dataInfo);
    };
    /**
     * @param {?} key
     * @return {?}
     */
    NarikDataStorageService.prototype.clear = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        this.checkKey(key);
        return this.getStorage(key).clear();
    };
    /**
     * @param {?} key
     * @param {?} items
     * @return {?}
     */
    NarikDataStorageService.prototype.removeItems = /**
     * @param {?} key
     * @param {?} items
     * @return {?}
     */
    function (key, items) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.getStorage(key).removeItems(items);
    };
    /**
     * @param {?} key
     * @param {?} dataItmes
     * @return {?}
     */
    NarikDataStorageService.prototype.addData = /**
     * @param {?} key
     * @param {?} dataItmes
     * @return {?}
     */
    function (key, dataItmes) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.getStorage(key).addItem(dataItmes);
    };
    /**
     * @private
     * @param {?} key
     * @return {?}
     */
    NarikDataStorageService.prototype.getStorage = /**
     * @private
     * @param {?} key
     * @return {?}
     */
    function (key) {
        key = key || this.defaultStorageKey;
        this.checkKey(key);
        return this.dataStorages.get(key);
    };
    /**
     * @param {?} dataItems
     * @return {?}
     */
    NarikDataStorageService.prototype.applyValidity = /**
     * @param {?} dataItems
     * @return {?}
     */
    function (dataItems) {
        var e_2, _a;
        try {
            for (var _b = __values(this.dataStorages.valuesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var storage = _c.value;
                storage.applyValidity(dataItems);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    /**
     * @private
     * @param {?} key
     * @return {?}
     */
    NarikDataStorageService.prototype.checkKey = /**
     * @private
     * @param {?} key
     * @return {?}
     */
    function (key) {
        if (!key) {
            throw new Error("You must specify storage  key. Either by DEFAULT_DATA_STORAGE_KEY or send it  with method parameter");
        }
    };
    NarikDataStorageService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikDataStorageService.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [DATA_STORAGE,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [DEFAULT_DATA_STORAGE_KEY,] }] },
        { type: ModuleManager },
        { type: EventAggregatorService },
        { type: RemoteMessagingService, decorators: [{ type: Optional }] }
    ]; };
    return NarikDataStorageService;
}(DataStorageService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.dataStorages;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.defaultStorageKey;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikDataStorageService.prototype.remoteMessagingService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AppInjector = /** @class */ (function () {
    function AppInjector() {
    }
    AppInjector.injector = undefined;
    return AppInjector;
}());
if (false) {
    /** @type {?} */
    AppInjector.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 * @param {?} token
 * @param {?=} notFoundValue
 * @param {?=} flags
 * @return {?}
 */
function NarikInject(token, notFoundValue, flags) {
    if (notFoundValue === void 0) { notFoundValue = null; }
    return (/**
     * @param {?} target
     * @param {?} key
     * @return {?}
     */
    function (target, key) {
        /** @type {?} */
        var prev = Object.getOwnPropertyDescriptor(target, key);
        /** @type {?} */
        var getter = (/**
         * @return {?}
         */
        function () {
            if (this["$$$Inject_" + token.toString()]) {
                return this["$$$Inject_" + token.toString()];
            }
            /** @type {?} */
            var localInjector = this.injector || this["$$$_Injector"];
            if (!localInjector) {
                for (var filedKey in this) {
                    if (this.hasOwnProperty(filedKey)) {
                        if (this[filedKey] instanceof Injector ||
                            (this[filedKey] &&
                                this[filedKey].constructor.name === "Injector_")) {
                            localInjector = this[filedKey];
                            this["$$$_Injector"] = localInjector;
                        }
                    }
                }
            }
            if (!localInjector) {
                console.warn("Could not find local Injector in  (" +
                    target.constructor.name +
                    "), use root injector instead!");
            }
            else {
                if (localInjector.constructor.name === "StaticInjector" &&
                    localInjector.parent) {
                    localInjector = localInjector.parent;
                }
            }
            /** @type {?} */
            var value = (localInjector || AppInjector.injector).get(token, notFoundValue, flags);
            this["$$$" + token.toString()] = value;
            return value;
        });
        Object.defineProperty(target, key, {
            get: getter,
            enumerable: prev == null ? true : prev.enumerable,
            configurable: prev == null ? true : prev.configurable
        });
    });
}
/**
 * @template T
 * @param {?} token
 * @param {?=} notFoundValue
 * @param {?=} flags
 * @return {?}
 */
function NarikGlobalInject(token, notFoundValue, flags) {
    if (notFoundValue === void 0) { notFoundValue = null; }
    return (/**
     * @param {?} target
     * @param {?} key
     * @return {?}
     */
    function (target, key) {
        /** @type {?} */
        var prev = Object.getOwnPropertyDescriptor(target, key);
        /** @type {?} */
        var getter = (/**
         * @return {?}
         */
        function () {
            if (this["$$$Inject_" + token.toString()]) {
                return this["$$$Inject_" + token.toString()];
            }
            /** @type {?} */
            var localInjectors = this.injectors;
            if (!localInjectors) {
                console.warn("Could not find local Injectors in  (" +
                    target.constructor.name +
                    ")!");
            }
            else {
                for (var i = localInjectors.length - 1; i >= 0; --i) {
                    /** @type {?} */
                    var injector = localInjectors[i];
                    /** @type {?} */
                    var value = injector.get(token, notFoundValue, flags);
                    this["$$$" + token.toString()] = value;
                    return value;
                }
                return undefined;
            }
        });
        Object.defineProperty(target, key, {
            get: getter,
            enumerable: prev == null ? true : prev.enumerable,
            configurable: prev == null ? true : prev.configurable
        });
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikDialogService = /** @class */ (function (_super) {
    __extends(NarikDialogService, _super);
    // componentFactories = new Map<
    //   Type<any>,
    //   {
    //     factory: ComponentFactory<any>;
    //     module?: NgModuleRef<any>;
    //   }
    // >();
    function NarikDialogService(injector, dialogOverlayContainerType, applicationRef, componentFactoryResolver, eventAggregatorService, moduleManager, moduleRef, document) {
        var _this = _super.call(this) || this;
        _this.injector = injector;
        _this.dialogOverlayContainerType = dialogOverlayContainerType;
        _this.applicationRef = applicationRef;
        _this.componentFactoryResolver = componentFactoryResolver;
        _this.eventAggregatorService = eventAggregatorService;
        _this.moduleManager = moduleManager;
        _this.document = document;
        _this.openDialogs = new Map();
        _this.injectors = [];
        _this.nextUniqueId = 1;
        _this.registerModule(moduleRef, componentFactoryResolver, injector);
        _this.moduleManager.narikLoaded.subscribe((/**
         * @return {?}
         */
        function () {
            _this.eventAggregatorService
                .listen("MODULE_LOAD_COMPLETELY")
                .subscribe((/**
             * @param {?} module
             * @return {?}
             */
            function (module) {
                if (module.moduleInfo && module.moduleInfo.module) {
                    _this.registerModule(module.moduleInfo.module, module.moduleInfo.module.componentFactoryResolver, module.moduleInfo.module.injector);
                }
            }));
        }));
        return _this;
    }
    /**
     * @private
     * @param {?} moduleRef
     * @param {?} componentFactoryResolver
     * @param {?} injector
     * @return {?}
     */
    NarikDialogService.prototype.registerModule = /**
     * @private
     * @param {?} moduleRef
     * @param {?} componentFactoryResolver
     * @param {?} injector
     * @return {?}
     */
    function (moduleRef, componentFactoryResolver, injector) {
        // const factories = componentFactoryResolver["_factories"].entriesArray();
        // for (const factory of factories) {
        //   this.componentFactories.set(factory.key, {
        //     factory: factory.value,
        //     module: moduleRef
        //   });
        // }
        if (injector) {
            this.injectors.push(injector);
        }
    };
    /**
     * @return {?}
     */
    NarikDialogService.prototype.activeDialogId = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var itemKeys = this.openDialogs.entriesArray();
        if (itemKeys.length > 0) {
            return itemKeys[itemKeys.length - 1].key;
        }
        return undefined;
    };
    /**
     * @param {?} el
     * @return {?}
     */
    NarikDialogService.prototype.isElementInActiveDialog = /**
     * @param {?} el
     * @return {?}
     */
    function (el) {
        /** @type {?} */
        var activeDialogId = this.activeDialogId();
        if (!activeDialogId) {
            return true;
        }
        /** @type {?} */
        var parent = el.nativeElement.closest("[narik-dialog-id=\"" + activeDialogId + "\"]");
        return !!parent;
    };
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} options
     * @return {?}
     */
    NarikDialogService.prototype.error = /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} options
     * @return {?}
     */
    function (message, title, options) {
        this.showMessage(message, title, MessageType.Error, options);
    };
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} type
     * @param {?=} options
     * @return {?}
     */
    NarikDialogService.prototype.showMessage = /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} type
     * @param {?=} options
     * @return {?}
     */
    function (message, title, type, options) {
        var _this = this;
        if (isArray(message)) {
            message = ((/** @type {?} */ (message)))
                .map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return _this.translateService.instant(x); }))
                .join(" ");
        }
        else if (isString(message)) {
            message = this.translateService.instant(message);
        }
        else {
            message = Object.keys(message)
                .map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return _this.translateService.instant(message[x]); }))
                .join(" ");
        }
        type = type || MessageType.Success;
        switch (type) {
            case MessageType.Success: {
                this.toastrService.success((/** @type {?} */ (message)), title, options);
                break;
            }
            case MessageType.Info: {
                this.toastrService.info((/** @type {?} */ (message)), title, options);
                break;
            }
            case MessageType.Warn: {
                this.toastrService.warning((/** @type {?} */ (message)), title, options);
                break;
            }
            case MessageType.Error: {
                this.toastrService.error((/** @type {?} */ (message)), title, options);
                break;
            }
            default:
                this.toastrService.success((/** @type {?} */ (message)), title, options);
        }
    };
    /**
     * @template T
     * @param {?} content
     * @param {?=} title
     * @param {?=} data
     * @param {?=} actions
     * @param {?=} options
     * @param {?=} validateOnClose
     * @param {?=} onClose
     * @param {?=} providers
     * @return {?}
     */
    NarikDialogService.prototype.showDialog = /**
     * @template T
     * @param {?} content
     * @param {?=} title
     * @param {?=} data
     * @param {?=} actions
     * @param {?=} options
     * @param {?=} validateOnClose
     * @param {?=} onClose
     * @param {?=} providers
     * @return {?}
     */
    function (content, title, data, actions, options, validateOnClose, onClose, providers) {
        var _this = this;
        options = options || {};
        /** @type {?} */
        var containers = this.createDialogContainer(options, actions, title);
        /** @type {?} */
        var dialogContainerRef = containers.container;
        /** @type {?} */
        var dialogOverlayContainerRef = containers.overLaycontainer;
        /** @type {?} */
        var result = new NarikDialogRef("dialog-" + UUID.UUID(), null);
        /** @type {?} */
        var renderer = this.rendererFactory.createRenderer(null, null);
        renderer.setAttribute(dialogContainerRef.location.nativeElement, "narik-dialog-id", result.id);
        result.container = dialogContainerRef.instance;
        if (content instanceof TemplateRef) {
            /** @type {?} */
            var dialogContent = dialogContainerRef.instance.contentContainerRef.createEmbeddedView(content);
        }
        else if (content instanceof Type) {
            // let factoryModule = this.componentFactories.get(content);
            // if (!factoryModule) {
            //   factoryModule = {
            //     factory: this.componentFactoryResolver.resolveComponentFactory(
            //       content as Type<T>
            //     )
            //   };
            // }
            /** @type {?} */
            var factory = this.componentFactoryResolver.resolveComponentFactory((/** @type {?} */ (content)));
            providers = providers || [];
            providers.push({ provide: DIALOG_REF, useValue: result });
            /** @type {?} */
            var localInjector = Injector.create(providers, this.injector);
            /** @type {?} */
            var dialogContent = dialogContainerRef.instance.contentContainerRef.createComponent(factory, undefined, localInjector);
            result.componentInstance = dialogContent.instance;
            if (data) {
                for (var key in data) {
                    if (data.hasOwnProperty(key)) {
                        /** @type {?} */
                        var element = data[key];
                        dialogContent.instance[key] = element;
                    }
                }
            }
        }
        result.element = dialogOverlayContainerRef.location.nativeElement;
        /** @type {?} */
        var overlayContainer = this.injector.get(OverlayContainer, undefined);
        if (overlayContainer) {
            /** @type {?} */
            var host = overlayContainer.getContainerElement();
            /** @type {?} */
            var pane = this.document.createElement("div");
            pane.id = "cdk-overlay-dialog-" + this.nextUniqueId++;
            pane.classList.add("cdk-overlay-pane");
            host.appendChild(pane);
            pane.appendChild(dialogOverlayContainerRef.location.nativeElement);
        }
        else {
            this.document.body.appendChild(dialogOverlayContainerRef.location.nativeElement);
        }
        setTimeout((/**
         * @return {?}
         */
        function () {
            dialogContainerRef.instance.isOpen = true;
        }), 100);
        dialogOverlayContainerRef.instance.dialogRef = result;
        dialogContainerRef.instance.dialogRef = result;
        result.dialogOverlayContainerRef = dialogOverlayContainerRef;
        this.openDialogs.set(result.id, result);
        if (onClose) {
            result.closed.then((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                onClose(x);
            }));
        }
        result.events
            .pipe(filter((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x.eventType === "CLOSE_REQUEST"; })))
            .subscribe((/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (result.componentInstance &&
                isFunction(((/** @type {?} */ (result.componentInstance))).onCloseRequest)) {
                ((/** @type {?} */ (result.componentInstance))).onCloseRequest(e);
            }
            if (validateOnClose) {
                /** @type {?} */
                var validateResult = validateOnClose(e.eventData);
                if (validateResult instanceof Promise) {
                    ((/** @type {?} */ (validateResult))).then((/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) {
                        if (x) {
                            _this.close(result, e.eventData, e.eventSource);
                        }
                    }));
                }
                else if (validateResult === true) {
                    _this.close(result, e.eventData, e.eventSource);
                }
            }
            else {
                _this.close(result, e.eventData, e.eventSource);
            }
        }));
        return result;
    };
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} actions
     * @param {?=} onResult
     * @return {?}
     */
    NarikDialogService.prototype.showConfirm = /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} actions
     * @param {?=} onResult
     * @return {?}
     */
    function (message, title, actions, onResult) {
        return this.showDialog(this.messageComponent, title, {
            message: message
        }, actions || __spread(DialogActions.yes_no), undefined, undefined, onResult);
    };
    /**
     * @param {?} message
     * @param {?=} title
     * @return {?}
     */
    NarikDialogService.prototype.showMessageBox = /**
     * @param {?} message
     * @param {?=} title
     * @return {?}
     */
    function (message, title) {
        return this.showDialog(this.messageComponent, title, {
            message: message
        }, [DialogActions.ok]);
    };
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} fields
     * @param {?=} entity
     * @param {?=} onResult
     * @param {?=} actions
     * @param {?=} options
     * @return {?}
     */
    NarikDialogService.prototype.showInput = /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} fields
     * @param {?=} entity
     * @param {?=} onResult
     * @param {?=} actions
     * @param {?=} options
     * @return {?}
     */
    function (message, title, fields, entity, onResult, actions, options) {
        /** @type {?} */
        var dialogRef = this.showDialog(this.inputComponent, title, {
            message: message,
            fields: fields,
            entity: entity
        }, actions || __spread(DialogActions.ok_cancel), options || {
            showBackdrop: true,
            disableAutoClose: true
        }, undefined, onResult);
        dialogRef.dialogResultTransformer = (/**
         * @param {?} dr
         * @return {?}
         */
        function (dr) {
            return {
                componentInstance: dr.componentInstance,
                data: dr.componentInstance.entity,
                dialogResult: dr.dialogResult
            };
        });
        return dialogRef;
    };
    /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} placeHolder
     * @param {?=} fieldType
     * @param {?=} defaultValue
     * @param {?=} onResult
     * @param {?=} actions
     * @param {?=} options
     * @return {?}
     */
    NarikDialogService.prototype.showTextInput = /**
     * @param {?} message
     * @param {?=} title
     * @param {?=} placeHolder
     * @param {?=} fieldType
     * @param {?=} defaultValue
     * @param {?=} onResult
     * @param {?=} actions
     * @param {?=} options
     * @return {?}
     */
    function (message, title, placeHolder, fieldType, defaultValue, onResult, actions, options) {
        return this.showInput(message, title, [
            {
                name: "input",
                fieldType: fieldType || FieldTypes.Text,
                options: {
                    plaveHolder: placeHolder
                }
            }
        ], {
            input: defaultValue
        }, onResult, actions, options);
    };
    /**
     * @param {?} content
     * @param {?=} title
     * @return {?}
     */
    NarikDialogService.prototype.showContent = /**
     * @param {?} content
     * @param {?=} title
     * @return {?}
     */
    function (content, title) {
        return this.showDialog(this.contentComponent, title, {
            content: content
        }, [DialogActions.ok]);
    };
    /**
     * @param {?=} force
     * @return {?}
     */
    NarikDialogService.prototype.closeAll = /**
     * @param {?=} force
     * @return {?}
     */
    function (force) {
        var e_1, _a;
        try {
            for (var _b = __values(this.openDialogs.valuesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var dialog = _c.value;
                dialog.close();
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @param {?} dialog
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    NarikDialogService.prototype.close = /**
     * @param {?} dialog
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    function (dialog, dialogResult, eventSource) {
        var _this = this;
        /** @type {?} */
        var _dialog;
        if (isString(dialog)) {
            _dialog = this.openDialogs.get((/** @type {?} */ (dialog)));
        }
        else {
            _dialog = (/** @type {?} */ (dialog));
        }
        if (_dialog.container.closeAnimationCompleted) {
            _dialog.container.closeAnimationCompleted.pipe(take(1)).subscribe((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                _this.doClose(_dialog, dialogResult, eventSource);
            }));
            _dialog.container.isOpen = false;
        }
        else {
            this.doClose(_dialog, dialogResult, eventSource);
        }
    };
    /**
     * @private
     * @param {?} _dialog
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    NarikDialogService.prototype.doClose = /**
     * @private
     * @param {?} _dialog
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    function (_dialog, dialogResult, eventSource) {
        _dialog.events.next({
            eventType: "CLOSED",
            eventData: dialogResult,
            eventSource: eventSource
        });
        /** @type {?} */
        var parentElement = ((/** @type {?} */ (_dialog.element))).parentElement || this.document.body;
        parentElement.removeChild(_dialog.element);
        this.openDialogs.delete(_dialog.id);
    };
    /**
     * @private
     * @param {?} options
     * @param {?} actions
     * @param {?} title
     * @return {?}
     */
    NarikDialogService.prototype.createDialogContainer = /**
     * @private
     * @param {?} options
     * @param {?} actions
     * @param {?} title
     * @return {?}
     */
    function (options, actions, title) {
        /** @type {?} */
        var overlayRef = this.createOverlay(options);
        /** @type {?} */
        var factory = this.componentFactoryResolver.resolveComponentFactory(this.dialogContainerType);
        /** @type {?} */
        var containerRef = overlayRef.instance.contentContainerRef.createComponent(factory);
        containerRef.instance.options = options || {};
        containerRef.instance.title = title;
        containerRef.instance.actions = actions;
        return {
            overLaycontainer: overlayRef,
            container: containerRef
        };
    };
    /**
     * @param {?} options
     * @return {?}
     */
    NarikDialogService.prototype.createOverlay = /**
     * @param {?} options
     * @return {?}
     */
    function (options) {
        /** @type {?} */
        var overlayFactory = this.componentFactoryResolver.resolveComponentFactory(this.dialogOverlayContainerType);
        /** @type {?} */
        var componentRef = overlayFactory.create(this.injector);
        this.applicationRef.attachView(componentRef.hostView);
        componentRef.instance.options = options || {};
        return componentRef;
    };
    NarikDialogService.decorators = [
        { type: Injectable, args: [{
                    providedIn: "root"
                },] }
    ];
    /** @nocollapse */
    NarikDialogService.ctorParameters = function () { return [
        { type: Injector },
        { type: Type, decorators: [{ type: Inject, args: [DIALOG_OVERLAY_CONTAINER,] }] },
        { type: ApplicationRef },
        { type: ComponentFactoryResolver },
        { type: EventAggregatorService },
        { type: ModuleManager },
        { type: NgModuleRef },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ NarikDialogService.ɵprov = ɵɵdefineInjectable({ factory: function NarikDialogService_Factory() { return new NarikDialogService(ɵɵinject(INJECTOR), ɵɵinject(DIALOG_OVERLAY_CONTAINER), ɵɵinject(ApplicationRef), ɵɵinject(ComponentFactoryResolver), ɵɵinject(EventAggregatorService), ɵɵinject(ModuleManager), ɵɵinject(NgModuleRef), ɵɵinject(DOCUMENT)); }, token: NarikDialogService, providedIn: "root" });
    __decorate([
        NarikInject(ToastrService),
        __metadata("design:type", ToastrService)
    ], NarikDialogService.prototype, "toastrService", void 0);
    __decorate([
        NarikInject(TranslateService),
        __metadata("design:type", TranslateService)
    ], NarikDialogService.prototype, "translateService", void 0);
    __decorate([
        NarikGlobalInject(DIALOG_MESSAGE_COMPONENT),
        __metadata("design:type", Type)
    ], NarikDialogService.prototype, "messageComponent", void 0);
    __decorate([
        NarikGlobalInject(DIALOG_INPUT_COMPONENT),
        __metadata("design:type", Type)
    ], NarikDialogService.prototype, "inputComponent", void 0);
    __decorate([
        NarikInject(DIALOG_CONTENT_COMPONENT),
        __metadata("design:type", Type)
    ], NarikDialogService.prototype, "contentComponent", void 0);
    __decorate([
        NarikGlobalInject(DIALOG_CONTAINER),
        __metadata("design:type", Type)
    ], NarikDialogService.prototype, "dialogContainerType", void 0);
    __decorate([
        NarikInject(RendererFactory2),
        __metadata("design:type", RendererFactory2)
    ], NarikDialogService.prototype, "rendererFactory", void 0);
    return NarikDialogService;
}(DialogService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.openDialogs;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.injectors;
    /** @type {?} */
    NarikDialogService.prototype.nextUniqueId;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.toastrService;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.translateService;
    /** @type {?} */
    NarikDialogService.prototype.messageComponent;
    /** @type {?} */
    NarikDialogService.prototype.inputComponent;
    /** @type {?} */
    NarikDialogService.prototype.contentComponent;
    /** @type {?} */
    NarikDialogService.prototype.dialogContainerType;
    /** @type {?} */
    NarikDialogService.prototype.rendererFactory;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.dialogOverlayContainerType;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.applicationRef;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikDialogService.prototype.document;
}
/**
 * @template T
 */
var  /**
 * @template T
 */
NarikDialogRef = /** @class */ (function () {
    function NarikDialogRef(id, componentInstance) {
        var _this = this;
        this.eventSubject = new ReplaySubject(10);
        this.id = id;
        this.componentInstance = componentInstance;
        this._closed = new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            _this.events
                .pipe(filter((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.eventType === "CLOSED"; })), first())
                .subscribe((/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                resolve(_this.dialogResultTransformer
                    ? _this.dialogResultTransformer(e.eventData)
                    : e.eventData);
                if (_this.dialogOverlayContainerRef) {
                    _this.dialogOverlayContainerRef.destroy();
                }
            }));
        }));
    }
    Object.defineProperty(NarikDialogRef.prototype, "closed", {
        get: /**
         * @return {?}
         */
        function () {
            return this._closed;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NarikDialogRef.prototype, "events", {
        get: /**
         * @return {?}
         */
        function () {
            return this.eventSubject;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    NarikDialogRef.prototype.close = /**
     * @param {?=} dialogResult
     * @param {?=} eventSource
     * @return {?}
     */
    function (dialogResult, eventSource) {
        this.eventSubject.next({
            eventType: "CLOSE_REQUEST",
            eventData: dialogResult,
            eventSource: eventSource
        });
    };
    return NarikDialogRef;
}());
if (false) {
    /** @type {?} */
    NarikDialogRef.prototype._closed;
    /** @type {?} */
    NarikDialogRef.prototype.dialogResultTransformer;
    /** @type {?} */
    NarikDialogRef.prototype.eventSubject;
    /** @type {?} */
    NarikDialogRef.prototype.id;
    /** @type {?} */
    NarikDialogRef.prototype.componentInstance;
    /** @type {?} */
    NarikDialogRef.prototype.container;
    /** @type {?} */
    NarikDialogRef.prototype.dialogOverlayContainerRef;
    /** @type {?} */
    NarikDialogRef.prototype.element;
}
var DialogActions = /** @class */ (function () {
    function DialogActions() {
    }
    DialogActions.ok = {
        label: "ok",
        dialogResult: "ok"
    };
    DialogActions.cancel = {
        label: "cancel",
        dialogResult: "cancel"
    };
    DialogActions.yes = {
        label: "yes",
        dialogResult: "yes"
    };
    DialogActions.no = {
        label: "no",
        dialogResult: "no"
    };
    DialogActions.ok_cancel = [DialogActions.ok, DialogActions.cancel];
    DialogActions.yes_no = [DialogActions.yes, DialogActions.no];
    return DialogActions;
}());
if (false) {
    /** @type {?} */
    DialogActions.ok;
    /** @type {?} */
    DialogActions.cancel;
    /** @type {?} */
    DialogActions.yes;
    /** @type {?} */
    DialogActions.no;
    /** @type {?} */
    DialogActions.ok_cancel;
    /** @type {?} */
    DialogActions.yes_no;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikErrorHandleService = /** @class */ (function (_super) {
    __extends(NarikErrorHandleService, _super);
    function NarikErrorHandleService(handles) {
        var _this = _super.call(this) || this;
        _this.errorHandlers = new Map();
        /** @type {?} */
        var data = groupBy(handles, "key");
        data.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return _this.errorHandlers.set(x.key, x.value); }));
        return _this;
    }
    /**
     * @param {?} errorTypeKey
     * @param {?} err
     * @return {?}
     */
    NarikErrorHandleService.prototype.HandleError = /**
     * @param {?} errorTypeKey
     * @param {?} err
     * @return {?}
     */
    function (errorTypeKey, err) {
        var e_1, _a;
        /** @type {?} */
        var handlers = this.errorHandlers
            .get(errorTypeKey)
            .sort((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x.order; }));
        /** @type {?} */
        var handled = false;
        try {
            for (var handlers_1 = __values(handlers), handlers_1_1 = handlers_1.next(); !handlers_1_1.done; handlers_1_1 = handlers_1.next()) {
                var x = handlers_1_1.value;
                handled = x.HandleError(err);
                if (handled) {
                    return true;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (handlers_1_1 && !handlers_1_1.done && (_a = handlers_1.return)) _a.call(handlers_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return handled;
    };
    NarikErrorHandleService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikErrorHandleService.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [ErrorHandler,] }] }
    ]; };
    return NarikErrorHandleService;
}(ErrorHandleService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikErrorHandleService.prototype.errorHandlers;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikEventAggregatorService = /** @class */ (function (_super) {
    __extends(NarikEventAggregatorService, _super);
    function NarikEventAggregatorService(metadataService) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.metadataService = metadataService;
        _this.eventsInfo = new Map();
        _this.subjects = new Map();
        /** @type {?} */
        var metaDataItems = _this.metadataService.getAllMetaData().valuesArray();
        try {
            for (var metaDataItems_1 = __values(metaDataItems), metaDataItems_1_1 = metaDataItems_1.next(); !metaDataItems_1_1.done; metaDataItems_1_1 = metaDataItems_1.next()) {
                var metaData = metaDataItems_1_1.value;
                _this.addMetaDataEvents(metaData);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (metaDataItems_1_1 && !metaDataItems_1_1.done && (_a = metaDataItems_1.return)) _a.call(metaDataItems_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        _this.metadataService.metaDataAdded.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            _this.addMetaDataEvents(x.metaData);
        }));
        return _this;
    }
    /**
     * @private
     * @param {?} metaData
     * @return {?}
     */
    NarikEventAggregatorService.prototype.addMetaDataEvents = /**
     * @private
     * @param {?} metaData
     * @return {?}
     */
    function (metaData) {
        var e_2, _a;
        if (metaData["events"]) {
            try {
                for (var _b = __values(metaData["events"].valuesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var event_1 = _c.value;
                    this.eventsInfo.set(event_1.key, event_1);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    };
    /**
     * @param {?} eventType
     * @return {?}
     */
    NarikEventAggregatorService.prototype.getSubject = /**
     * @param {?} eventType
     * @return {?}
     */
    function (eventType) {
        /** @type {?} */
        var subject = this.subjects.get(eventType);
        if (!subject) {
            subject = this.createSubject(this.eventsInfo.get(eventType));
            this.subjects.set(eventType, subject);
        }
        return subject;
    };
    /**
     * @param {?} eventInfo
     * @return {?}
     */
    NarikEventAggregatorService.prototype.createSubject = /**
     * @param {?} eventInfo
     * @return {?}
     */
    function (eventInfo) {
        if (!eventInfo || !eventInfo.info) {
            return new Subject();
        }
        else {
            if (eventInfo.info.subjectType === "ReplaySubject") {
                return new ReplaySubject(eventInfo.info.subjectParam || 1);
            }
            else if (eventInfo.info.subjectType === "ReplaySubject") {
                return new BehaviorSubject(eventInfo.info.subjectParam);
            }
        }
        return new Subject();
    };
    /**
     * @param {?} eventType
     * @param {?} eventArgs
     * @return {?}
     */
    NarikEventAggregatorService.prototype.publish = /**
     * @param {?} eventType
     * @param {?} eventArgs
     * @return {?}
     */
    function (eventType, eventArgs) {
        /** @type {?} */
        var subject = this.getSubject(eventType);
        subject.next({
            eventType: eventType,
            eventArgs: eventArgs
        });
    };
    /**
     * @template T
     * @param {?} eventType
     * @return {?}
     */
    NarikEventAggregatorService.prototype.listen = /**
     * @template T
     * @param {?} eventType
     * @return {?}
     */
    function (eventType) {
        /** @type {?} */
        var subject = this.getSubject(eventType);
        return subject.pipe(filter((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x.eventType === eventType; })), pluck("eventArgs"), share());
    };
    NarikEventAggregatorService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikEventAggregatorService.ctorParameters = function () { return [
        { type: MetaDataService }
    ]; };
    return NarikEventAggregatorService;
}(EventAggregatorService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikEventAggregatorService.prototype.eventsInfo;
    /**
     * @type {?}
     * @private
     */
    NarikEventAggregatorService.prototype.subjects;
    /**
     * @type {?}
     * @private
     */
    NarikEventAggregatorService.prototype.metadataService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikModuleManager = /** @class */ (function (_super) {
    __extends(NarikModuleManager, _super);
    function NarikModuleManager(injector, httpService, configService, translateService) {
        var _this = _super.call(this) || this;
        _this.injector = injector;
        _this.httpService = httpService;
        _this.configService = configService;
        _this.translateService = translateService;
        _this.modules = new Map();
        _this.modulesChangedSubject = new Subject();
        _this.modulesChanged = _this.modulesChangedSubject.asObservable();
        _this.narikLoadedSubject = new ReplaySubject(1);
        return _this;
    }
    Object.defineProperty(NarikModuleManager.prototype, "narikLoaded", {
        get: /**
         * @return {?}
         */
        function () {
            return this.narikLoadedSubject.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @param {?=} moduleInfo
     * @return {?}
     */
    NarikModuleManager.prototype.fixModuleInformation = /**
     * @private
     * @param {?=} moduleInfo
     * @return {?}
     */
    function (moduleInfo) { };
    /**
     * @param {?} key
     * @param {?=} moduleInfo
     * @return {?}
     */
    NarikModuleManager.prototype.addOrUpdateModule = /**
     * @param {?} key
     * @param {?=} moduleInfo
     * @return {?}
     */
    function (key, moduleInfo) {
        var e_1, _a;
        var _this = this;
        this.fixModuleInformation(moduleInfo);
        /** @type {?} */
        var isExists = this.modules.has(key);
        this.modules.set(key, moduleInfo);
        /** @type {?} */
        var translatePromices = [];
        if (moduleInfo.metaData && moduleInfo.metaData.translateItems) {
            try {
                for (var _b = __values(moduleInfo.metaData.translateItems), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var translateItem = _c.value;
                    translatePromices.push(this.translateService.addTranslationItem(translateItem));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        this.modulesChangedSubject.next({
            moduleEventType: isExists ? ModuleEventType.Update : ModuleEventType.Add,
            moduleKey: key,
            moduleInfo: moduleInfo
        });
        Promise.all(translatePromices).then((/**
         * @return {?}
         */
        function () {
            _this.eventAggregatorService.publish("MODULE_LOAD_COMPLETELY", {
                moduleKey: key,
                moduleInfo: moduleInfo
            });
        }));
    };
    /**
     * @param {?} key
     * @return {?}
     */
    NarikModuleManager.prototype.removeModule = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        /** @type {?} */
        var info = this.modules.get(key);
        this.modules.delete(key);
        this.modulesChangedSubject.next({
            moduleEventType: ModuleEventType.Remove,
            moduleKey: key,
            moduleInfo: info
        });
    };
    /**
     * @return {?}
     */
    NarikModuleManager.prototype.init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var moduleRootPath = this.configService.getConfig("modulesMetaDataRoot");
        return this.httpService
            .get(moduleRootPath + "/narik.json")
            .pipe(tap$1((/**
         * @param {?} info
         * @return {?}
         */
        function (info) {
            _this.addOrUpdateModule("narik", info);
            _this.narikLoadedSubject.next();
        })))
            .toPromise();
    };
    NarikModuleManager.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikModuleManager.ctorParameters = function () { return [
        { type: Injector },
        { type: NarikHttpService },
        { type: ConfigService },
        { type: NarikTranslateService }
    ]; };
    __decorate([
        NarikInject(EventAggregatorService),
        __metadata("design:type", EventAggregatorService)
    ], NarikModuleManager.prototype, "eventAggregatorService", void 0);
    return NarikModuleManager;
}(ModuleManager));
if (false) {
    /** @type {?} */
    NarikModuleManager.prototype.modules;
    /** @type {?} */
    NarikModuleManager.prototype.modulesChanged;
    /** @type {?} */
    NarikModuleManager.prototype.modulesChangedSubject;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.narikLoadedSubject;
    /** @type {?} */
    NarikModuleManager.prototype.eventAggregatorService;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.configService;
    /**
     * @type {?}
     * @private
     */
    NarikModuleManager.prototype.translateService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikNavigationService = /** @class */ (function () {
    function NarikNavigationService(providers) {
        var _this = this;
        this.navigationProviders = new Map();
        providers.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return _this.navigationProviders.set(x.key, x); }));
    }
    /**
     * @param {?} commands
     * @param {?=} providerKey
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    NarikNavigationService.prototype.navigate = /**
     * @param {?} commands
     * @param {?=} providerKey
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    function (commands, providerKey, extras, data, dialogOptions) {
        if (providerKey === void 0) { providerKey = ""; }
        return this.navigationProviders
            .get(providerKey)
            .navigate(commands, extras, data, dialogOptions);
    };
    /**
     * @param {?} providerKey
     * @param {?} path
     * @return {?}
     */
    NarikNavigationService.prototype.createNavigationCommand = /**
     * @param {?} providerKey
     * @param {?} path
     * @return {?}
     */
    function (providerKey, path) {
        return this.navigationProviders
            .get(providerKey)
            .createNavigationCommand(path);
    };
    /**
     * @param {?} providerKey
     * @param {?} outlet
     * @return {?}
     */
    NarikNavigationService.prototype.setOutlet = /**
     * @param {?} providerKey
     * @param {?} outlet
     * @return {?}
     */
    function (providerKey, outlet) {
        this.navigationProviders.get(providerKey).outlet = outlet;
    };
    NarikNavigationService.decorators = [
        { type: Injectable, args: [{
                    providedIn: "root"
                },] }
    ];
    /** @nocollapse */
    NarikNavigationService.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [NavigationProvider,] }] }
    ]; };
    /** @nocollapse */ NarikNavigationService.ɵprov = ɵɵdefineInjectable({ factory: function NarikNavigationService_Factory() { return new NarikNavigationService(ɵɵinject(NavigationProvider)); }, token: NarikNavigationService, providedIn: "root" });
    return NarikNavigationService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikNavigationService.prototype.navigationProviders;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikRemoteDataProviderService = /** @class */ (function (_super) {
    __extends(NarikRemoteDataProviderService, _super);
    function NarikRemoteDataProviderService(httpService, injector, moduleManager, metaDataService) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.httpService = httpService;
        _this.injector = injector;
        _this.moduleManager = moduleManager;
        _this.metaDataService = metaDataService;
        _this.key = "remote";
        _this.order = 100;
        _this.dayaKeyTemplate = "{0}_{1}";
        _this.dataStreams = new Map();
        _this.modulesDataInformations = new Map();
        try {
            for (var _b = __values(_this.moduleManager.modules.entriesArray()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var module = _c.value;
                if (module.value.metaData && module.value.metaData.dataInfo) {
                    _this.addRemoteDataInfo(module.key, module.value.metaData.dataInfo);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        _this.moduleManager.modulesChanged.subscribe((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (x.moduleInfo.metaData && x.moduleInfo.metaData.dataInfo) {
                _this.addRemoteDataInfo(x.moduleKey, x.moduleInfo.metaData.dataInfo);
            }
        }));
        return _this;
    }
    /**
     * @protected
     * @param {?} moduleKey
     * @param {?} dataInfo
     * @return {?}
     */
    NarikRemoteDataProviderService.prototype.addRemoteDataInfo = /**
     * @protected
     * @param {?} moduleKey
     * @param {?} dataInfo
     * @return {?}
     */
    function (moduleKey, dataInfo) {
        if (!this.modulesDataInformations.has(moduleKey)) {
            this.modulesDataInformations.set(moduleKey, dataInfo);
        }
    };
    /**
     * @param {?} dataInfo
     * @return {?}
     */
    NarikRemoteDataProviderService.prototype.isDataProviderFor = /**
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        return true;
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    NarikRemoteDataProviderService.prototype.getData = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var _dataUrl = dataInfo.dataUrl;
        /** @type {?} */
        var _remoteDataProvider = dataInfo.remoteDataProvider;
        /** @type {?} */
        var _parameterPrefix = "";
        if (!_dataUrl) {
            /** @type {?} */
            var _dataInfo = __assign({}, dataInfo);
            if (!_dataInfo.moduleKey) {
                _dataInfo.moduleKey = this.injector.get(MODULE_DATA_KEY);
            }
            if (!dataInfo.actionType || dataInfo.actionType === "DATA") {
                /** @type {?} */
                var dataItemInformations = this.metaDataService.getDataItemInformation(_dataInfo.moduleKey, _dataInfo.dataKey);
                if (dataItemInformations) {
                    _dataInfo = Object.assign(dataItemInformations, _dataInfo);
                }
            }
            /** @type {?} */
            var moduleDataItemInformations = this.modulesDataInformations.get(_dataInfo.moduleKey);
            if (moduleDataItemInformations) {
                if (!_dataInfo.dataUrl) {
                    /** @type {?} */
                    var urlInfo = moduleDataItemInformations.dataUrlInfo;
                    if (!dataInfo.actionType || dataInfo.actionType === "DATA") {
                        _dataInfo.dataUrl = urlInfo.dataPathTemplate;
                    }
                    else if (dataInfo.actionType === "GET") {
                        _dataInfo.dataUrl = urlInfo.getPathTemplate;
                    }
                    else if (dataInfo.actionType === "LIST") {
                        _dataInfo.dataUrl = urlInfo.listPathTemplate;
                    }
                    else if (dataInfo.actionType === "POST") {
                        _dataInfo.dataUrl = urlInfo.postPathTemplate;
                    }
                    else if (dataInfo.actionType === "UPDATE") {
                        _dataInfo.dataUrl = urlInfo.updatePathTemplate;
                    }
                    else if (dataInfo.actionType === "DELETE") {
                        _dataInfo.dataUrl = urlInfo.deletePathTemplate;
                    }
                    else if (dataInfo.actionType === "COMPLETE") {
                        _dataInfo.dataUrl = urlInfo.completePathTemplate;
                    }
                    else {
                        _dataInfo.dataUrl = urlInfo[dataInfo.actionType + "PathTemplate"];
                    }
                    _parameterPrefix = urlInfo.parameterPrefix;
                    if (!_remoteDataProvider) {
                        _remoteDataProvider = urlInfo.defaultRemoteDataProvider;
                    }
                    if (!_dataInfo.dataUrlMethod &&
                        (!dataInfo.actionType || dataInfo.actionType === "DATA")) {
                        _dataInfo.dataUrlMethod = urlInfo.defaultDataUrlMethod;
                    }
                }
            }
            if (!_dataInfo.dataUrlMethod) {
                _dataInfo.dataUrlMethod = "";
            }
            _dataUrl = replaceString(_dataInfo.dataUrl, _dataInfo, "", "{", "}");
        }
        if (!dataInfo.dataMethod ||
            dataInfo.dataMethod === "GET" ||
            dataInfo.dataMethod === "PUT") {
            _parameterPrefix = _parameterPrefix || "";
            if (dataInfo.urlParameters || dataInfo.dataParameters) {
                if (_parameterPrefix && _dataUrl.indexOf(_parameterPrefix) >= 0) {
                    _dataUrl = replaceString(_dataUrl, dataInfo.urlParameters || dataInfo.dataParameters, _parameterPrefix);
                }
                else {
                    if (!_remoteDataProvider) {
                        throw new Error("RemoteDataProvider Dos Not Determined");
                    }
                    /** @type {?} */
                    var urlCreatorService = this.injector.get(UrlCreatorService);
                    _dataUrl = urlCreatorService.applyParameters(_remoteDataProvider, _dataUrl, dataInfo.urlParameters || dataInfo.dataParameters);
                }
            }
            if (dataInfo.pagingParameter) {
                /** @type {?} */
                var urlCreatorService = this.injector.get(UrlCreatorService);
                _dataUrl = urlCreatorService.applyPagingParameters(_remoteDataProvider, _dataUrl, dataInfo.pagingParameter);
            }
        }
        if (dataInfo.dataMethod === "POST") {
            return (/** @type {?} */ (this.httpService.post(_dataUrl, dataInfo.dataParameters || {})));
        }
        else if (dataInfo.dataMethod === "DELETE") {
            return (/** @type {?} */ (this.httpService.delete(_dataUrl, dataInfo.dataParameters || {})));
        }
        else if (dataInfo.dataMethod === "PUT") {
            return (/** @type {?} */ (this.httpService.put(_dataUrl, dataInfo.dataParameters || {})));
        }
        else {
            return (/** @type {?} */ (this.httpService.get(_dataUrl)));
        }
    };
    /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    NarikRemoteDataProviderService.prototype.getDataStream = /**
     * @template T
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var fullKey = this.getFullKey(dataInfo);
        if (this.dataStreams.has(fullKey)) {
            return this.dataStreams.get(fullKey);
        }
        else {
            /** @type {?} */
            var dataSubject_1 = new ReplaySubject(1);
            this.dataStreams.set(fullKey, dataSubject_1);
            this.getData(dataInfo)
                .pipe(first())
                .subscribe((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return dataSubject_1.next(data); }));
            return dataSubject_1.asObservable();
        }
    };
    /**
     * @protected
     * @param {?} dataInfo
     * @return {?}
     */
    NarikRemoteDataProviderService.prototype.getFullKey = /**
     * @protected
     * @param {?} dataInfo
     * @return {?}
     */
    function (dataInfo) {
        /** @type {?} */
        var moduleKey = dataInfo.moduleKey;
        if (!moduleKey) {
            moduleKey = this.injector.get(MODULE_DATA_KEY);
        }
        return formatString(this.dayaKeyTemplate, moduleKey, dataInfo.dataKey);
    };
    NarikRemoteDataProviderService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikRemoteDataProviderService.ctorParameters = function () { return [
        { type: NarikHttpService },
        { type: Injector },
        { type: ModuleManager },
        { type: MetaDataService }
    ]; };
    return NarikRemoteDataProviderService;
}(RemoteDataProviderService));
if (false) {
    /** @type {?} */
    NarikRemoteDataProviderService.prototype.key;
    /** @type {?} */
    NarikRemoteDataProviderService.prototype.order;
    /** @type {?} */
    NarikRemoteDataProviderService.prototype.dayaKeyTemplate;
    /**
     * @type {?}
     * @protected
     */
    NarikRemoteDataProviderService.prototype.dataStreams;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.modulesDataInformations;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikRemoteDataProviderService.prototype.metaDataService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikRoleBasedAuthorizationService = /** @class */ (function (_super) {
    __extends(NarikRoleBasedAuthorizationService, _super);
    /**
     *
     */
    function NarikRoleBasedAuthorizationService(authenticationService) {
        var _this = _super.call(this) || this;
        _this.authenticationService = authenticationService;
        return _this;
    }
    /**
     * @param {?} itemKey
     * @return {?}
     */
    NarikRoleBasedAuthorizationService.prototype.hasAccess = /**
     * @param {?} itemKey
     * @return {?}
     */
    function (itemKey) {
        if (this.authenticationService.currentUserValue &&
            this.authenticationService.currentUserValue.roles) {
            /** @type {?} */
            var key = this.extractItemKey(itemKey);
            if (key) {
                /** @type {?} */
                var that_1 = this;
                return of$1(!!key.filter((/**
                 * @param {?} n
                 * @return {?}
                 */
                function (n) {
                    return (that_1.authenticationService.currentUserValue.roles.indexOf(n) > -1);
                }))[0]);
            }
        }
        return of$1(false);
    };
    /**
     * @protected
     * @param {?} itemKey
     * @return {?}
     */
    NarikRoleBasedAuthorizationService.prototype.extractItemKey = /**
     * @protected
     * @param {?} itemKey
     * @return {?}
     */
    function (itemKey) {
        if (isString(itemKey)) {
            return [itemKey];
        }
        else if (isArray(itemKey)) {
            return itemKey;
        }
        return null;
    };
    NarikRoleBasedAuthorizationService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikRoleBasedAuthorizationService.ctorParameters = function () { return [
        { type: AuthenticationService }
    ]; };
    return NarikRoleBasedAuthorizationService;
}(AuthorizationService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikRoleBasedAuthorizationService.prototype.authenticationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikUrlCreatorService = /** @class */ (function (_super) {
    __extends(NarikUrlCreatorService, _super);
    function NarikUrlCreatorService(creators) {
        var _this = _super.call(this) || this;
        _this.urlCreators = new Map();
        creators.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return _this.urlCreators.set(x.key, x); }));
        return _this;
    }
    /**
     * @param {?} key
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    NarikUrlCreatorService.prototype.applyParameters = /**
     * @param {?} key
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    function (key, url, parameters) {
        /** @type {?} */
        var creator = this.urlCreators.get(key);
        return creator.applyParameters(url, parameters);
    };
    /**
     * @param {?} key
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    NarikUrlCreatorService.prototype.applyPagingParameters = /**
     * @param {?} key
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    function (key, url, pagingParameter) {
        /** @type {?} */
        var creator = this.urlCreators.get(key);
        return creator.applyPagingParameters(url, pagingParameter);
    };
    NarikUrlCreatorService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikUrlCreatorService.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [UrlCreator,] }] }
    ]; };
    return NarikUrlCreatorService;
}(UrlCreatorService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikUrlCreatorService.prototype.urlCreators;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ApiUrlCreator = /** @class */ (function (_super) {
    __extends(ApiUrlCreator, _super);
    function ApiUrlCreator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.key = "api";
        return _this;
    }
    /**
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    ApiUrlCreator.prototype.applyParameters = /**
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    function (url, parameters) {
        if (!parameters) {
            return url;
        }
        return formatString("{0}{1}{2}", url, url.indexOf("?") >= 0 ? "" : "?", Object.keys(parameters)
            .map((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            return formatString("{0}={1}", x, parameters[x]);
        }))
            .join("&"));
    };
    /**
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    ApiUrlCreator.prototype.applyPagingParameters = /**
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    function (url, pagingParameter) {
        throw new Error("Method not implemented.");
    };
    ApiUrlCreator.decorators = [
        { type: Injectable }
    ];
    return ApiUrlCreator;
}(UrlCreator));
if (false) {
    /** @type {?} */
    ApiUrlCreator.prototype.key;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ODataUrlCreator = /** @class */ (function (_super) {
    __extends(ODataUrlCreator, _super);
    function ODataUrlCreator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.key = "odata";
        _this.odataFilters = {
            eq: "eq",
            neq: "ne",
            gt: "gt",
            gte: "ge",
            lt: "lt",
            lte: "le",
            contains: "contains",
            doesnotcontain: "substringof",
            endswith: "endswith",
            startswith: "startswith",
            isnull: "eq",
            isnotnull: "ne",
            isnullorempty: "eq",
            isnotnullorempty: "ne",
            isempty: "eq",
            isnotempty: "ne"
        };
        return _this;
    }
    /**
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    ODataUrlCreator.prototype.applyParameters = /**
     * @param {?} url
     * @param {?} parameters
     * @return {?}
     */
    function (url, parameters) {
        if (!parameters) {
            return url;
        }
        if (isObject(parameters)) {
            return formatString("{0}({1})", url, Object.keys(parameters)
                .map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                return formatString("{0}={2}{1}{2}", x, parameters[x], isString(parameters[x]) ? "'" : "");
            }))
                .join(","));
        }
        else {
            return formatString("{0}({2}{1}{2})", url, parameters, isString(parameters) ? "'" : "");
        }
    };
    /**
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    ODataUrlCreator.prototype.applyPagingParameters = /**
     * @param {?} url
     * @param {?} pagingParameter
     * @return {?}
     */
    function (url, pagingParameter) {
        if (!pagingParameter) {
            return url;
        }
        /** @type {?} */
        var orderBy = "";
        if (pagingParameter.sort && pagingParameter.sort.length !== 0) {
            orderBy = "&%24orderby=";
            orderBy += pagingParameter.sort
                .map((/**
             * @param {?} s
             * @return {?}
             */
            function (s) {
                return "" + s.field + (s.order === "desc" ? " desc" : "");
            }))
                .join(",");
        }
        /** @type {?} */
        var filter = "";
        if (pagingParameter.filter && pagingParameter.filter.filters) {
            filter = "&%24filter=" + this.toOdataFilter(pagingParameter.filter);
        }
        pagingParameter.skip =
            pagingParameter.skip ||
                pagingParameter.pageIndex * pagingParameter.pageCount;
        return (url +
            ("?%24format=json&%24top=" + pagingParameter.pageCount + "&%24skip=" + pagingParameter.skip + orderBy + filter + "&%24count=true"));
    };
    /**
     * @private
     * @param {?} filter
     * @return {?}
     */
    ODataUrlCreator.prototype.toOdataFilter = /**
     * @private
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var result = [];
        /** @type {?} */
        var condition = filter.condition || "and";
        /** @type {?} */
        var idx;
        /** @type {?} */
        var length;
        /** @type {?} */
        var field;
        /** @type {?} */
        var type;
        /** @type {?} */
        var format;
        /** @type {?} */
        var operator;
        /** @type {?} */
        var value;
        /** @type {?} */
        var ignoreCase;
        /** @type {?} */
        var filters = filter.filters;
        for (idx = 0, length = filters.length; idx < length; idx++) {
            filter = filters[idx];
            field = filter.field;
            value = filter.value;
            operator = filter.operator;
            if (filter.filters) {
                filter = this.toOdataFilter(filter);
            }
            else {
                ignoreCase = filter.ignoreCase;
                field = field.replace(/\./g, "/");
                filter = this.odataFilters[operator];
                if (operator === "isnullorempty") {
                    filter = formatString("{0} {1} null or {0} {1} ''", field, filter);
                }
                else if (operator === "isnotnullorempty") {
                    filter = formatString("{0} {1} null and {0} {1} ''", field, filter);
                }
                else if (operator === "isnull" || operator === "isnotnull") {
                    filter = formatString("{0} {1} null", field, filter);
                }
                else if (operator === "isempty" || operator === "isnotempty") {
                    filter = formatString("{0} {1} ''", field, filter);
                }
                else if (filter && value !== undefined) {
                    type = typeof value;
                    if (type === "string") {
                        format = "'{1}'";
                        value = value.replace(/'/g, "''");
                        if (ignoreCase === true) {
                            field = "tolower(" + field + ")";
                        }
                    }
                    else if (type === "date") {
                        format = "{1:yyyy-MM-ddTHH:mm:ss+00:00}";
                        // value = kendo.timezone.apply(value, "Etc/UTC");
                    }
                    else {
                        format = "{1}";
                    }
                    if (filter.length > 3) {
                        if (filter !== "substringof") {
                            format = "{0}({2}," + format + ")";
                        }
                        else {
                            format = "{0}(" + format + ",{2})";
                            if (operator === "doesnotcontain") {
                                format = "{0}({2},'{1}') eq -1";
                                filter = "indexof";
                            }
                        }
                    }
                    else {
                        format = "{2} {0} " + format;
                    }
                    filter = formatString(format, filter, value, field);
                }
            }
            result.push(filter);
        }
        filter = result.join(" " + condition + " ");
        if (result.length > 1) {
            filter = "(" + filter + ")";
        }
        return filter;
    };
    ODataUrlCreator.decorators = [
        { type: Injectable }
    ];
    return ODataUrlCreator;
}(UrlCreator));
if (false) {
    /** @type {?} */
    ODataUrlCreator.prototype.key;
    /** @type {?} */
    ODataUrlCreator.prototype.odataFilters;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikEmptyCommandProcessor = /** @class */ (function () {
    function NarikEmptyCommandProcessor() {
    }
    /**
     * @param {?} sender
     * @param {?} cmd
     * @return {?}
     */
    NarikEmptyCommandProcessor.prototype.processCommand = /**
     * @param {?} sender
     * @param {?} cmd
     * @return {?}
     */
    function (sender, cmd) { };
    return NarikEmptyCommandProcessor;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikValidationService = /** @class */ (function (_super) {
    __extends(NarikValidationService, _super);
    function NarikValidationService() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._validators = {
            email: {
                func: Validators.email
            },
            max: {
                func: Validators.max,
                params: ["max"]
            },
            maxLength: {
                func: Validators.maxLength,
                params: ["maxLength"]
            },
            min: {
                func: Validators.min,
                params: ["min"]
            },
            minLength: {
                func: Validators.minLength,
                params: ["minLength"]
            },
            pattern: {
                func: Validators.pattern,
                params: ["pattern"]
            },
            required: {
                func: Validators.required
            },
            requiredTrue: {
                func: Validators.requiredTrue
            },
            base64: {
                func: CustomValidators.base64,
                params: ["min"]
            },
            creditCard: {
                func: CustomValidators.creditCard
            },
            date: {
                func: CustomValidators.date
            },
            dateISO: {
                func: CustomValidators.dateISO
            },
            digits: {
                func: CustomValidators.digits
            },
            equal: {
                func: CustomValidators.equal,
                params: ["equal"]
            },
            equalTo: {
                func: CustomValidators.equalTo,
                params: ["equalTo"]
            },
            gt: {
                func: CustomValidators.gt,
                params: ["gt"]
            },
            gte: {
                func: CustomValidators.gte,
                params: ["gte"]
            },
            json: {
                func: CustomValidators.json
            },
            lt: {
                func: CustomValidators.lt,
                params: ["lt"]
            },
            lte: {
                func: CustomValidators.lte,
                params: ["lte"]
            },
            maxDate: {
                func: CustomValidators.maxDate,
                params: ["maxDate"]
            },
            minDate: {
                func: CustomValidators.minDate,
                params: ["minDate"]
            },
            notEqual: {
                func: CustomValidators.notEqual,
                params: ["notEqual"]
            },
            notEqualTo: {
                func: CustomValidators.notEqualTo,
                params: ["notEqualTo"]
            },
            number: {
                func: CustomValidators.number
            },
            range: {
                func: CustomValidators.range,
                params: ["range"]
            },
            rangeLength: {
                func: CustomValidators.rangeLength,
                params: ["rangeLength"]
            },
            url: {
                func: CustomValidators.url
            },
            uuid: {
                func: CustomValidators.uuid
            }
        };
        return _this;
    }
    /**
     * @param {?} key
     * @param {?} validator
     * @return {?}
     */
    NarikValidationService.prototype.addValidator = /**
     * @param {?} key
     * @param {?} validator
     * @return {?}
     */
    function (key, validator) {
        this._validators[key] = validator;
    };
    /**
     * @return {?}
     */
    NarikValidationService.prototype.validators = /**
     * @return {?}
     */
    function () {
        return this._validators;
    };
    return NarikValidationService;
}(ValidationService));
if (false) {
    /** @type {?} */
    NarikValidationService.prototype._validators;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikShortcutService = /** @class */ (function (_super) {
    __extends(NarikShortcutService, _super);
    function NarikShortcutService(eventManager, document) {
        var _this = _super.call(this) || this;
        _this.eventManager = eventManager;
        _this.document = document;
        _this.hotkeys = new Map();
        _this.defaults = {
            element: _this.document
        };
        return _this;
    }
    /**
     * @param {?} options
     * @return {?}
     */
    NarikShortcutService.prototype.addShortcut = /**
     * @param {?} options
     * @return {?}
     */
    function (options) {
        var _this = this;
        /** @type {?} */
        var merged = __assign(__assign({}, this.defaults), options);
        /** @type {?} */
        var event = "keydown." + merged.keys;
        if (merged.description) {
            this.hotkeys.set(merged.keys, merged.description);
        }
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            /** @type {?} */
            var handler = (/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                e.preventDefault();
                observer.next({
                    event: e,
                    uniqueId: merged.uniqueId
                });
            });
            /** @type {?} */
            var dispose = _this.eventManager.addEventListener(merged.element, event, handler);
            return (/**
             * @return {?}
             */
            function () {
                dispose();
                _this.hotkeys.delete(merged.keys);
            });
        }));
    };
    NarikShortcutService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikShortcutService.ctorParameters = function () { return [
        { type: EventManager },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    return NarikShortcutService;
}(ShortcutService));
if (false) {
    /** @type {?} */
    NarikShortcutService.prototype.hotkeys;
    /** @type {?} */
    NarikShortcutService.prototype.defaults;
    /**
     * @type {?}
     * @private
     */
    NarikShortcutService.prototype.eventManager;
    /**
     * @type {?}
     * @private
     */
    NarikShortcutService.prototype.document;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikBaseNavigationProvider = /** @class */ (function () {
    function NarikBaseNavigationProvider(router) {
        this.router = router;
    }
    /**
     * @param {?} config
     * @param {?} segments
     * @param {?} segmentGroup
     * @return {?}
     */
    NarikBaseNavigationProvider.prototype.findRoute = /**
     * @param {?} config
     * @param {?} segments
     * @param {?} segmentGroup
     * @return {?}
     */
    function (config, segments, segmentGroup) {
        var e_1, _a;
        /** @type {?} */
        var item;
        try {
            for (var config_1 = __values(config), config_1_1 = config_1.next(); !config_1_1.done; config_1_1 = config_1.next()) {
                var route = config_1_1.value;
                if (route.path === "**") {
                    return {
                        route: route
                    };
                }
                else {
                    if (route.path === "") {
                        if (route.pathMatch === "full" &&
                            (segmentGroup.hasChildren() || segments.length > 0)) {
                            throw new Error("");
                        }
                        item = {
                            component: null,
                            match: { consumed: [], posParams: {} }
                        };
                    }
                    else {
                        item = {
                            component: null,
                            match: this.defaultUrlMatcher(segments, segmentGroup, route)
                        };
                    }
                    if (item && item.match && item.match.consumed) {
                        /** @type {?} */
                        var childRoutes = this.getChildConfig(route);
                        if (item.match.consumed.length !== 0) {
                            segments.splice(0, 1);
                        }
                        item = this.findRoute(childRoutes, segments, segmentGroup);
                        if (item) {
                            return item;
                        }
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (config_1_1 && !config_1_1.done && (_a = config_1.return)) _a.call(config_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return item;
    };
    /**
     * @param {?} route
     * @return {?}
     */
    NarikBaseNavigationProvider.prototype.getChildConfig = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        if (route.children) {
            return route.children;
        }
        if (route.loadChildren) {
            return route["_loadedConfig"].routes;
        }
        return [];
    };
    /**
     * @param {?} segments
     * @param {?} segmentGroup
     * @param {?} route
     * @return {?}
     */
    NarikBaseNavigationProvider.prototype.defaultUrlMatcher = /**
     * @param {?} segments
     * @param {?} segmentGroup
     * @param {?} route
     * @return {?}
     */
    function (segments, segmentGroup, route) {
        /** @type {?} */
        var parts = route.path.split("/");
        if (parts.length > segments.length) {
            // The actual URL is shorter than the config, no match
            return null;
        }
        if (route.pathMatch === "full" &&
            (segmentGroup.hasChildren() || parts.length < segments.length)) {
            // The config is longer than the actual URL but we are looking for a full match, return null
            return null;
        }
        /** @type {?} */
        var posParams = {};
        // Check each config part against the actual URL
        for (var index = 0; index < parts.length; index++) {
            /** @type {?} */
            var part = parts[index];
            /** @type {?} */
            var segment = segments[index];
            /** @type {?} */
            var isParameter = part.startsWith(":");
            if (isParameter) {
                posParams[part.substring(1)] = segment;
            }
            else if (part !== segment.path) {
                // The actual URL part does not match the config, no match
                return null;
            }
        }
        return { consumed: segments.slice(0, parts.length), posParams: posParams };
    };
    return NarikBaseNavigationProvider;
}());
if (false) {
    /** @type {?} */
    NarikBaseNavigationProvider.prototype.outlet;
    /**
     * @type {?}
     * @protected
     */
    NarikBaseNavigationProvider.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikDialogNavigationProvider = /** @class */ (function (_super) {
    __extends(NarikDialogNavigationProvider, _super);
    function NarikDialogNavigationProvider(dialogService, router) {
        var _this = _super.call(this, router) || this;
        _this.dialogService = dialogService;
        _this.key = "dialog";
        return _this;
    }
    /**
     * @param {?} path
     * @return {?}
     */
    NarikDialogNavigationProvider.prototype.createNavigationCommand = /**
     * @param {?} path
     * @return {?}
     */
    function (path) {
        return [path];
    };
    /**
     * @param {?} commands
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    NarikDialogNavigationProvider.prototype.navigate = /**
     * @param {?} commands
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    function (commands, extras, data, dialogOptions) {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            /** @type {?} */
            var tree;
            if (isArray(commands)) {
                tree = _this.router.createUrlTree((/** @type {?} */ (commands)), extras);
            }
            else if (isString(commands)) {
                tree = _this.router.parseUrl((/** @type {?} */ (commands)));
            }
            else {
                tree = (/** @type {?} */ (commands));
            }
            /** @type {?} */
            var primary = tree.root.children[PRIMARY_OUTLET];
            /** @type {?} */
            var route = _this.findRoute(_this.router.config, primary.segments, primary);
            if (route && route.route) {
                /** @type {?} */
                var dialog = _this.dialogService.showDialog(route.route.component, data ? data["__dialogTitle"] : undefined, {
                    parameters: __assign(__assign({ routeByCustomProvider: true, path: primary.segments[0].path }, route.route.data), data)
                }, [], dialogOptions || {
                    isFullScreen: false,
                    showBackdrop: true,
                    disableAutoClose: true
                }, undefined, undefined, [{ provide: ActivatedRoute, useValue: extras.relativeTo }]);
                resolve(dialog);
            }
            else {
                reject(false);
            }
        }));
    };
    NarikDialogNavigationProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikDialogNavigationProvider.ctorParameters = function () { return [
        { type: DialogService },
        { type: Router }
    ]; };
    return NarikDialogNavigationProvider;
}(NarikBaseNavigationProvider));
if (false) {
    /** @type {?} */
    NarikDialogNavigationProvider.prototype.key;
    /**
     * @type {?}
     * @private
     */
    NarikDialogNavigationProvider.prototype.dialogService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikRouteNavigationProvider = /** @class */ (function () {
    function NarikRouteNavigationProvider(router) {
        this.router = router;
        this.key = "route";
    }
    /**
     * @param {?} path
     * @return {?}
     */
    NarikRouteNavigationProvider.prototype.createNavigationCommand = /**
     * @param {?} path
     * @return {?}
     */
    function (path) {
        return ["../" + path];
    };
    /**
     * @param {?} commands
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    NarikRouteNavigationProvider.prototype.navigate = /**
     * @param {?} commands
     * @param {?=} extras
     * @param {?=} data
     * @param {?=} dialogOptions
     * @return {?}
     */
    function (commands, extras, data, dialogOptions) {
        extras = extras || {};
        if (data) {
            ((/** @type {?} */ (extras))).data = data;
        }
        if (isArray(commands)) {
            return this.router.navigate((/** @type {?} */ (commands)), extras);
        }
        else {
            return this.router.navigateByUrl((/** @type {?} */ (commands)), extras);
        }
    };
    NarikRouteNavigationProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikRouteNavigationProvider.ctorParameters = function () { return [
        { type: Router }
    ]; };
    return NarikRouteNavigationProvider;
}());
if (false) {
    /** @type {?} */
    NarikRouteNavigationProvider.prototype.key;
    /** @type {?} */
    NarikRouteNavigationProvider.prototype.outlet;
    /**
     * @type {?}
     * @private
     */
    NarikRouteNavigationProvider.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikFormTitleResolver = /** @class */ (function (_super) {
    __extends(NarikFormTitleResolver, _super);
    function NarikFormTitleResolver(translateService) {
        var _this = _super.call(this) || this;
        _this.translateService = translateService;
        return _this;
    }
    /**
     * @param {?} routeSnapshot
     * @param {?=} path
     * @return {?}
     */
    NarikFormTitleResolver.prototype.resolveTitle = /**
     * @param {?} routeSnapshot
     * @param {?=} path
     * @return {?}
     */
    function (routeSnapshot, path) {
        if (routeSnapshot) {
            /** @type {?} */
            var title = (routeSnapshot.data && routeSnapshot.data.title) ||
                (routeSnapshot.url[0] && routeSnapshot.url[0].path);
            if (title) {
                return this.translateService.instant(this.getFirst(title));
            }
        }
        if (path) {
            return this.translateService.instant(this.getFirst(path));
        }
        return "";
    };
    /**
     * @private
     * @param {?} title
     * @return {?}
     */
    NarikFormTitleResolver.prototype.getFirst = /**
     * @private
     * @param {?} title
     * @return {?}
     */
    function (title) {
        return title ? title.split("-")[0] : "";
    };
    NarikFormTitleResolver.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikFormTitleResolver.ctorParameters = function () { return [
        { type: TranslateService }
    ]; };
    return NarikFormTitleResolver;
}(FormTitleResolver));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikFormTitleResolver.prototype.translateService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikCoreModule = /** @class */ (function () {
    function NarikCoreModule(translateService, defaultLang, useDefaultLang, injector) {
        translateService.setDefaultLang(defaultLang);
        if (useDefaultLang) {
            translateService.use(defaultLang);
        }
        AppInjector.injector = injector;
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    NarikCoreModule.forRoot = /**
     * @param {?=} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: NarikCoreModule,
            providers: [
                {
                    provide: ErrorHandleService,
                    useClass: (config && config.errorHandleService) || NarikErrorHandleService
                },
                {
                    provide: DataProviderService,
                    useClass: (config && config.dataProviderService) || NarikDataProviderService
                },
                {
                    provide: DataStorageService,
                    useClass: (config && config.dataStorageService) || NarikDataStorageService
                },
                {
                    provide: DialogService,
                    useClass: (config && config.dialogService) || NarikDialogService
                },
                {
                    provide: UrlCreatorService,
                    useClass: (config && config.urlCreatorService) || NarikUrlCreatorService
                },
                {
                    provide: ModuleManager,
                    useClass: (config && config.moduleManagerService) || NarikModuleManager
                },
                {
                    provide: ValidationService,
                    useClass: (config && config.validationService) || NarikValidationService
                },
                {
                    provide: EventAggregatorService,
                    useClass: (config && config.eventAggregatorService) ||
                        NarikEventAggregatorService
                },
                {
                    provide: AuthorizationService,
                    useClass: (config && config.authorizationService) ||
                        NarikRoleBasedAuthorizationService
                },
                {
                    provide: ConfigService,
                    useClass: (config && config.configService) || NarikConfigService
                },
                {
                    provide: JsonService,
                    useClass: (config && config.jsonService) || NarikJsonService
                },
                {
                    provide: ComponentTypeResolver,
                    useClass: (config && config.componentTypeResolver) || NarikComponentTypeResolver
                },
                {
                    provide: FormTitleResolver,
                    useClass: (config && config.formTitleResolver) || NarikFormTitleResolver
                },
                {
                    provide: CommandProcessor,
                    useClass: (config && config.commandProcessor) || NarikEmptyCommandProcessor
                },
                {
                    provide: DEFAULT_LANG,
                    useValue: (config && config.defaultLang) || "en"
                },
                {
                    provide: NavigationService,
                    useClass: NarikNavigationService
                },
                {
                    provide: USE_DEFAULT_LANG,
                    useValue: config && config.useDefaultLang
                },
                { provide: CONFIG_PATH, useValue: config && config.configFilePath },
                { provide: CONFIG_OPTIONS, useValue: config && config.configOptions },
                {
                    provide: APP_INITIALIZER,
                    useFactory: initConfig,
                    deps: [ConfigService, ModuleManager],
                    multi: true
                },
                {
                    provide: ShortcutService,
                    useClass: NarikShortcutService
                }
            ]
        };
    };
    NarikCoreModule.decorators = [
        { type: NgModule, args: [{
                    imports: [ToastrModule.forRoot()],
                    declarations: [COMPONENTS],
                    exports: [EXPORT_COMPONENTS],
                    providers: [
                        {
                            provide: RemoteDataProviderService,
                            useClass: NarikRemoteDataProviderService
                        },
                        {
                            provide: SessionStorageDataProvider,
                            useClass: SessionStorageDataProvider
                        },
                        {
                            provide: LocalStorageDataProvider,
                            useClass: LocalStorageDataProvider
                        },
                        {
                            provide: MemoryDataProvider,
                            useClass: MemoryDataProvider
                        },
                        {
                            provide: DATA_PROVIDER,
                            useExisting: SessionStorageDataProvider,
                            multi: true
                        },
                        {
                            provide: DATA_PROVIDER,
                            useClass: StaticDataProvider,
                            multi: true
                        },
                        {
                            provide: DATA_PROVIDER,
                            useExisting: LocalStorageDataProvider,
                            multi: true
                        },
                        {
                            provide: DATA_PROVIDER,
                            useExisting: MemoryDataProvider,
                            multi: true
                        },
                        {
                            provide: DATA_PROVIDER,
                            useClass: RemoteDataProvider,
                            multi: true
                        },
                        {
                            provide: DATA_STORAGE,
                            useExisting: SessionStorageDataProvider,
                            multi: true
                        },
                        {
                            provide: DATA_STORAGE,
                            useExisting: LocalStorageDataProvider,
                            multi: true
                        },
                        {
                            provide: DATA_STORAGE,
                            useExisting: MemoryDataProvider,
                            multi: true
                        },
                        {
                            provide: UrlCreator,
                            useClass: ApiUrlCreator,
                            multi: true
                        },
                        {
                            provide: UrlCreator,
                            useClass: ODataUrlCreator,
                            multi: true
                        },
                        {
                            provide: NavigationProvider,
                            useClass: NarikDialogNavigationProvider,
                            multi: true
                        },
                        {
                            provide: NavigationProvider,
                            useClass: NarikRouteNavigationProvider,
                            multi: true
                        },
                        { provide: HTTP_INTERCEPTORS, useClass: HttpErrorInterceptor, multi: true }
                    ]
                },] }
    ];
    /** @nocollapse */
    NarikCoreModule.ctorParameters = function () { return [
        { type: NarikTranslateService },
        { type: String, decorators: [{ type: Inject, args: [DEFAULT_LANG,] }] },
        { type: Boolean, decorators: [{ type: Inject, args: [USE_DEFAULT_LANG,] }] },
        { type: Injector }
    ]; };
    return NarikCoreModule;
}());
/**
 * @param {?} configService
 * @param {?} moduleManager
 * @return {?}
 */
function initConfig(configService, moduleManager) {
    /** @type {?} */
    var promise = (/**
     * @return {?}
     */
    function () {
        // return configService.init().then(() => {
        //   moduleManager.init();
        // });
        return promiseSerial([
            (/**
             * @return {?}
             */
            function () { return configService.init(); }),
            (/**
             * @return {?}
             */
            function () { return moduleManager.init(); })
        ]);
    });
    return promise;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ResourceModel() { }
if (false) {
    /** @type {?} */
    ResourceModel.prototype.src;
    /** @type {?|undefined} */
    ResourceModel.prototype.loaded;
}
var NarikResourceLoaderService = /** @class */ (function () {
    function NarikResourceLoaderService(configService) {
        this.resources = [];
        this.dynamicResourcesPath = "";
        this.dynamicResourcesPath = configService.getConfig("dynamicResourcesPath");
        if (this.dynamicResourcesPath) {
            this.dynamicResourcesPath += "/";
        }
    }
    /**
     * @param {?} items
     * @return {?}
     */
    NarikResourceLoaderService.prototype.load = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        var _this = this;
        /** @type {?} */
        var loaders = items.map((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (Array.isArray(x)) {
                return Observable$1.create((/**
                 * @param {?} o
                 * @return {?}
                 */
                function (o) {
                    /** @type {?} */
                    var allloaders = x.map((/**
                     * @param {?} t
                     * @return {?}
                     */
                    function (t) { return _this.loadInternall(t); }));
                    concat.apply(void 0, __spread(allloaders)).subscribe((/**
                     * @param {?} t
                     * @return {?}
                     */
                    function (t) { }), (/**
                     * @return {?}
                     */
                    function () { }), (/**
                     * @return {?}
                     */
                    function () {
                        o.next();
                        o.complete();
                    }));
                }));
            }
            else {
                return _this.loadInternall(x);
            }
        }));
        return Observable$1.create((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            forkJoin(loaders).subscribe((/**
             * @param {?} results
             * @return {?}
             */
            function (results) {
                observer.next(results);
            }));
        }));
    };
    /**
     * @private
     * @param {?} resource
     * @return {?}
     */
    NarikResourceLoaderService.prototype.loadInternall = /**
     * @private
     * @param {?} resource
     * @return {?}
     */
    function (resource) {
        var _this = this;
        return new Observable$1((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            /** @type {?} */
            var existingResources = _this.resources.find((/**
             * @param {?} s
             * @return {?}
             */
            function (s) { return s.src === resource.src; }));
            // Complete if already loaded
            if (existingResources && existingResources.loaded) {
                observer.next(existingResources);
                observer.complete();
            }
            else {
                // Add the script
                _this.resources = __spread(_this.resources, [resource]);
                if (resource.src.toLowerCase().endsWith(".js")) {
                    /** @type {?} */
                    var scriptElement = document.createElement("script");
                    scriptElement.type = "text/javascript";
                    scriptElement.src = _this.dynamicResourcesPath + resource.src;
                    scriptElement.onload = (/**
                     * @return {?}
                     */
                    function () {
                        resource.loaded = true;
                        observer.next(resource);
                        observer.complete();
                    });
                    scriptElement.onerror = (/**
                     * @param {?} error
                     * @return {?}
                     */
                    function (error) {
                        observer.error("Couldn't load script " + resource.src);
                    });
                    document.getElementsByTagName("body")[0].appendChild(scriptElement);
                }
                else {
                    /** @type {?} */
                    var cssElement = document.createElement("link");
                    cssElement.rel = "stylesheet";
                    cssElement.href = _this.dynamicResourcesPath + resource.src;
                    cssElement.onload = (/**
                     * @return {?}
                     */
                    function () {
                        resource.loaded = true;
                        observer.next(resource);
                        observer.complete();
                    });
                    cssElement.onerror = (/**
                     * @param {?} error
                     * @return {?}
                     */
                    function (error) {
                        observer.error("Couldn't load style " + resource.src);
                    });
                    document.getElementsByTagName("head")[0].appendChild(cssElement);
                }
            }
        }));
    };
    NarikResourceLoaderService.decorators = [
        { type: Injectable, args: [{
                    providedIn: "root"
                },] }
    ];
    /** @nocollapse */
    NarikResourceLoaderService.ctorParameters = function () { return [
        { type: ConfigService }
    ]; };
    /** @nocollapse */ NarikResourceLoaderService.ɵprov = ɵɵdefineInjectable({ factory: function NarikResourceLoaderService_Factory() { return new NarikResourceLoaderService(ɵɵinject(ConfigService)); }, token: NarikResourceLoaderService, providedIn: "root" });
    return NarikResourceLoaderService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikResourceLoaderService.prototype.resources;
    /**
     * @type {?}
     * @private
     */
    NarikResourceLoaderService.prototype.dynamicResourcesPath;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikTranslateLoader = /** @class */ (function () {
    function NarikTranslateLoader(http, configService, items) {
        if (items === void 0) { items = []; }
        this.http = http;
        this.configService = configService;
        this.items = items;
        this.root = "";
        this.slash = "/";
    }
    /**
     * @param {?} lang
     * @return {?}
     */
    NarikTranslateLoader.prototype.getTranslation = /**
     * @param {?} lang
     * @return {?}
     */
    function (lang) {
        var _this = this;
        if (this.root) {
            return this.getTranslationInternal(lang);
        }
        else {
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                _this.configService.configLoaded.pipe(first()).subscribe((/**
                 * @return {?}
                 */
                function () {
                    _this.root = _this.configService.getConfig("translationsPath");
                    _this.getTranslationInternal(lang).subscribe((/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) { return observer.next(x); }));
                }));
            }));
        }
    };
    /**
     * @private
     * @param {?} lang
     * @return {?}
     */
    NarikTranslateLoader.prototype.getTranslationInternal = /**
     * @private
     * @param {?} lang
     * @return {?}
     */
    function (lang) {
        var _this = this;
        if (this.items.length !== 0) {
            /** @type {?} */
            var loaders_1 = this.items.map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                return _this.http.get("" + _this.root + _this.slash + lang + _this.slash + x + ".json");
            }));
            return Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                forkJoin$1(loaders_1).subscribe((/**
                 * @param {?} trnslations
                 * @return {?}
                 */
                function (trnslations) {
                    /** @type {?} */
                    var result = {};
                    trnslations.map((/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) { return (result = Object.assign(result, x)); }));
                    observer.next(result);
                }));
            }));
        }
        else {
            return of$1({});
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    NarikTranslateLoader.prototype.addTranslationItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        this.items.push(item);
    };
    /**
     * @param {?} lang
     * @param {?} item
     * @return {?}
     */
    NarikTranslateLoader.prototype.getTranslateFilePath = /**
     * @param {?} lang
     * @param {?} item
     * @return {?}
     */
    function (lang, item) {
        return "" + this.root + this.slash + lang + this.slash + item + ".json";
    };
    return NarikTranslateLoader;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.root;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.slash;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.http;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.configService;
    /**
     * @type {?}
     * @private
     */
    NarikTranslateLoader.prototype.items;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikResourceBasedAuthorizationService = /** @class */ (function (_super) {
    __extends(NarikResourceBasedAuthorizationService, _super);
    /**
     *
     */
    function NarikResourceBasedAuthorizationService() {
        return _super.call(this) || this;
    }
    /**
     * @param {?} itemKey
     * @return {?}
     */
    NarikResourceBasedAuthorizationService.prototype.hasAccess = /**
     * @param {?} itemKey
     * @return {?}
     */
    function (itemKey) {
        /** @type {?} */
        var key = this.extractItemKey(itemKey);
        return of$1(false);
    };
    /**
     * @protected
     * @param {?} itemKey
     * @return {?}
     */
    NarikResourceBasedAuthorizationService.prototype.extractItemKey = /**
     * @protected
     * @param {?} itemKey
     * @return {?}
     */
    function (itemKey) {
        if (isString(itemKey)) {
            return [
                {
                    key: itemKey
                }
            ];
        }
        else if (isArray(itemKey)) {
            return itemKey;
        }
        return null;
    };
    NarikResourceBasedAuthorizationService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NarikResourceBasedAuthorizationService.ctorParameters = function () { return []; };
    return NarikResourceBasedAuthorizationService;
}(AuthorizationService));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function NarikCoreModuleConfig() { }
if (false) {
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.configFilePath;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.configOptions;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.errorHandleService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.dataProviderService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.dialogService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.dataStorageService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.moduleManagerService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.eventAggregatorService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.urlCreatorService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.authorizationService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.configService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.jsonService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.formTitleResolver;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.commandProcessor;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.validationService;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.componentTypeResolver;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.defaultLang;
    /** @type {?|undefined} */
    NarikCoreModuleConfig.prototype.useDefaultLang;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var NarikModule = /** @class */ (function () {
    function NarikModule(injector) {
        var _this = this;
        this.injector = injector;
        this.configService.configLoaded.pipe(first$1()).subscribe((/**
         * @return {?}
         */
        function () {
            _this.moduleRootPath = _this.configService.getConfig("modulesMetaDataRoot");
            if (!_this.moduleRootPath) {
                throw new Error("modulesMetaDataRoot is null");
            }
            _this.registerModule();
        }));
    }
    /**
     * @protected
     * @return {?}
     */
    NarikModule.prototype.registerModule = /**
     * @protected
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var moduleInfo = this.moduleInfo;
        if (moduleInfo) {
            moduleInfo.subscribe((/**
             * @param {?} info
             * @return {?}
             */
            function (info) {
                info.module = _this.moduleRef;
                _this.moduleManager.addOrUpdateModule(_this.key, info);
            }));
        }
    };
    /**
     * @protected
     * @return {?}
     */
    NarikModule.prototype.loadInfoFromJson = /**
     * @protected
     * @return {?}
     */
    function () {
        return this.jsonService
            .getJson(this.moduleRootPath + "/" + this.key.toLowerCase() + ".json")
            .pipe(map((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return (/** @type {?} */ (x)); })));
    };
    /**
     * @protected
     * @param {?} info
     * @return {?}
     */
    NarikModule.prototype.loadInfoFromData = /**
     * @protected
     * @param {?} info
     * @return {?}
     */
    function (info) {
        return of$1(info);
    };
    __decorate([
        NarikInject(ModuleManager),
        __metadata("design:type", ModuleManager)
    ], NarikModule.prototype, "moduleManager", void 0);
    __decorate([
        NarikInject(NgModuleRef),
        __metadata("design:type", NgModuleRef)
    ], NarikModule.prototype, "moduleRef", void 0);
    __decorate([
        NarikInject(NarikHttpService),
        __metadata("design:type", NarikHttpService)
    ], NarikModule.prototype, "httpService", void 0);
    __decorate([
        NarikInject(JsonService),
        __metadata("design:type", JsonService)
    ], NarikModule.prototype, "jsonService", void 0);
    __decorate([
        NarikInject(ConfigService),
        __metadata("design:type", ConfigService)
    ], NarikModule.prototype, "configService", void 0);
    return NarikModule;
}());
if (false) {
    /** @type {?} */
    NarikModule.prototype.key;
    /** @type {?} */
    NarikModule.prototype.moduleInfo;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.moduleManager;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.moduleRef;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.httpService;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.jsonService;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.configService;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.moduleRootPath;
    /**
     * @type {?}
     * @private
     */
    NarikModule.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NarikDialogContainer = /** @class */ (function () {
    function NarikDialogContainer() {
        this.isOpen = false;
        this.closeAnimationCompleted = new EventEmitter();
        this.actions = [];
    }
    Object.defineProperty(NarikDialogContainer.prototype, "contentContainerRef", {
        get: /**
         * @return {?}
         */
        function () {
            return this.loaderHost.viewContainerRef;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} item
     * @return {?}
     */
    NarikDialogContainer.prototype.actionClick = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        this.dialogRef.close({
            componentInstance: this.dialogRef.componentInstance,
            dialogResult: item.dialogResult
        }, "DIALOG");
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NarikDialogContainer.prototype._onAnimationDone = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (event.toState === "closed") {
            this.closeAnimationCompleted.emit(event);
        }
    };
    NarikDialogContainer.propDecorators = {
        loaderHost: [{ type: ViewChild, args: [ComponentLoaderHostDirective, { static: true },] }]
    };
    return NarikDialogContainer;
}());
if (false) {
    /** @type {?} */
    NarikDialogContainer.prototype.isOpen;
    /** @type {?} */
    NarikDialogContainer.prototype.closeAnimationCompleted;
    /** @type {?} */
    NarikDialogContainer.prototype.loaderHost;
    /** @type {?} */
    NarikDialogContainer.prototype.options;
    /** @type {?} */
    NarikDialogContainer.prototype.title;
    /** @type {?} */
    NarikDialogContainer.prototype.actions;
    /** @type {?} */
    NarikDialogContainer.prototype.dialogRef;
}
/** @type {?} */
var DialogAnimationBody = [
    state("closed", style({ opacity: 0, transform: "scale(0.7)" })),
    state("open", style({ transform: "none" })),
    transition("closed => open", animate("150ms cubic-bezier(0, 0, 0.2, 1)", style({ transform: "none", opacity: 1 }))),
    transition("open => closed", animate("75ms cubic-bezier(0.4, 0.0, 0.2, 1)", style({ opacity: 0 })))
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} cls
 * @param {?} template
 * @return {?}
 */
function applyBaseTemplate(cls, template) {
    var e_1, _a;
    template =
        typeof template === "string" ? template : ((/** @type {?} */ (template))).default;
    /** @type {?} */
    var annotations = cls["__annotations__"];
    if (annotations) {
        try {
            for (var annotations_1 = __values(annotations), annotations_1_1 = annotations_1.next(); !annotations_1_1.done; annotations_1_1 = annotations_1.next()) {
                var annotation = annotations_1_1.value;
                if (annotation && annotation.hasOwnProperty("template")) {
                    /** @type {?} */
                    var parser = new DOMParser();
                    /** @type {?} */
                    var parentDoc = parser.parseFromString(template, "text/html");
                    /** @type {?} */
                    var childDoc = parser.parseFromString(annotation.template, "text/html");
                    /** @type {?} */
                    var sectionItems = parentDoc.querySelectorAll("[narik-section]");
                    for (var index = 0; index < sectionItems.length; index++) {
                        /** @type {?} */
                        var element = sectionItems[index];
                        /** @type {?} */
                        var sectionName = element.attributes["narik-section"].value;
                        /** @type {?} */
                        var contentItem = childDoc.querySelector("[\\#" + sectionName + "]");
                        if (contentItem &&
                            contentItem.tagName.toLowerCase() === "ng-template") {
                            template = template.replace("narik-section=\"" + sectionName + "\"", "*ngIf=\"false; else " + sectionName + "\"");
                        }
                    }
                    annotation.template = template + annotation.template;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (annotations_1_1 && !annotations_1_1.done && (_a = annotations_1.return)) _a.call(annotations_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    return cls;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} templateKey
 * @return {?}
 */
function NarikBaseTemplate(templateKey) {
    /** @type {?} */
    var typeDecorator = (/** @type {?} */ (((
    // tslint:disable-next-line:no-shadowed-variable
    /**
     * @param {?} cls
     * @return {?}
     */
    function TypeDecorator(cls) {
        return applyBaseTemplate(cls, templateKey);
    }))));
    return typeDecorator;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ApiUrlCreator, AppInjector, DialogActions, DialogAnimationBody, HttpErrorInterceptor, LOCAL_STORAGE_VALIDITY_LEN, LocalStorageDataProvider, MEMORY_STORAGE_VALIDITY_LEN, MemoryDataProvider, NarikBaseDataProvider, NarikBaseDataStorage, NarikBaseNavigationProvider, NarikBaseTemplate, NarikComponentTypeResolver, NarikCoreModule, NarikDataProviderService, NarikDialogContainer, NarikDialogNavigationProvider, NarikDialogRef, NarikDialogService, NarikErrorHandleService, NarikGlobalInject, NarikHttpService, NarikInject, NarikModule, NarikModuleManager, NarikRemoteDataProviderService, NarikResourceBasedAuthorizationService, NarikResourceLoaderService, NarikRoleBasedAuthorizationService, NarikRouteNavigationProvider, NarikShortcutService, NarikTranslateLoader, NarikTranslateService, NarikUrlCreatorService, NarikValidationService, ODataUrlCreator, RemoteDataProvider, SESSION_STORAGE_VALIDITY_LEN, StaticDataProvider, applyBaseTemplate, initConfig, COMPONENTS as ɵa, EXPORT_COMPONENTS as ɵb, SessionStorageDataProvider as ɵc, NarikDataStorageService as ɵd, NarikEventAggregatorService as ɵe, NarikConfigService as ɵf, NarikJsonService as ɵg, NarikFormTitleResolver as ɵh, NarikEmptyCommandProcessor as ɵi, NarikNavigationService as ɵj };
//# sourceMappingURL=narik-core.js.map
