import { DataInfo, DataProvider } from "narik-infrastructure";
import { Injector } from "@angular/core";
import { Subject } from "rxjs/internal/Subject";
import { Observable } from "rxjs/internal/Observable";
export declare abstract class NarikBaseDataProvider implements DataProvider {
    private injector;
    key: string;
    order: number;
    belongsInChain: boolean;
    dayaKeyTemplate: string;
    protected dataStreams: Map<string, Subject<any>>;
    abstract getData(dataInfo: any): Observable<any>;
    abstract isDataProviderFor(dataInfo: DataInfo): boolean;
    constructor(injector: Injector);
    protected getFullKey(dataInfo: DataInfo): string;
    getDataStream(dataInfo: DataInfo): Observable<any>;
    getDataStream<T>(dataInfo: DataInfo): Observable<T>;
    raiseDataStream(dataInfo: DataInfo, data: any): void;
    dataChanged(dataInfo: DataInfo | DataInfo[]): void;
}
