import { Observable } from "rxjs/internal/Observable";
import { NarikBaseDataProvider } from "./narik-base-data-provider";
import { DataStorage, DataInfo } from "narik-infrastructure";
export declare abstract class NarikBaseDataStorage extends NarikBaseDataProvider implements DataStorage {
    validityLen: number;
    abstract clear(): Observable<any>;
    abstract getStorageModel<T>(dataInfo: DataInfo): Observable<StorageModel>;
    abstract removeItems(items: DataInfo[]): Observable<any>;
    abstract addItem(dataItmes: {
        dataInfo: DataInfo;
        data: any;
    }[]): Observable<any>;
    compeleteStorageData(data: any, validityLen?: number): StorageModel;
    getData(dataInfo: DataInfo): Observable<any>;
    getData<T>(dataInfo: DataInfo): Observable<T>;
    checkAndReturn<T>(storageData: StorageModel): T;
    applyValidity(dataItems: {
        dataInfo: DataInfo;
        validDate: Date;
    }[]): void;
}
export interface StorageModel {
    validityLen?: number;
    dataTime?: Date;
    data: any;
}
