import { DataStorageService, DataInfo, DataStorage, EventAggregatorService, ModuleManager, RemoteMessagingService } from "narik-infrastructure";
import { Observable } from "rxjs/internal/Observable";
export declare class NarikDataStorageService extends DataStorageService {
    private defaultStorageKey;
    private moduleManager;
    private eventAggregatorService;
    private remoteMessagingService;
    private dataStorages;
    constructor(storages: DataStorage[], defaultStorageKey: string, moduleManager: ModuleManager, eventAggregatorService: EventAggregatorService, remoteMessagingService: RemoteMessagingService);
    getDataStream(key: string, dataInfo: DataInfo): Observable<any>;
    getDataStream<T>(key: string, dataInfo: DataInfo): Observable<T>;
    getData(key: string, dataInfo: DataInfo): Observable<any>;
    getData<T>(key: string, dataInfo: DataInfo): Observable<T>;
    clear(key: string): Observable<any>;
    removeItems(key: string, items: DataInfo[]): Observable<any>;
    addData(key: string, dataItmes: {
        dataInfo: DataInfo;
        data: any;
    }[]): Observable<any>;
    private getStorage;
    applyValidity(dataItems: {
        dataInfo: DataInfo;
        validDate: Date;
    }[]): void;
    private checkKey;
}
