import { EntityField, DialogInputContent, ModuleManager } from "narik-infrastructure";
import { DialogService, MessageType, DialogOption, DialogResult, DialogRef, DialogAction, DialogContainer, EventAggregatorService, DialogOverlayContainer, DialogEvent, FieldTypes } from "narik-infrastructure";
import { Type, TemplateRef, ComponentFactoryResolver, ApplicationRef, ComponentRef, Injector, NgModuleRef, ElementRef, StaticProvider, RendererFactory2 } from "@angular/core";
import { ReplaySubject } from "rxjs/internal/ReplaySubject";
export declare class NarikDialogService extends DialogService {
    private injector;
    private dialogOverlayContainerType;
    private applicationRef;
    private componentFactoryResolver;
    private eventAggregatorService;
    private moduleManager;
    private document;
    private openDialogs;
    private injectors;
    nextUniqueId: number;
    private toastrService;
    private translateService;
    messageComponent: Type<any>;
    inputComponent: Type<DialogInputContent>;
    contentComponent: Type<any>;
    dialogContainerType: Type<DialogContainer>;
    rendererFactory: RendererFactory2;
    constructor(injector: Injector, dialogOverlayContainerType: Type<DialogOverlayContainer>, applicationRef: ApplicationRef, componentFactoryResolver: ComponentFactoryResolver, eventAggregatorService: EventAggregatorService, moduleManager: ModuleManager, moduleRef: NgModuleRef<any>, document: any);
    private registerModule;
    activeDialogId(): string;
    isElementInActiveDialog(el: ElementRef): boolean;
    error(message: string | string[] | any, title?: string, options?: any): void;
    showMessage(message: string | string[], title?: string, type?: MessageType, options?: any): void;
    showDialog<T>(content: Type<any> | TemplateRef<any>, title?: string, data?: any, actions?: DialogAction[], options?: DialogOption, validateOnClose?: (dialogresult: DialogResult<T>) => boolean | Promise<boolean>, onClose?: (dialogresult: DialogResult<T>) => void, providers?: StaticProvider[]): DialogRef<T>;
    showConfirm(message: string, title?: string, actions?: DialogAction[], onResult?: (dialogresult: DialogResult<any>) => void): DialogRef<any>;
    showMessageBox(message: string, title?: string): DialogRef<any>;
    showInput(message: string, title?: string, fields?: EntityField[], entity?: any, onResult?: (dialogresult: DialogResult<DialogInputContent>) => void, actions?: DialogAction[], options?: DialogOption): DialogRef<any>;
    showTextInput(message: string, title?: string, placeHolder?: string, fieldType?: FieldTypes, defaultValue?: any, onResult?: (dialogresult: DialogResult<DialogInputContent>) => void, actions?: DialogAction[], options?: DialogOption): DialogRef<any>;
    showContent(content: string, title?: string): DialogRef<any>;
    closeAll(force?: boolean): void;
    close(dialog: DialogRef<any> | string, dialogResult?: DialogResult<any>, eventSource?: "DIALOG" | "CONTENT"): void;
    private doClose;
    private createDialogContainer;
    createOverlay(options: DialogOption): ComponentRef<DialogOverlayContainer>;
}
export declare class NarikDialogRef<T> implements DialogRef<T> {
    _closed: Promise<DialogResult<T>>;
    dialogResultTransformer: (result: DialogResult<T>) => DialogResult<T>;
    eventSubject: ReplaySubject<DialogEvent>;
    id: string;
    componentInstance: T;
    container: DialogContainer;
    dialogOverlayContainerRef: ComponentRef<any>;
    readonly closed: Promise<DialogResult<T>>;
    element: ElementRef<any>;
    readonly events: ReplaySubject<DialogEvent>;
    constructor(id: string, componentInstance: T);
    close(dialogResult?: DialogResult<any>, eventSource?: "DIALOG" | "CONTENT"): void;
}
export declare class DialogActions {
    static ok: DialogAction;
    static cancel: DialogAction;
    static yes: DialogAction;
    static no: DialogAction;
    static ok_cancel: DialogAction[];
    static yes_no: DialogAction[];
}
