import { EventAggregatorService, ModuleInfo, ModuleEventArg, ModuleManager, ConfigService } from "narik-infrastructure";
import { Subject } from "rxjs/internal/Subject";
import { Injector } from "@angular/core";
import { NarikHttpService } from "./narik-http.service";
import { NarikTranslateService } from "./narik-translation.service";
import { Observable } from "rxjs/internal/Observable";
export declare class NarikModuleManager extends ModuleManager {
    private injector;
    private httpService;
    private configService;
    private translateService;
    readonly modules: Map<string, ModuleInfo>;
    readonly modulesChanged: Observable<ModuleEventArg>;
    readonly modulesChangedSubject: Subject<ModuleEventArg>;
    private narikLoadedSubject;
    readonly narikLoaded: Observable<any>;
    eventAggregatorService: EventAggregatorService;
    constructor(injector: Injector, httpService: NarikHttpService, configService: ConfigService, translateService: NarikTranslateService);
    private fixModuleInformation;
    addOrUpdateModule(key: string, moduleInfo?: ModuleInfo): void;
    removeModule(key: string): void;
    init(): Promise<any>;
}
