import { DataInfo, ModuleManager, RemoteDataProviderService, ModuleDataInfo, MetaDataService } from "narik-infrastructure";
import { Observable } from "rxjs/internal/Observable";
import { Subject } from "rxjs/internal/Subject";
import { Injector } from "@angular/core";
import { NarikHttpService } from "./narik-http.service";
export declare class NarikRemoteDataProviderService extends RemoteDataProviderService {
    private httpService;
    private injector;
    private moduleManager;
    private metaDataService;
    key: string;
    order: number;
    dayaKeyTemplate: string;
    protected dataStreams: Map<string, Subject<any>>;
    private modulesDataInformations;
    constructor(httpService: NarikHttpService, injector: Injector, moduleManager: ModuleManager, metaDataService: MetaDataService);
    protected addRemoteDataInfo(moduleKey: string, dataInfo: ModuleDataInfo): void;
    isDataProviderFor(dataInfo: DataInfo): boolean;
    getData(dataInfo: DataInfo): Observable<any>;
    getData<T>(dataInfo: DataInfo): Observable<T>;
    getDataStream(dataInfo: DataInfo): Observable<any>;
    getDataStream<T>(dataInfo: DataInfo): Observable<T>;
    protected getFullKey(dataInfo: DataInfo): string;
}
